        PROGRAM DBTDEQC
C
C**** *DBTPROC*
C
C
C     PURPOSE.
C     --------
C         CONTROLLING ROUTINE FOR DECODING
C         BATHY,DRIBU AND TESAC DATA.
C
C
C**   INTERFACE.
C     ----------
C
C         NONE.
C
C     METHOD.
C     -------
C
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C        *CALL* *INITVAR( IERR )*
C        *CALL* *READIN ( IERR )*
C        *CALL* *PROCRFB( IERR )*
C        *CALL* *PROCHDR( IERR )*
C        *CALL* *PROCTXT( IERR )*
C        *CALL* *PROCT1S( IERR )*
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
c		R. CINTRA    *CPTEC*
C          ultima alteracao  em 18/01/1999 
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comrec.h'
      INCLUDE 'comstat.h'
c
      common /reperr/ numreperr
      common /recwriten/ irecswriten
      common /repetida/ irepetida
      common /inil/ inil
c
c
      character*4 cstop
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE VARIABLES AND CONSTANTS.
C                ----------------------------------
 100  CONTINUE
C
C     DRIFTER STREAM NUMBER 4
C
      CALL INITVAR( IERR )

C     ----------------------------------------------------------------
      OPEN(UNIT=99,FILE='buoy.rdb',FORM='FORMATTED',
     1     STATUS='UNKNOWN',ACCESS='SEQUENTIAL')
C     ----------------------------------------------------------------
c
C           1.1  INITIALIZE MDB ACCESS.
C                ----------------------
 110  CONTINUE
C

C     ------------------------------------------------------------------
C*          2.   READ IN BULLETIN.
C                -----------------
c
      numbullerr = 0
      numreperr = 0
      irecswriten = 0
c
 200  CONTINUE
c
      ierr = 0
      CALL READIN(IERR)
      IF(IERR.NE.0 .OR. IEOF.EQ.1) GO TO 1000
      
C     ------------------------------------------------------------------
C*          3.   FORMAT BULLETIN.
C                ----------------
 300  CONTINUE
C
      CALL PROCRFB( IERR )
      if(ierr.ne.0) numbullerr = numbullerr + 1
      IF(IERR.NE.0) GO TO 200
C     ------------------------------------------------------------------
C*          4.   DECODE BULLETIN HEADER.
C                -----------------------
 400  CONTINUE
C
      CALL PROCHDR( IERR )
      if(ierr.ne.0) numbullerr = numbullerr + 1
      IF(KERR.NE.0) GO TO 200
C     ------------------------------------------------------------------
C*          5.   CHECK TEXT OF BULLETIN.
C                -----------------------
 500  CONTINUE
C
      CALL PROCTXT( IERR )
      if(ierr.ne.0) numbullerr = numbullerr + 1
      IF(KERR.NE.0) GO TO 200
C
C     ------------------------------------------------------------------
C*          6.   CALL APPROPRIATE ROUTINE TO DECODE SATTELITE DATA.
C                ---------------------------------------------------
 600  CONTINUE
C
      CALL PROCT1S( IERR )
C
C
      GO TO 200
C
C     ------------------------------------------------------------------
C
c 1001 continue
c
c      print*,' Open error on OCEA.stop.dat'
c      go to 1000
c
c 1002 continue
c
c      print*,' Read error on OCEA.stop.dat'

 1000 CONTINUE
C
      close(unit=99)

c----|-----------------------------------------------------------------|-------|
C		Criar uma estatistica do processamento das  
c               mensagens Serao incluida no arquivo cabecalho.dat.
c               
c             ________________________________________________
c             | VARIAVEL   |        DESCRICAO                |
C             |============|=================================|
c	      |	numbull    |   Numero de boletins lidos,     |
C             |------------|---------------------------------|
c             | numbullerr |   Numero de boletins com erro,  |
C             |------------|---------------------------------|
c             | numreport  |   Numero de mensagens lidas,    |
C             |------------|---------------------------------|
c	      |	numreperr  |   Numero de mensagens com erro, |
C             |------------|---------------------------------|
c    	      |	irecswriten|   Numero de mensagens gravadas, |
C             |------------|---------------------------------|
c	      |	irepetida  |   Numero de mensagens repetidas |
C             |------------|---------------------------------|
c             | inil       |   Numero de mensagens ignoradas |
c             |______________________________________________|
c               
c------------------------------------------------------------------------------

      numreport = 0
c
      do 15 i=1,26
         numreport = numreport + numrep(i)
 15   continue
c
      Open(91,file='mesg_err.dat',status='old',access='append')
c
c------------------------------------------------------------------------------

      write(91,20)
      write(91,10)numbull,numbullerr,numreport,numreperr,
     c irecswriten,irepetida/2,inil
 10   format('| BUOY      |','     ',I5,'     |',
     c       '     ',I5,'    ||',I5,'     |'
     c       ,I5,'     |',I5,'     |',
     c       I5,'     |',I5,'     |')
      write(91,20)
 20   format('|-----------|---------------|------------',
     c        '--||----------|----------|----------|---',
     c        '-------|----------|')
c

      close(91)
c
      stop
      END
      
      SUBROUTINE READIN( IERR )
C
C**** *READIN*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO READ IN ONE BULLETIN AT A TIME.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *READIN( IERR )*
c
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
c		R. CINTRA    *CPTEC*
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
 
      CHARACTER*16384 YCHAR
      Character*16384 buff_aux
      Character*4 four_chars
      Character*4 endmsg
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comstat.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
C
      DATA NSKIP/0/
c     Data aux/'03010D0D'Z/       ! ^C^A^M^M (separador de mensagens)
      Data aux/'0D0D0103'Z/       ! ^C^A^M^M (separador de mensagens)
C
C     ------------------------------------------------------------------
C*          1.   RESET ERROR INDICATOR, WORD AND BIT POINTERS.
C                ---------------------------------------------
 100  CONTINUE
C
      IERR= 0
      NWPT= 1
      NBPT= 0
      NSUB= 0
C
C*          1.1  READ IN BULLETIN AND INCERMENT BULLETIN COUNTER.
C                ------------------------------------------------
C
      IERR=0
C
      OPEN(UNIT=3,IOSTAT=IOS,ERR=400,
     1     FILE='buoy.dat',
     1     STATUS='OLD')
 
C
      Write(endmsg,10) aux     ! ^C^A^M^M (separador de mensagens)
 10   Format(a4)
 110  CONTINUE
      index = 1
      ilen = 1
      four_chars = char(0) // char(0) // char(0) // char(0)
c     
      Do While(four_chars .ne. endmsg)
      READ (3,'(Q,A)',ERR=200,END=300,IOSTAT=IOS) ILEN,YCHAR
      buff_aux(index:index+ilen-1) = ychar(1:ilen)
c     ------------------------------------------------------------------
c      Alteracao (Gamb) para cobrir problema do fortran v3.8. 
c       Na leitura do arquivo stream_LF,tem como final de registro um LF e CR,
c       sendo que este ultimo faz parte da mensagem, e por isso foi novamente 
c       acrescentado. 
c
c            A T E N C A O - checar as novas versoes do fortran/OSF.
c
c                    Rosangela.  04.07.96
c     ------------------------------------------------------------------
      index = index + ilen
      ilen = ilen + 1
      buff_aux(index:index) = char(13)  ! O CR nao vem na leitura
      ychar(ilen:ilen) = char(13)
      four_chars = ychar(ilen-3:ilen)
c
      end do
c
      ilen = index - 1
      ychar(1:ilen) = buff_aux(1:ilen)
c
C
      if(ilen.gt.4) NUMBULL=NUMBULL + 1
C
C*          1.2  PRINT BULLETIN NUMBER.
C                ----------------------
 120  CONTINUE
C
C      WRITE(*,9902) NUMBULL
C
C*          1.3  SKIP BULLETIN IF NECESSARY.
C                ---------------------------
 130  CONTINUE
C
      IF(NUMBULL.LE.NSKIP) GO TO 100
C
C*          1.4  TRANSFER BULLETIN TO 'KCHAR', ONE CHARACTER PER WORD
C                -----------------------------------------------------
C                AND SUPPRESS PARITY BIT.
C                ------------------------
 140  CONTINUE
C
      DO 141 I=1,ILEN
C
      KCHAR(I)=ICHAR(YCHAR(I:I)).AND.127
C
 141  CONTINUE
C
      RETURN
C     -----------------------------------------------------------------
 200  CONTINUE
C
      IERR=1
      WRITE(*,9901) IOS
      PRINT*,'READIN: ILEN=',ILEN
      RETURN
C     -----------------------------------------------------------------
 300  CONTINUE
C
      IEOF=1
      PRINT*,'READIN: END OF FILE IEOF=',IEOF
      RETURN
C     -----------------------------------------------------------------
 400  CONTINUE
C
      IERR=1
      WRITE(*,9903) IOS
      RETURN
C     ----------------------------------------------------------------
 9901 FORMAT(1H0,'+ + + ERROR IN READING BULLETIN FILE. IOSTAT=',
     C I6,' DECIMAL')
 9902 FORMAT(1H ,'BULLETIN NUMBER IS ',I6)
 9903 FORMAT(1H0,'+ + + ERROR IN OPENING UNIT 3. IOSTAT=',
     C I6,' DECIMAL')
C     ----------------------------------------------------------------
      END
      
      SUBROUTINE PROCRFB ( IERR )
C**** *PROCRFB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO FORMAT BULLETIN.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCRFB(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C          J. HENNESSY         *ECMWF*
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C     ------------------------------------------------------------------
C*          1.   KEEP SOURCE OF DATA AND DATE/TIME OF ARRIVAL.
C                ---------------------------------------------
 100  CONTINUE
C
      DO 101 I=1,3
C
      KHEAD(I)=MINDIC      ! THIS WILL BE CHANGED ACCORDING TO THE KEY.
C
 101  CONTINUE
C     ------------------------------------------------------------------
C*          2.  DEFINE T1 AND T2 FROM ABBREVIATED HEADING.
C               ------------------------------------------
 200  CONTINUE

      DO 202 I=1,ILEN
C
      IF(KCHAR(I).GE.65.AND.KCHAR(I).LE.90) GO TO 203
C
 202  CONTINUE
C
      IT1=27
      GO TO 210
C
 203  CONTINUE
C
      IT1=KCHAR(I  )-64
      IT2=KCHAR(I+1)-64
C
      IF(IT1.NE.19) THEN
                       IERR=1
                       IT1=27
                       RETURN
                    END IF
C
C     CHECK IF 'T2' CHARACTER IS LETTER.
C
      IF(IT2.LT.0.OR.IT2.GT.26) IT1=27
C
C*          2.1  LAST CHARACTER OF BULLETIN CAN BE IN ANY OF THE LAST
C                -----------------------------------------------------
C                5 WORDS. IF CHARACTER  IS 'ETX' REPLACE BY 'GS' .
C                -------------------------------------------------
C                IF NEITHER CAN BE FOUND INSERT 'GS' AS LAST CHARACTER.
C                ------------------------------------------------------
 210  CONTINUE
C
      IST=ILEN-5
C
      DO 211 I=1,ILEN
C
      IF (KCHAR(I).EQ.3.OR.KCHAR(I).EQ.29) THEN
                                              KCHAR(I)= 29
                                              IGS=I
                                              RETURN
                                           END IF
C
 211  CONTINUE
C
      I=I-1
      KCHAR(I)= 29
      IGS=I
C
      RETURN
      END
      
      SUBROUTINE PROCTXT ( IERR )
C
C**** *PROCTXT*
C
C
C     PURPOSE.
C     --------
C          CHECKS WHETHER BULLETIN CONTAINS USEFUL DATA .
C          THE FOLLOWING BULLETINS ARE CONSIDERED TO CONTAIN
C          NO USEFUL DATA.
C                 1. TEXT OF 'NIL' , OR VARIANTS OF THIS.
C                 2. TEXT OF 'NO DATA AVAILABLE'.
C                 3. TEXT OF 'NO REPORTS AVAILABLE'.
C                      1. - 3.  ARE DETERMINED SIMPLY BY CHECKING
C                      THE LENGTH OF THE TEXT . IF IT IS LESS
C                      THAN 26 THERE CANT BE ANY USEFUL DATA IN IT
C                 4. UK AND GERMAN DOMESTIC BULLETINS WHICH DO
C                    NOT CONFORM TO WMO CODES.
C
C          INPUT     : BULLETIN IN ARRAY 'KCHAR' ,
C                      ONE CHARACTER PER WORD.
C
C          OUTPUT    : KERR = 0 INDICATES BULLETIN CONTENTS REQUIRED.
C                           = 1 MEANS TEXT OF 'NIL' ETC.
C                           = 2 UK OR GERMAN DOMESTIC BULLETIN.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCTXT(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTLET(I,J)*
C         *CALL* *PRTBULL(I,J)*
C         *CALL* *SAVBULL(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C          J. HENNESSY         *ECMWF*
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'combuff.h'
C
C     ------------------------------------------------------------------
C
C*          1.   CLEAR ERROR INDICATOR.
C                ----------------------
 100  CONTINUE
C
      KERR= 0
C
C
C*          1.1  CHECK IF BULLETIN IS TOO SHORT I.E. "NIL" BULLETIN.
C                ---------------------------------------------------
 110  CONTINUE
C
      ILE = IGS - IMI
      IF(ILE .LT. 26) THEN
                         KERR = 7
                         NUMBERR(7) = NUMBERR(7) + 1
                                KCHAR(IGS)=KCHAR(IGS).OR.128
C                               GO TO 900
                      END IF
C
C
C*          1.2  CHECK IF THE BULLETIN IS DOMESTIC FROM UK OR GERMANY.
C                -----------------------------------------------------
C                THIS IS DONE BY CHECKING IF THE BULLETIN HAS
C                --------------------------------------------
C                CCCC OF (EG--,ED--) OTHER THAN (EGRR,EDZW).
C                -------------------------------------------
 120  CONTINUE
C
      IPT=IAH+4
      CALL NEXTLET(IPT,JAH)
C
C     IF BULLETINS HAVE 'CCCC' NOT 'ED--' OR 'EG--' , RETURN.
C
      IF ( KCHAR(IPT).NE.69 ) RETURN
      IF ( KCHAR(IPT+1).NE.71.AND.KCHAR(IPT+1).NE.68 ) RETURN
C
C        FIRST UK
C
             IF (KCHAR(IPT+1).EQ.71)
     C                      THEN
                                 IF(KCHAR(IPT+2) .NE. 82 .OR.
     1                              KCHAR(IPT+3) .NE. 82)
     2                                   KERR = 8
                            ELSE
C
C        THEN GERMANY
C
                                 IF(KCHAR(IPT+2) .NE. 90 .OR.
     1                              KCHAR(IPT+3) .NE. 87)
     2                                   KERR = 8
                            END IF
C
C     MARK CCCC GROUP IF REQUIRED.
C
      IF ( KERR.EQ.8 ) THEN
                              KCHAR(IPT+4) = KCHAR(IPT+4).OR.128
                              NUMBERR(8) = NUMBERR(8) + 1
                          END IF
C
C           1.3 TREAT IN ACCORDANCE WITH DEFINED OPTIONS.
C               -----------------------------------------
 130  CONTINUE
C
C     RETURN IF NO ERROR.
C
      IF ( KERR.EQ.0 ) RETURN
C
C
 900  CONTINUE
C
      N = KERR - 1
      N1 =JISHFT(IOPTS(677),-N).AND.1
      N2 =JISHFT(IOPTS(678),-N).AND.1
C
C           1.4  PRINT BULLETIN IF REQUIRED.
C                ---------------------------
 140  CONTINUE
C
      IF (N1.EQ.1) THEN
                       WRITE (*,9900) KERR
                       CALL PRTBULL (1,IGS)
                   END IF
C
C           1.5 WRITE TO ERROR FILE IF REQUIRED.
C               --------------------------------
 150  CONTINUE
C
      IF ( N2.EQ.1 ) CALL SAVBULL(IERR)
      RETURN
C     -----------------------------------------------------------------
 9900 FORMAT (1H ,'BULLETIN ERROR NUMBER ',I2.2)
C     -----------------------------------------------------------------
      END 
      
      SUBROUTINE PROCHDR ( IERR )
C
C**** *PROCHDR
C
C
C     PURPOSE.
C     --------
C         DEODE BULLETIN HEADER AND INSERT REQUIRED PARAMETERS
C         IN DECODED REPORT HEADER.
C
C         LOCATES BEGINNING  AND END OF ABBREVIATED HEADER AND
C         'MIMIMJMJ' LINES.
C
C         INPUT     : BULLETIN IN KCHAR(1) - KCHAR(IGS)
C
C                     BULLETIN RECORD HEADER IN KINT(1) - KINT(5)
C
C                     'IT1' = 27 INDICATING BULLETIN HAS NOT BEEN
C                            IDENTIFIED FROM 'TT' OF ABBREVIATED HEADER.
C
C         OUTPUT    : KDEC(10) = DAY OF MONTH ( INTEGER ) . YY
C                     KDEC(11) = TIME OF BULLETIN - HOURS ( INTEGER ) . G
C                     KDEC(12) = TIME OF BULLETIN - MINS ( INTEGER ) . GG
C
C                     KDEC(14) = 0 IF ORIGIN OF REPORT IS FGGE.
C                                1  "   "     "    "    " BRACKNELL.
C                                2  "   "     "    "    " OFFENBACH.
C
C                     KDEC(20) =1 NIL
C                     KDEC(21) =1 IF BULLETIN IS 'COR' , OTHERWISE
C                                    = 0 .
C
C                     KDEC(21) = 1 IF BULLERIN IS 'CCA'
C                     KDEC(21) = 2 IF BULLERIN IS 'CCB'
C                     KDEC(21) = 3 IF BULLERIN IS 'CCC'
C                     KDEC(21) = 4 IF BULLERIN IS 'CCD'
C                     .
C                     .
C
C                     KDEC(18) = DATE OF BULLETIN ARRIVAL ( ON VAX )
C                     KDEC(19) = TIME  "    "        "      "     "
C
C                     IAH =    "      " BEGINNING OF 'ABBREVIATED HEADER'
C                     JAH =    "      "     END   "       "         "
C
C                     IMI =    "      " BEGINNING OF 'MIMIMJMJ' LINE.
C                     JMI =    "      "     END   "       "       "
C
C                     KERR = 0 IF NO ERROR FATAL TO DECODING ENCOUNTERED.
C                         = 1 IF BULLETIN HAS LESS THAN 3 LINES.
C                         = 2 IF BULLETIN IS NOT RECOGNISED.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCHDR( IERR )*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C         *CALL* *NEXTEND(I,J)*
C         *CALL* *NEXTFIG(I,J)*
C         *CALL* *EXTGRP (I,N1,N2,N3,N4,N5,N,IRET)*
C         *CALL* *NEXTLET(I,J)*
C         *CALL* *SAVBULL(IERR )*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C          J. HENNESSY         *ECMWF*
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
      DIMENSION ILST(26)
      DATA ILST/65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
     1          81,82,83,84,85,86,87,88,89,90/
C     ------------------------------------------------------------------
C
C*          1.   CLEAR ERROR INDICATOR AND SET REPORT HEADER AREA
C                ------------------------------------------------
C                TO MISSING DATA INDICATOR.
C                --------------------------
 100  CONTINUE
C
      KERR=0
C
      DO 101 I=1,24
C
      KDEC(I)= MINDIC
C
 101  CONTINUE
C
C*          1.1  FLAG FIELDS SET TO ZERO.
C                ------------------------
 110  CONTINUE
C
      KDEC(13)=0
      KDEC(15)=0
      KDEC(21)=0
C
C*          2.  LOCATE BEGINNING AND END OF 'STARTING LINE' ,
C               ---------------------------------------------
C               'ABBREVIATED HEADER' AND 'MIMIMJMJ LINE ' .
C               -------------------------------------------
C
      ISL = 1
      CALL NEXTPRT ( ISL,IGS )
      JSL = ISL
      CALL NEXTEND ( JSL,IGS )
      IAH = JSL
      CALL NEXTPRT ( IAH,IGS ) 
      JAH =IAH
      CALL NEXTEND ( JAH,IGS )
      IMI = JAH
      CALL NEXTPRT ( IMI,IGS )
      JMI = IMI
      CALL NEXTEND ( JMI,IGS )
C
C*          2.1 IF THESE 3 LINES CANNOT BE LOCATED , BULLETIN CONSISTS
C               ------------------------------------------------------
C               OF LESS THAN 3 LINES.
C               ---------------------
 210  CONTINUE
C
      IF ( JMI.GT.IGS ) THEN
C
C                           SET ERROR NUMBER AND MARK ERROR.
C
                            KERR = 1
                            KCHAR(IGS)=KCHAR(IGS).OR.128
                            NUMBERR(1) = NUMBERR(1) + 1
                            GO TO 300
                        END IF
C
C
C
C*          2.2  BULLETIN CANNOT BE IDENTIFIED FROM 'TT' .
C                -----------------------------------------
 220  CONTINUE
C
      IF ( IT1.EQ.27 ) THEN
C
C                          SET ERROR NUMBER AND MARK ERROR.
C
                           KERR = 2
                           KCHAR(IAH+2)=KCHAR(IAH+2).OR.128
                           NUMBERR(2) = NUMBERR(2) + 1
                           GO TO 300
                       END IF
C
C
C*          2.3  NO CHECKS ARE MADE ON TTAAII OR CCCC GROUPS.
C                --------------------------------------------
 230  CONTINUE
C
C
C
C*          2.4  LOCATE AND DECODE 'YYGGGG' GROUP .
C                ----------------------------------
 240  CONTINUE
C
C     SCAN 'KCHAR' FOR FIRST FIGURE AFTER 'II' FIGURES.
C
      IPT = IAH + 6
      CALL NEXTFIG ( IPT,JAH )
      IF ( IPT.GE.JAH ) THEN
                          KERR = 5
                        ELSE
C
C                         EXTRACT YY,GG AND GG AND CONVERT TO INTEGERS
C                         IN WORDS 10-12 OF 'KINT' .
C
                          CALL EXTGRP( IPT,2,2,2,0,0,10,IRET )
                          IPT = IABS(IPT)
C
C                         TEST VALIDITY OF YY,GG AND GG.
C                         THIS TEST MAKES CHECKING RETURN CODE 'IRET'
C                         UNNECESSARY.
C
                          IF ( KINT(10).LT.1.OR.KINT(10).GT.31 )
     C                             THEN
                                        KERR = 5
                                        KINT(10) = MINDIC
                                   END IF
C
                          IF ( KINT(11).LT.0.OR.KINT(11).GT.23 )
     C                             THEN
                                        KERR = 5
                                        KINT(11) = MINDIC
                                   END IF
C
                          IF ( KINT(12).LT.0.OR.KINT(12).GT.59 )
     C                             THEN
                                        KERR = 5
                                        KINT(11) = MINDIC
                                   END IF
C
C
C                                  COPY TO DECODED REPORT HEADER AREA
C                                  AND RESET WORDS IN 'KINT'.
C
                                   DO 241 I=10,12
                                          KDEC(I) = KINT(I)
                                          KINT(I) = MINDIC
  241                              CONTINUE
C
                        END IF
C
C     MARK ERROR IN YYGGGG GROUP.
C
      IF ( KERR.EQ.5 ) THEN
                              KCHAR(IPT)=KCHAR(IPT).OR.128
                              NUMBERR(5) = NUMBERR(5) + 1
                          END IF
C
C
C
C
C*          2.5 THE ONLY CHECK ON 'BBB' IS FOR 'COR'.
C               -------------------------------------
 250  CONTINUE
C
C     FIND NEXT LETTER IN ABBREVIATED HEADER LINE AND CHECK IF 'C' (67)
C
C     CALL PRTBULL(1,IGS)
      CALL NEXTLET ( IPT,JAH )
C
      IF ( KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.79) THEN
                                                       KDEC(21)=1
                                                       GO TO 260
                                                    END IF
      IF ( KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.67)
     1     THEN
              DO 251 IJ=1,26
              IF(KCHAR(IPT+2).EQ.ILST(IJ)) THEN
                                              KDEC(21)=IJ
                                              GO TO 260
                                           END IF
C
 251          CONTINUE
C
           END IF
C
C
C
C*          2.6 INSERT ORIGIN AND DATE/TIME OF ARRIVAL OF BULLETIN.
C               ---------------------------------------------------
 260  CONTINUE
C
C     ORIGIN IS DERIVED FROM KEY . BRACKNELL FILE
C     NAMES START WITH 'B' AND OFFENBACH WITH 'C'. THIS FILENAME IS
C     IN ASCCI CODE       ( 'B' =66 , 'C' = 67)
C
      KDEC(14) = MINDIC    !    ORIGIN WILL BE DEFINED FROM KEY.
C
C
      KDEC(18) = MINDIC               ! DATE AND TIME OF ARRIVAL
      KDEC(19) = MINDIC               !
C
C
C
C*          2.7 TREAT ERROR BULLETIN IN ACCORDANCE WITH DEFINED OPTIONS.
C               --------------------------------------------------------
 270  CONTINUE
C
C     RETURN IF NO ERRORS FOUND.
C
      IF ( KERR.EQ.0 ) RETURN
C
C
C*          3. HANDLE ERROR BULLETIN.
C              ----------------------
 300  CONTINUE
C
      N = KERR-1
      N1 =JISHFT(IOPTS(677),-N).AND.1
      N2 =JISHFT(IOPTS(678),-N).AND.1
C
C*          3.1 PRINT BULLETIN IF REQUIRED.
C               ---------------------------
 310  CONTINUE
C
      IF ( N1.EQ.1 ) THEN
                         WRITE (*,9900) KERR
                         CALL PRTBULL ( 1,IGS)
                     END IF
C
C*          3.2 WRITE BULLETIN TO ERROR FILE IF REQUIRED.
C               -----------------------------------------
 320  CONTINUE
C
      IF ( N2.EQ.1 ) CALL SAVBULL(IERR)
C
C*          3.3  ONLY ERRORS 1 AND 2 ARE FATAL TO DECODING , SO CLEAR
C                -----------------------------------------------------
C                ERROR INDICATOR BEFORE RETURNING.
C                ---------------------------------
 330  CONTINUE

c     IF ( KERR.GT.2 ) KERR = 0
      if (kerr.gt.2) then
         kerr = 0
c         ierr = 0
      end if
C
      RETURN
C
C
 9900 FORMAT (1H ,'BULLETIN ERROR NUMBER ',I2.2)
C
C
      END 
      
      SUBROUTINE PROCT1S ( IERR )
C
C**** *PROCT1S*
C
C
C     PURPOSE.
C     --------
C         CONTROLLING ROUTINE FOR DECODING BATHY,
C         TESAC AND DRIBU.
C
C         DATA ( BULLETINS WITH 'T1' OF 'S' )
C
C         INPUT    : IERR IS NOT USED ON INPUT.
C
C                    IT2  = 1-26 CORRESPONDING TO 'T2' OF A-Z.
C
C         OUTPUT   : IERR IS UNALTERED UNLESS A FATAL ERROR OCCURRS ,
C                     WHEN IT IS SET TO 1.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCT1S(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *BULLSO(IERR)*
C         *CALL* *BULLSS(IERR)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*
C
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.  CALL APPROPRIATE ROUTINE, 'IT2' CONTAINS AN INTEGER IN THE
C                ---------------------------------------------------------
C               RANGE 1-26, CORRESPONDING TO 'T2' OF ABBREVIATED HEADER.
C                -------------------------------------------------------
 100  CONTINUE
C
C
      GOTO ( 110,120,130,140,150,160,170,180,190,200,210,220,230,
     C       240,250,260,270,280,290,300,310,320,330,340,350,360) IT2
C
C     -----------------------------------------------------------------
C*              1.1  BULLETINS WITH 'TT' = 'SA'.
C                    ----------------------------------------------
 110  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.2  BULLETINS WITH 'TT' = 'SB'.
C                    ---------------------------
 120  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.3  BULLETINS WITH 'TT' = 'SC'.
C                    ---------------------------
  130 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.4  BULLETINS WITH 'TT' = 'SD'.
C                    ---------------------------
  140 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.5  BULLETINS WITH 'TT' = 'SE'.
C                    ----------------------------
  150 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.6  BULLETINS WITH 'TT' = 'SF'.
C                    ---------------------------
  160 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.7  BULLETINS WITH 'TT' = 'SG'.
C                    ----------------------------
  170 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.8  BULLETINS WITH 'TT' = 'SH'.
C                    ---------------------------
  180 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.9  BULLETINS WITH 'TT' = 'SI'.
C
  190 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.0  BULLETINS WITH 'TT' = 'SJ'.
C                    ---------------------------
 200  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.1  BULLETINS WITH 'TT' = 'SK'.
C                    ---------------------------
 210  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.2  BULLETINS WITH 'TT' = 'SL'.
C                    ---------------------------
 220  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.3  BULLETINS WITH 'TT' = 'SM'.
C                    ---------------------------
 230  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.4  BULLETINS WITH 'TT' = 'SN'.
C                    ---------------------------
 240  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.5  BULLETINS WITH 'TT' = 'SO'. BATHY AND TESAC.
C                    --------------------------------------------
 250  CONTINUE
      CALL BULLSO( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              2.6  BULLETINS WITH 'TT' = 'SP'.
C                    ---------------------------
 260  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.7  BULLETINS WITH 'TT' = 'SQ'.
C                    ---------------------------
 270  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.8  BULLETINS WITH 'TT' = 'SR'.
C                    ---------------------------
 280  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.9  BULLETINS WITH 'TT' = 'SS'.  DRIBU.
C                    -----------------------------------
 290  CONTINUE
      CALL BULLSS( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              3.0  BULLETINS WITH 'TT' = 'ST'.
C                    ---------------------------
 300  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              3.1  BULLETINS WITH 'TT' = 'SU'.
C
 310  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.2  BULLETINS WITH 'TT' = 'SV'.
C
 320  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.3  BULLETINS WITH 'TT' = 'SW'.
C
 330  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.4  BULLETINS WITH 'TT' = 'SX'.
C
 340  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.5  BULLETINS WITH 'TT' = 'SY'.
C
 350  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.6  BULLETINS WITH 'TT' = 'SZ'.
C
 360  CONTINUE
      RETURN
C
C
      END
      
      SUBROUTINE BULLSS ( IERR )
C
C**** *BULLSS*
C
C
C     PURPOSE.
C     --------
C
C         CONTROLLING ROUTINE FOR DECODING OF INDIVIDUAL
C         REPORTS FROM BULLETINS OF 'DRIBU '  REPORTS.
C
C         INPUT    : BULLETIN IN CCITT 5 CHARACTER, 1 CHARACTER PER
C                    WORD IN 'KCHAR'.
C
C                    POINTERS TO BEGINNING AND END OF 'STARTING LINE',
C                    'MIMIMJMJ LINE' AND END OF BULLETIN.
C
C                    IERR NOT USED
C
C         OUTPUT   : DECODED REPORTS WRITTEN TO FILE AND ERROR REPORTS
C                    TO ERROR FILE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BULLSS(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PRTBULL(I,J)*
C         *CALL* *NEXTMI (I,J,K)*
C         *CALL* *NEXTEQ (I,J)*
C         *CALL* *SAVREP (IHEAD,IERR) *
C         *CALL* *ZZYINT (IHEAD,IERR)*
C         *CALL* *ZZYDEC (IHEAD,IERR)*
C         *CALL* *NEXPRT (I,J,)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
c
      common /reperr/ numreperr
      common /inil/inil
C
C     ------------------------------------------------------------------
C*          1.  PRINT INPUT BULLETIN.              .
C                --------------------
 100  CONTINUE
C
C      CALL PRTBULL ( 1,IGS)
C
C*          1.1 SET FLAGS AND WORKING POINTERS.
C
c               -------------------------------
 110  CONTINUE
C
C     WORKING POINTERS
C
      IPT=IMI
C
C     CLEAR FLAG WHICH INDICATES BULLETIN HEADER ALREADY WRITTEN
C     TO ERROR FILE
C
      IHEAD= 0
C
C*           1.2  SET DATA REPORT TYPE INDICATORS IN DECODED
C                 ------------------------------------------
C                 REPRT HEADER AND PART OF REPORT INDICATOR.
C                 ------------------------------------------
 120  CONTINUE
C
      K= IPT + 10
C
C     CHECK IF VALID MIMI OF 'MIMIMJMJ'.
C
      DO 121 I=IPT,K
C
      IF ( KCHAR( I ) .EQ. 90 .AND. KCHAR(I+1) .EQ. 90 .AND.
     &     KCHAR(I+2) .EQ. 89 .AND. KCHAR(I+3) .EQ. 89      )
     &      THEN
               KDEC(4)=  165
               IPT    =  I
               GO TO 140
            END IF
 121  CONTINUE
C
C*         1.3 INVALID 'MIMI'. WRITE REPORT TO ERROR FILE
C              ------------------------------------------
 130  CONTINUE
C
      KCHAR(IPT)=KCHAR(IPT).OR.128
      IEQ=IPT
      CALL NEXTEQ (IEQ,IGS)
      IF(IEQ.GT.IGS) RETURN
C
C     SEE IF REPORT TOO SHORT
C
      LEN =IEQ-IPT
      IF(LEN.LT.17) GO TO 300
C
      KDEC(4)= 165
      CALL SAVREP(IHEAD,IERR)
c
      numrep(22) = numrep(22) + 1
c
      GO TO 300
C
C*          1.4  LOCATE END OF REPORT AND INCREMENT COUNT
C                ----------------------------------------
 140  CONTINUE
C
      KDEC(23)=1
      IEQ=IPT
C
      CALL NEXTEQ(IEQ,IGS)
C
      IF(IEQ.GT.IGS) RETURN
C
C     CHECK IF = - SIGN IS MISSING, TRYING TO FIND THE NEXT ZZXX
C
      CALL NEXTMI(IPT,IEQ,IIPT)
      IF(IIPT.LT.IEQ) IEQ=IIPT
C
      NUMREP(22)=NUMREP(22) + 1
C
C
C*           2. DECODE DRIBU REPORT.
C               --------------------
 200  CONTINUE
C                   CONVERT TO INTERMEDIATE (INTEGER) FORMAT
C
                    CALL ZZYINT(IHEAD,IERR)
c
                    isaverr = ierr
         	    if (kerr .eq. 1 .or. kerr .eq. 2) inil = inil + 1
C
                    IF(KERR.NE.0) GO TO 300
C
C                   CONVERT INTERMEDIATE (INTEGER) FORMAT TO DECODE FORM
C                   AND WRITE TO FILE
C
                    CALL ZZYDEC(IHEAD,IERR)
C
C
C*             3. LOCATE START OF NEXT REPORT
C                 ----------------------------
 300  CONTINUE
C
      if (isaverr.ne.0) numreperr = numreperr + 1
      isaverr = 0
      kerr = 0
      ierr = 0
c
      IPT=IEQ + 1
C
      CALL NEXTPRT(IPT,IGS)
C
C*            3.1  CHECK FOR END OF BULLETIN
C                  -------------------------
 310  CONTINUE
C
      IF(IPT.GE.IGS)
     &   THEN
C           END OF BULLETIN,SO IF ANY REPORT HAS BEEN WRITTEN TO
C           ERROR FILE,ADD 'GS' CHARACTER BEFORE RETURNING.
C
            IF(IHEAD.EQ.0) RETURN
            IHEAD= 2
            CALL SAVREP(IHEAD,IERR)
C
C           CALL PRTBULL(1,IGS)
C
           RETURN
         END IF
C
C*            3.2 RESET REPORTS DATA BASE TYPE AND
C                 --------------------------------
C                 REPORT TYPE INDICATORS
 320  CONTINUE
C
      KDEC(23)= 0
      KDEC( 4)= 0
C
C     SEARCH THE BEGINNING OF NEXT REPORT AND CHANGE THE POINTER IMI
C
      NPT=IEQ
      CALL NEXTLET(NPT,IGS)
C
      IF(NPT.GE.IGS) RETURN
C
      IMI=NPT
      CALL NEXTEND(NPT,IGS)
C
      IF(NPT.GE.IGS) RETURN
C
      GO TO 120
C
      END
      
      SUBROUTINE ZZYINT (IHEAD,IERR)
C
C**** *ZZYINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT DRIBU REPORTS  FROM CCITT 5 CHARACTER
C         FORMAT TO INTERMEDIATE (INTEGER) FORMAT
C
C         INPUT    : REPORT IN KCHAR(IPT) - KCHAR(IEQ),
C                    IN CCITT 5, 1 CHARACTER PER WORD.
C
C                    IHEAD = 0  INDICATES BULLETIN HEADER NOT ALREADY
C                               WRITTEN TO ERROR FILE
C                          = 1  MEANS HEADER ALREADY WRITTEN TO ERROR FILE
C
C                    IERR       NOT USED ON INPUT
C
C          OUTPUT   : REPORTS IN INTEGER FORMAT IN ARRAY 'KINT' IN DESIRED
C                     FORMAT (SEE SEPARATE DOCUMENTATION).
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ZZYINT(IHEAD,IERR)*
C
C     METHOD.
C     -------
C
C         IF AN ERROR IS FOUND IN THE DATA, THE DECODING IS PROCE
C         UNLESS THE ERROR IS FATAL I.E.
C         LAT/LONG OR TIME/DATE IS INCORRECT.
C         WHEN A NON FATAL ERROR HAS BEEN DETECTED THE ROUTINE TR
C         TO FIND THE BEGINNING OF CORRECT DATA. IF CORRECT DATA
C         FOUND THE DECODING THE NUMBER OF NON-FATAL ERRORS IS CO
C         AND IF IT IS GREATER THAN LIMIT (5 FOR NOW) ALL THE DAT
C         AFTER THE FIRST ERROR ARE REMOVED (THIS IS DONE TO ENSU
C         THAT TOTALLY CORRUPTED DATA ARE NOT USED E.G. WRONG PAR
C         OF DRIBU).
C         FOR THIS PURPOSE TWO VARIABLES ARE USED
C         NUMERR = NUMBER OF NON-FATAL ERRORS
C         IREMPOS= THE POINTER TO FIRST ERROR IN 'KINT'.
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTFIG(I,J)*
C         *CALL* *EXTGRP (I, , , , , , )*
C         *CALL* *ERRSTA (I, , , , , , )*
C         *CALL* *NEXSEP2(I,J,*)*
C         *CALL* *NEXPRT2(I,J,*)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C*          1. CLEAR FLAGS AND ERROR INDICATOR. KEEP POINTER TO FIRST
C              ------------------------------------------------------
C              CHARACTER OF REPORT.
C              --------------------
 100  CONTINUE
C
C     POINTER TO FIRST CHARACTER
C
      KEEP=IPT
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST= 0
C
C     ERROR INDICATOR
C
 101  KERR   = 0
      NUMERR = 0
      IREMPOS= 10
C
C
C*        1.1 CHECK FOR 'NIL' REPORT.
C             -----------------------
 110  CONTINUE
C
      NIL= 0
C
      LEN=IEQ-IPT
      IF(LEN.LE.30)
     &   THEN
            KERR=1
            NIL =1
            CALL ERRSTA(22,0,IFIRST,NUMERR)
         END IF
C
C*            2. SET AREA FOR INTERMEDIATE (INTEGER) REPORT
C                ------------------------------------------
C                TO MISSING DATA VALUE .
C                -----------------------
 200  CONTINUE
C
      DO 201 I=1,8192
         KINT(I)=MINDIC
 201  CONTINUE
C
C
C*           2.1 CLEAR DATA FOR PREVIOUS REPORT FROM
C                -----------------------------------
C                DECODED REPORT HEADER AREA
C                ---------------------------
 210  CONTINUE
C
      DO 211 I=1,3
         KDEC(I)=MINDIC
 211  CONTINUE
C
      DO 212 I=5,9
         KDEC(I)=MINDIC
 212  CONTINUE
C
C     CLEAR FLAG FIELDS RETAINING 'COR' FLAG.
C
      KDEC(13)=MINDIC
      KDEC(15)=KDEC(15).AND.4
      KDEC(16)=MINDIC
      KDEC(17)=MINDIC
C
      KDEC(20)=0
      KDEC(22)=MINDIC
      KDEC(23)=1
C
C*            3.  SECTION 0 - IDENTIFICATION AND POSITION DATA;
C                 ---------------------------------------------
C                 BUOY IDENTIFIECATION,TIME,POSITION.
C                 -----------------------------------
 300  CONTINUE
C
C     BUOY IDENTIFIER. A1BWNBNBNB
C     ---------------------------
C
      CALL NEXTFIG(IPT,IEQ)
      IF(IPT.GT.IEQ) GO TO 700
C
      CALL EXTGRP (IPT,1,1,3,0,0,1,IRET)
      IF(IRET.NE.0) THEN
         KERR=5
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         IF(NUMERR.EQ.1) IREMPOS=1
      END IF
C
C     YYMMJ - GROUP
C
      CALL NEXSEP2 (IPT,IEQ,*700)
      CALL NEXPRT2 (IPT,IEQ,*700)
C
      CALL EXTGRP(IPT,2,2,1,0,0,4,IRET)
      IF(IRET.NE.0) THEN
         KERR=2
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         IF(NUMERR.EQ.1) IREMPOS=4
         GO TO 700
      END IF
C
C     GG gg iw
C     -- -- -
      CALL NEXSEP2 (IPT,IEQ,*700)
      CALL NEXPRT2 (IPT,IEQ,*700)
C
      CALL EXTGRP(IPT,2,2,1,0,0,7,IRET)
      IF(IRET.NE.0) THEN
         KERR=3
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         GO TO 700
      END IF
C
      IF(KINT(4).LT.1.OR.KINT(1).GT.31) THEN
         IRET=1
         KINT(4)=MINDIC
      END IF
C
      IF(KINT(5).LT.1.OR.KINT(5).GT.12) THEN
         IRET=2
         KINT(5)=MINDIC
      END IF
C
      IF(KINT(6).LT.0.OR.KINT(6).GT.9) THEN
         IRET=3
         KINT(6)=MINDIC
      END IF
C 
      IF(KINT(7).LT.0.OR.KINT(7).GT.24) THEN
         IRET=2
         KINT(7)=MINDIC
      END IF
      IF(KINT(8).LT.0.OR.KINT(8).GT.59) THEN
         IRET=2
         KINT(8)=MINDIC
      END IF
C
      IF(IRET.NE.0) THEN
C
C        CHECK IF ALREADY KNOWN TO BE 'NIL' - REPORT
C
         IF(NIL.EQ.1) THEN
            KERR=1
            RETURN
         END IF
C
         KERR=2
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         RETURN
C
      END IF
C
C     QCLALALALALA - GROUP
C     - - - - -
C
      CALL NEXSEP2(IPT,IEQ,*700)
      CALL NEXPRT2(IPT,IEQ,*700)
C
      CALL EXTGRP (IPT,1,4,0,0,0,10,IRET)
      IF(IRET.NE.0) THEN
         KERR=4
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         GO TO 700
      END IF
C
C     LOLOLOLOLOLO - GROUP
C     - - - - -
C
      CALL NEXSEP2(IPT,IEQ,*700)
      CALL NEXPRT2(IPT,IEQ,*700)
C
      CALL EXTGRP (IPT,5,0,0,0,0,12,IRET)
      IF(IRET.NE.0) THEN
         KERR=5
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         GO TO 700
      END IF
C
C     6QlQt// 
C     -------
C
      CALL NEXSEP2(IPT,IEQ,*700)
      CALL NEXPRT2(IPT,IEQ,*700)
C
C     CHECK IF NEXT GROUP QUALITY CONTROL GROUP
C     -----------------------------------------
c      IF(KCHAR(IPT).EQ.54.AND.KCHAR(IPT+3).EQ.47.AND.
c    
c      Mudanca no codigo wmo - o grupo passa a ser 6QlQtQa/
c             nao estamos utilizando Qa (futuro)
c
      IF(KCHAR(IPT).EQ.54.AND.
     1   KCHAR(IPT+4).EQ.47) THEN
         CALL EXTGRP (IPT,1,1,1,2,0,13,IRET)
         IF(IRET.NE.0) THEN
            KERR=5
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            GO TO 700
         END IF
C
         CALL NEXSEP2(IPT,IEQ,*700)
         CALL NEXPRT2(IPT,IEQ,*700)
C
      END IF 
C
C        CHECK IF IT IS BEGINING OF SECTION 1
C
         IF(KCHAR(IPT).EQ.49.AND.KCHAR(IPT+1).EQ.49.AND.
     1      KCHAR(IPT+2).EQ.49) THEN
            CALL EXTGRP (IPT,3,1,1,0,0,17,IRET)
            IF(IRET.NE.0) THEN
               KERR=5
               CALL ERRSTA(22,1,IFIRST,NUMERR)
               IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
               GO TO 700
            END IF
         ELSE
            GO TO 311
         END IF
C
C-----------------------------------------------------------------------
C*          3.1 SECTION 1 - SURFACE PARAMETERS.
C               -------------------------------
 310  CONTINUE
C
C     CHECK IF THE NEXT GROUP IS BEGINING OF SECTION 2
C
      CALL NEXSEP2(IPT,IEQ,*700)
      CALL NEXPRT2(IPT,IEQ,*700)
C
 311  CONTINUE
C
      IF(KCHAR(IPT  ) .EQ. 50 .AND.
     &   KCHAR(IPT+1) .EQ. 50 .AND.
     &   KCHAR(IPT+2) .EQ. 50 ) then
C           BEGINING OF THE SECTION 2 FOUND
         GO TO 400
      END IF
C
      IF(KCHAR(IPT  ) .EQ. 51 .AND.
     &   KCHAR(IPT+1) .EQ. 51 .AND.
     &   KCHAR(IPT+2) .EQ. 51 ) then
C           BEGINING OF THE SECTION 3 FOUND
            GO TO 420
         END IF
C
      IF(KCHAR(IPT  ) .EQ. 52 .AND.
     &   KCHAR(IPT+1) .EQ. 52 .AND.
     &   KCHAR(IPT+2) .EQ. 52) then
C           BEGINING OF THE SECTION 4 FOUND
            GO TO 500
         END IF
C     -----------------------------------------------------------------
C     THERE ARE SOME USEFULL INFORMATION IN SECTION 1
C
      CALL EXTVAL(IPT,1,IVAL)
C
      IF(IVAL .EQ. 0) THEN
C
C        WIND DIRECTION AND SPEED
C
         CALL EXTGRP (IPT,1,2,2,0,0,20,IRET)
         IF(IRET.NE.0) THEN
            KERR=9
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=16
            GO TO 700
         END IF
         GO TO 310
      END IF
C
      IF(IVAL .EQ. 1) THEN
C
C       AIR TEMPERATURE FOUND
C
        CALL EXTGRP (IPT,1,1,3,0,0,23,IRET) 
        IF(IRET.NE.0) THEN
           KERR=10
           CALL ERRSTA(22,1,IFIRST,NUMERR)
           IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
           IF(NUMERR.EQ.1) IREMPOS=16
           GO TO 700
        END IF
        GO TO 310
      END IF
C
      IF(IVAL .EQ. 2) THEN
C
C       2SNTDTDTD
C
        CALL EXTGRP (IPT,1,1,3,0,0,26,IRET)
        IF(IRET.NE.0) THEN
           KERR=10
           CALL ERRSTA(22,1,IFIRST,NUMERR)
           IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
           IF(NUMERR.EQ.1) IREMPOS=16
           GO TO 700
        END IF
        GO TO 310
      END IF
C
      IF(IVAL .EQ. 3) THEN
C
C       3P0P0P0P0 STATION LEVEL PRESSURE
C
        CALL EXTGRP (IPT,1,4,0,0,0,29,IRET)
        IF(IRET.NE.0) THEN
           KERR=10
           CALL ERRSTA(22,1,IFIRST,NUMERR)
           IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
           IF(NUMERR.EQ.1) IREMPOS=16
           GO TO 700
        END IF
        GO TO 310
      END IF
C
      IF(IVAL .EQ. 4) THEN
C
C        MEAN SEA LEVEL PRESSURE FOUND
C
         CALL EXTGRP (IPT,1,4,0,0,0,31,IRET)
         IF(IRET.NE.0) THEN
            KERR=7
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=19
            GO TO 700
         END IF
         GO TO 310
      END IF
C
      IF(IVAL .EQ. 5) THEN
C
C        PRESSURE TENDENCY  FOUND
C
         CALL EXTGRP (IPT,1,1,3,0,0,33,IRET)
         IF(IRET.NE.0) THEN
            KERR=11
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=21
            GO TO 700
         END IF
         GO TO 310
      END IF
C
      GO TO 310
C     ------------------------------------------------------------------
C*          4. SECTION 2.
C              ----------
 400  CONTINUE
C
      CALL EXTGRP (IPT,3,1,1,0,0,36,IRET)
      IF(IRET.NE.0) THEN
         KERR=8
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         IF(NUMERR.EQ.1) IREMPOS=24
         GO TO 700
      END IF
C
 410  CONTINUE
C
      CALL NEXSEP2(IPT,IEQ,*700)
      CALL NEXPRT2(IPT,IEQ,*700)
C
      IF(KCHAR(IPT  ) .EQ. 51 .AND.
     &   KCHAR(IPT+1) .EQ. 51 .AND.
     &   KCHAR(IPT+2) .EQ. 51 ) then
C           BEGINING OF THE SECTION 3 FOUND
            GO TO 420
         END IF
C
      IF(KCHAR(IPT  ) .EQ. 52 .AND.
     &   KCHAR(IPT+1) .EQ. 52 .AND.
     &   KCHAR(IPT+2) .EQ. 52) then 
C           BEGINING OF THE SECTION 4 FOUND
            GO TO 500
         END IF
C     -----------------------------------------------------------------
C     THERE ARE SOME USEFULL INFORMATION IN SECTION 2
C
      CALL EXTVAL(IPT,1,IVAL)
C
C
      IF(IVAL .EQ. 0) THEN
C
C        SEA SURFACE TEMPERATURE FOUND
C
         CALL EXTGRP (IPT,1,1,3,0,0,39,IRET)
         IF(IRET.NE.0) THEN
            KERR=8
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=12
            GO TO 700
         END IF
         GO TO 410
      END IF
C
      IF(IVAL .EQ. 1) THEN
C
C        PERIOD AND HEIGTH OF WAVES.
C
         CALL EXTGRP (IPT,1,2,2,0,0,42,IRET)
         IF(IRET.NE.0) THEN
            KERR=9
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=28
            GO TO 700
         END IF
         GO TO 410
      END IF
C
      IF(IVAL.EQ.2.AND.KCHAR(IPT+1).EQ.48) THEN
C
C        PERIOD OF WAVES.
C
         CALL EXTGRP (IPT,2,3,0,0,0,45,IRET)
         IF(IRET.NE.0) THEN
            KERR=10
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=31
            GO TO 700
         END IF
         GO TO 410
      END IF
C
      IF(IVAL.EQ.2.AND.KCHAR(IPT+1).EQ.49) THEN
C
C        HEIGHT OF WAVES.
C
         CALL EXTGRP (IPT,2,3,0,0,0,47,IRET)
         IF(IRET.NE.0) THEN
            KERR=11
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=33
            GO TO 700
         END IF
         GO TO 410
      END IF
C
      GO TO 410
C-----------------------------------------------------------------------
C*          4.2 SECTION 3 - TEMPERATURES,SALINITY AT SIGNIFICANT DEPTHS.
C              ---------------------------------------------------------
 420  CONTINUE
C
      CALL EXTGRP (IPT,3,1,1,0,0,49,IRET)
      IF(IRET.NE.0) THEN
         KERR=12
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         IF(NUMERR.EQ.1) IREMPOS=35
         GO TO 700
      END IF
C
 421  CONTINUE
C
      CALL NEXSEP2(IPT,IEQ,*700)
      CALL NEXPRT2(IPT,IEQ,*700)
C
      IF(KCHAR(IPT  ) .EQ. 52 .AND.
     &   KCHAR(IPT+1) .EQ. 52 .AND.
     &   KCHAR(IPT+2) .EQ. 52) then
C           BEGINING OF THE SECTION 4 FOUND
            GO TO 500
         END IF
C
C     CHECK IF SEA T OR CURRENT INFORMATION FOLLOW
C
      IF(KCHAR(IPT  ) .EQ.56 .AND.
     &   KCHAR(IPT+1) .EQ.56       ) GO TO 430
      IF(KCHAR(IPT  ) .EQ.54 .AND.
     &   KCHAR(IPT+1) .EQ.54       ) GO TO 440
C
      GO TO 421
C
C     -----------------------------------------------------------------
 430  CONTINUE
C
      CALL EXTGRP (IPT,4,1,0,0,0,52,IRET)
      IF(IRET.NE.0) THEN
         KERR=14
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         IF(NUMERR.EQ.1) IREMPOS=36
         GO TO 700
      END IF
C
C-----------------------------------------------------------------------
      IPOS=48  
C
 431  CONTINUE
C
      CALL NEXSEP2(IPT,IEQ,*700)
      CALL NEXPRT2(IPT,IEQ,*700)
C
      IF(KCHAR(IPT  ) .EQ. 52 .AND.
     &   KCHAR(IPT+1) .EQ. 52 .AND.
     &   KCHAR(IPT+2) .EQ. 52) then
C           BEGINING OF THE SECTION 4 FOUND
            GO TO 500
         END IF
C
C     CHECK IF CURRENT INFORMATION FOLLOWS.
C
      IF(KCHAR(IPT  ) .EQ.54 .AND.
     &   KCHAR(IPT+1) .EQ.54      ) GO TO 440
C     -----------------------------------------------------------------
C     TEMPERATURES AT SIGNIFICANT DEPTHS FOLLOW
C
      CALL EXTVAL(IPT,1,IVAL)
C
      IF(IVAL.EQ. 2 ) THEN
         CALL EXTGRP (IPT,1,4,0,0,0,IPOS,IRET)
         IF(IRET.NE.0) THEN
            KERR=14
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=IPOS
            GO TO 700
         END IF
         GO TO 431
      END IF
C
      IF(IVAL.EQ. 3 ) THEN
         CALL EXTGRP (IPT,1,4,0,0,0,IPOS+2,IRET)
         IF(IRET.NE.0) THEN
            KERR=14
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=IPOS+2
            GO TO 700
         END IF
         GO TO 431
      END IF
C
      IF(IVAL.EQ. 4 ) THEN
         CALL EXTGRP (IPT,1,4,0,0,0,IPOS+4,IRET)
         IF(IRET.NE.0) THEN
            KERR=14
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=IPOS+4
            GO TO 700
         END IF
      END IF
C
         IPOS=IPOS+6
      GO TO 431
C-----------------------------------------------------------------------
 440  CONTINUE
C
C     66K69K3
C
      CALL EXTGRP (IPT,2,1,1,1,0,401,IRET)
      IF(IRET.NE.0) THEN
         KERR=14
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         IF(NUMERR.EQ.1) IREMPOS=126
         GO TO 700
      END IF
C
      IPOS=405
C
 441  CONTINUE
C
      CALL NEXSEP2(IPT,IEQ,*700)
      CALL NEXPRT2(IPT,IEQ,*700)
C
      IF(KCHAR(IPT  ) .EQ. 52 .AND.
     &   KCHAR(IPT+1) .EQ. 52 .AND.
     &   KCHAR(IPT+2) .EQ. 52 .AND.
     &   KCHAR(IPT+3) .LE. 32      )
     &   THEN
C           BEGINING OF THE SECTION 4 FOUND
            GO TO 500
         END IF
C
C     -----------------------------------------------------------------
C     DEPTH, DIRECTION AND SPEED OF CURRENT.
C
      CALL EXTVAL(IPT,1,IVAL)
C
      IF(IVAL.EQ. 2 ) THEN
         CALL EXTGRP (IPT,1,4,0,0,0,IPOS,IRET)
         IF(IRET.NE.0) THEN
            KERR=14
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=IPOS
            GO TO 700
         END IF
      END IF
C
      CALL NEXSEP2(IPT,IEQ,*700)
      CALL NEXPRT2(IPT,IEQ,*700)
C
      IF(KCHAR(IPT  ) .EQ. 52 .AND.
     &   KCHAR(IPT+1) .EQ. 52 .AND.
     &   KCHAR(IPT+2) .EQ. 52 ) then 
C        BEGINING OF THE SECTION 4 FOUND
         GO TO 500
      END IF
C
      CALL EXTGRP (IPT,2,3,0,0,0,IPOS+2,IRET)
      IF(IRET.NE.0) THEN
         KERR=14
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         IF(NUMERR.EQ.1) IREMPOS=IPOS+2
         GO TO 700
      END IF
C
      IPOS=IPOS+4
      GO TO 441
C     -----------------------------------------------------------------
C*          5. QUALITY CONTROL INFORMATION.
C              ----------------------------
 500  CONTINUE
C
      CALL EXTGRP (IPT,3,0,0,0,0,701,IRET)
      IF(IRET.NE.0) THEN
         KERR=15
         CALL ERRSTA(22,1,IFIRST,NUMERR)
         IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
         IF(NUMERR.EQ.1) IREMPOS=701
         GO TO 700
      END IF
C
 510  CONTINUE
C
      CALL NEXSEP2(IPT,IEQ,*700)
      CALL NEXPRT2(IPT,IEQ,*700)
C
C     THERE ARE SOME INFORMATION ABOUT TECHNICAL AND QUALITY FEATURES
C
      CALL EXTVAL(IPT,1,IVAL)
C
      IF(IVAL.EQ.1) THEN
C
C        1QPQ2QTWQ4 GROUP FOUND
C        -- - -  -
         CALL EXTGRP (IPT,1,1,1,1,1,702,IRET)
         IF(IRET.NE.0) THEN
            KERR=16
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=702
            GO TO 700
         END IF
         GO TO 510
      END IF
C
      IF(IVAL.EQ.2) THEN
C
C        2QNQL// GROUP FOUND
C           -- - --
         CALL EXTGRP (IPT,1,1,1,2,0,707,IRET)
         IF(IRET.NE.0) THEN
            KERR=17
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=707
            GO TO 700
         END IF
C
         CALL NEXSEP2(IPT,IEQ,*700)
         CALL NEXPRT2(IPT,IEQ,*700)
C
         IF(KINT(709).EQ.1) THEN
C
C           SKIP YYMMJ GGgg/ GROUPS
C
            CALL NEXSEP2(IPT,IEQ,*700)
            CALL NEXPRT2(IPT,IEQ,*700)
C
            CALL NEXSEP2(IPT,IEQ,*700)
            CALL NEXPRT2(IPT,IEQ,*700)
C
C           7VBVBDBDB
C
            CALL EXTGRP (IPT,1,2,2,0,0,714,IRET)
            IF(IRET.NE.0) THEN
               KERR=18
               CALL ERRSTA(22,1,IFIRST,NUMERR)
               IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
               IF(NUMERR.EQ.1) IREMPOS=714
               GO TO 700
            END IF
         END IF
C
         IF(KINT(709).EQ.2) THEN
            CALL EXTGRP (IPT,1,4,0,0,0,711,IRET)
            IF(IRET.NE.0) THEN
               KERR=19
               CALL ERRSTA(22,1,IFIRST,NUMERR)
               IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
               IF(NUMERR.EQ.1) IREMPOS=711
               GO TO 700
            END IF
C
            CALL NEXSEP2(IPT,IEQ,*700)
            CALL NEXPRT2(IPT,IEQ,*700)
C
            CALL EXTGRP (IPT,5,0,0,0,0,713,IRET)
            IF(IRET.NE.0) THEN
               KERR=20
               CALL ERRSTA(22,1,IFIRST,NUMERR)
               IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
               IF(NUMERR.EQ.1) IREMPOS=713
               GO TO 700
            END IF
C
            GO TO 510
C
         END IF
      END IF
C
      IF(IVAL.EQ.8) THEN
         CALL EXTGRP (IPT,1,4,0,0,0,717,IRET)
         IF(IRET.NE.0) THEN
            KERR=21
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=717
            GO TO 700
         END IF
C
         GO TO 510
C
      END IF
C
      IF(IVAL.EQ.9) THEN
         CALL EXTGRP (IPT,1,1,3,0,0,719,IRET)
         IF(IRET.NE.0) THEN
            KERR=22
            CALL ERRSTA(22,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(22,KERR)=NOER(22,KERR)+1
            IF(NUMERR.EQ.1)  IREMPOS=719
            GO TO 700
         END IF
      END IF
C
      GO TO 510
C     -----------------------------------------------------------------
C*            7. ERROR CHECKING AND HANDLING .
C                -----------------------------
 700  CONTINUE
C
C     RETURN IF NO ERRORS IN REPORT
C
      IF(KERR.EQ.0) RETURN
C
C     IF FIRST DECODING ATTEMPT ,TRY TO CORRECT
C     THE ERROR AND DECODE AGAIN
C
      IF(IFIRST.EQ.0) THEN
                         IPT=KEEP
                         CALL FIXSS
                         IFIRST=1
                        NUMRERR(22)=NUMRERR(22) + 1
                         GO TO 101
                      ELSE
                         CALL SAVREP(IHEAD,IERR)
C
C                        CLEAR PARITY BIT AFTER SAVING ERROR FILE
C
                         DO 701 I=KEEP,IGS
                         KCHAR(I)=KCHAR(I).AND.127
 701                     CONTINUE
C
C                        ONLY REPORTS WITH ERROR IN DATE/TIME
C                        OR LAT/LONG ARE NOT PROCESSED ANY FURTHER
C
C                        IF THERE ARE MORE THEN 5 NON-FATAL ERRORS
C                        IN REPORT IT IS ONLY PROCESSED UNTIL THE
C                        FIRST ERROR
C
                         IF(NUMERR.GT.5) THEN
                                           DO 702 I=IREMPOS,8192
                                            KINT(I)=MINDIC
 702                                        CONTINUE
                                         END IF
C
c                        IF(KERR.GT.6) KERR=0
                         if(kerr.gt.6) then
                           kerr = 0
c                          ierr = 0
                         end if
c
                      END IF
C
 703  CONTINUE
C
C     CALL PRTKINT(KINT,1,120,MINDIC)
C
      RETURN
      END
      
      SUBROUTINE ZZYDEC(IHEAD,IERR)
C
C**** *ZZYDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE DRIBU REPORT  FROM INTERMEDIATE
C         FORMAT TO FULL DECODED FORMAT
C
C         INPUT    : REPORT IN INTERMEDIATE FORMAT IN 'KINT'
C
C         OUTPUT   : REPORT WRITTEN INTO DECODED REPORT FILE 04
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ZZYDEC(IHEAD,IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      INCLUDE 'comkeyc.h'
C
C
      CHARACTER*9 CIDENT,CVAL 
      character*24 cunit
C
C     ------------------------------------------------------------------
C*          1.  INITIALIZE CONSTANTS AND VARIABLES.
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C     CLEAR THE ERROR INDICATOR
C
      KERR=0
C
C     SET UNUSED HEADER FIELDS TO MISSING DATA INDICATOR
C     (ALTITUDE,WMO REGION AND COUNTRY,RESERVED FIELDS)
C
      KDEC(07)=MINDIC
      KDEC(08)=MINDIC
      KDEC(15)=KDEC(15).AND.4
      KDEC(16)=MINDIC
      KDEC(17)=MINDIC
      KDEC(21)=MINDIC
      KDEC(22)=MINDIC
C
C     CLEAR 'NIL' REPORT INDICATOR
C
      KDEC(20)=0
C
C     SET DECODED REPORT TO MISSING DATA VALUE
C
      DO 101 I=25,1536
      KDEC(I)=MINDIC
 101  CONTINUE
C
C---------------------------------------------------------------------
C*           2. SET UP HEADER OF FULLY EXPANDED DRIBU FORMAT.
C               ---------------------------------------------
 200  CONTINUE
C
C     SET UP DAY, HOUR AND MINUTE
C
      KDEC(1)=KINT(4)
      KDEC(2)=KINT(7)
      KDEC(9)=KINT(8)
C
C     SET UP LATITUDE AND LONGITUDE
C
      CALL QLALOD(KINT(10),KINT(11),KINT(12),MINDIC,KDEC(5),KDEC(6))
      IF(KDEC(5).EQ.MINDIC.OR.KDEC(6).EQ.MINDIC) THEN
            IERR=5
            RETURN
      ENDIF
C
C     SET BUOY IDENTIFICATION
C
      IF(KINT(1).NE.MINDIC.AND.
     &   KINT(2).NE.MINDIC.AND.
     &   KINT(3).NE.MINDIC) THEN
         IBL=32
         KINT(1)=KINT(1) + 48
         KINT(2)=KINT(2) + 48
         IB1=KINT(3)/100
         IB2=(KINT(3)-IB1*100)/10
         IB3=(KINT(3)-((KINT(3)/10)*10))
         IB1=IB1+48
         IB2=IB2+48
         IB3=IB3+48
C
         CIDENT=CHAR(KINT(1))//CHAR(KINT(2))//CHAR(IB1)
     1          //CHAR(IB2)//CHAR(IB3)//'    '
C
         READ(CIDENT,'(I5)') KDEC(7)
C
      ELSE
C
C        IDENTIFIER IS MISSING
C
         CIDENT='XXX      '               
         KDEC(7)=MINDIC
      END IF
C
C     SET ENGINEERING STATUS OF BUOY,INDICATOR FOR TYPE OF DROGUE
C     AND LENGTH OF CABLE AT WICH THE DROGUE IS ATTACHED
C
      IF(KINT(718).EQ.MINDIC) KINT(718)='1777'O
      IF(KINT(720).EQ.MINDIC) KINT(720)='1777'O
      IF(KINT(721).EQ.MINDIC) KINT(721)='1777'O
C
      KDEC(13)=JISHFT(KINT(718),16).OR.JISHFT(KINT(720),8).OR.KINT(721)
C
C     SET UP : QUALITY OF PRESSURE MEASURMENTS
C              QUALITY OF SECOND WORD IN MESSAGE
C              QUALITY OF MEASURMENT OF WATER-SURFACE TEMPERATURE
C              QUALITY OF FOURTH WORD IN MESSAGE
C              QUALITY OF LOCATION
C
      IF(KINT(703).EQ.MINDIC) KINT(703)='37'O
      IF(KINT(704).EQ.MINDIC) KINT(704)='37'O
      IF(KINT(705).EQ.MINDIC) KINT(705)='37'O
      IF(KINT(706).EQ.MINDIC) KINT(706)='37'O
      IF(KINT(708).EQ.MINDIC) KINT(708)='37'O
      IF(KINT(709).EQ.MINDIC) KINT(709)='37'O
C
      KDEC(22)=JISHFT(KINT(703),25).OR.JISHFT(KINT(704),20).OR.
     &         JISHFT(KINT(705),15).OR.JISHFT(KINT(706),10).OR.
     &         JISHFT(KINT(708), 5).OR.       KINT(709)
C
C     SET UP LENGTH OF REPORT
C
      KDEC(24)=400
C
C-----------------------------------------------------------------------
C*           3. MEAN SEA-LEVEL PRESSURE.
C               ------------------------
 300  CONTINUE
C
      IF(KINT(32).NE.MINDIC) THEN
         KDEC(25)=KINT(32)
         IF(KINT(32).LE.999) KDEC(25)=KINT(32)+10000
      END IF
C
C               STATIONLEVEL PRESSURE
C
      IF(KINT(30).NE.MINDIC) THEN
         KDEC(26)=KINT(30)
         IF(KINT(30).LE.999) KDEC(26)=KINT(30)+10000
      END IF
C     -----------------------------------------------------------------
C*             4. WIND DIRECTION AND SPEED.
C                 -------------------------
 400  CONTINUE
C
      IF(KINT(21).NE.MINDIC.AND.KINT(22).NE.MINDIC) THEN
         KDEC(27)=KINT(21)*10
         IF(KINT(21).EQ.99) KDEC(27)=0
         IF(KINT(21).EQ.0 ) THEN
            KDEC(27)=0
            KDEC(28)=0
         END IF
C
         IF(KINT(9).EQ.0.OR.KINT(9).EQ.1) THEN
C
C           WIND SPEED IN (M/S)
C
            KDEC(28)=KINT(22)
         END IF
C
         IF(KINT(9).EQ.3.OR.KINT(9).EQ.4) THEN
C           WIND SPEED IN KNOTS
            KDEC(28)=KINT(22)/2. + .5
         END IF
C
         IF(KINT(9).EQ.MINDIC) THEN
            KDEC(27)=MINDIC
            KDEC(28)=MINDIC
         END IF
      END IF
C     -----------------------------------------------------------------
C*          5.  AIR TEMPERATURE .
C               -----------------
 500  CONTINUE
C
      IF(KINT(24).NE.MINDIC.AND.KINT(25).NE.MINDIC) THEN
         IF(KINT(24).EQ.0) KDEC(29)=KINT(25)
         IF(KINT(24).EQ.1) KDEC(29)=-KINT(25)
      END IF
C
C               DEW POINT TEMPERATURE
C
      IF(KINT(27).NE.MINDIC.AND.KINT(28).NE.MINDIC) THEN
         IF(KINT(27).EQ.0) KDEC(30)=KINT(28)
         IF(KINT(27).EQ.1) KDEC(30)=-KINT(28)
C
C              RELATIVE HUMIDITY
C
         IF(KINT(27).EQ.9) KDEC(30)=KINT(28)
      END IF
C
C     ------------------------------------------------------------------
C*          6. SEA-SURFACE TEMPERATURE
C
 600  CONTINUE
C
      IF(KINT(40).NE.MINDIC.AND.KINT(41).NE.MINDIC) THEN
         IF(KINT(40).EQ.0) KDEC(31)=KINT(41)
         IF(KINT(40).EQ.1) KDEC(31)=-KINT(41)
      END IF
C     ------------------------------------------------------------------
C     A- CODE
C
      KDEC(32)=KINT(34)
C     ------------------------------------------------------------------
C*           7. PRESSURE TENDENCY.
C               ------------------
 700  CONTINUE
C
      KDEC(33)=KINT(35)
C     ------------------------------------------------------------------
C*           8. NUMBER OF HOURS BEFORE THE TIME OF OBSERVATION.
C               -----------------------------------------------
 800  CONTINUE
C
      KDEC(34)=KINT(714)
C     -------------------------------------------------------------------
C*           9. DRIFT DIRECTION OF THE BUOY .
C               -----------------------------
 900  CONTINUE
C
      IF(KINT(716).NE.MINDIC) KDEC(35)=KINT(716)*10
C     ------------------------------------------------------------------
C*           10. DRIFTING SPEED ( CM/S)
C
 1000 CONTINUE
C
      KDEC(36)=KINT(715)
C
C         
C     ------------------------------------------------------------------
C*           10. DEPTHS, TEMPERATURES, SALINITY.
C                ------------------------------
 1100 CONTINUE
C
      IPKT=55
      IPKD=41
C
      DO 1101 I=1,49
C
      IF(KINT(IPKT  ).NE.MINDIC) THEN
         KDEC(IPKD  )=KINT(IPKT)
         IF(KINT(IPKT+2).NE.MINDIC) KDEC(IPKD+1)=KINT(IPKT+2)
         IF(KINT(IPKT+4).NE.MINDIC) KDEC(IPKD+2)=KINT(IPKT+4)
      END IF
C
      IPKD=IPKD+3
      IPKT=IPKT+6
C
 1101 CONTINUE
C
      IPKT=406
      IPKD=201
C
      DO 1102 I=1,49
C
      IF(KINT(IPKT  ).NE.MINDIC) THEN
         KDEC(IPKD  )=KINT(IPKT)
         IF(KINT(IPKT+1).NE.MINDIC) KDEC(IPKD+1)=KINT(IPKT+1)
         IF(KINT(IPKT+2).NE.MINDIC) KDEC(IPKD+2)=KINT(IPKT+2)
      END IF
C
      IPKD=IPKD+3
      IPKT=IPKT+4
C
 1102 CONTINUE
C
C     -------------------------------------------------------------
C*              12. WRITE DRIBU INTO WORKING TABLE FOR BUFR CONVERSION.
C                   ----------------------------------------------------
 1200 CONTINUE
C
C     CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
C
      CALL WTDRIBU(IERR)
C     -------------------------------------------------------------
C*              13. QUALITY CONTROL DRIBU REPORT.
C                   -----------------------------
 1300 CONTINUE
C
      IF(.NOT.L11) GO TO 1500 
      IF(L11.AND.L12) THEN
         L12=.FALSE.
         CALL QCDRIBU( IERR )
         L12=.TRUE.
      ELSE
         CALL QCDRIBU(IERR)
      END IF
C     -------------------------------------------------------------
C*              14. ENCODE BUFR MESSAGE.
C                   --------------------
 1400 CONTINUE
C
      CALL BENCD( IERR )
C
C     -------------------------------------------------------------
C*              15. MOVE VALUEW INTO VALUES.
C                   ------------------------
 1500 CONTINUE
C
      IF(.NOT.L12.AND..NOT.L13) GO TO 1800 
      CALL QCCON( IERR )
C 
C     -------------------------------------------------------------
C*              16. QUALITY CONTROL DRIBU REPORT.
C                   -----------------------------
 1600 CONTINUE
C
      CALL QCDRIBU( IERR )
C     -------------------------------------------------------------
C*              17. ENCODE BUFR MESSAGE.
C                   --------------------
 1700 CONTINUE
C
      CALL BENCD( IERR )
C
C------------------------------------------------------------------
 1800 CONTINUE
C 
      RETURN
      END
      
      SUBROUTINE FIXSS
C
C**** *FIXSS*
C
C
C     PURPOSE.
C     --------
C
C         TO FIX PROBLEM BULLETINS WITH T1T2=SS.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *FIXSS*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C*          1. CLEAR PARITI BITS.
C              ------------------
 100  CONTINUE
C
      DO 101 I=IPT,IGS
         KCHAR(I)=KCHAR(I).AND.127
 101  CONTINUE
C
C*          2. CONVERT LETTERS TO FIGURES IF NEEDED.
C              -------------------------------------
 200  CONTINUE
C
      CALL REMEEE
C
      RETURN
      END
      
      SUBROUTINE QLALOM(IQUADR,ILAT,ILONG,MINDIC,ILAT2,ILONG2)
C
C**** *QLALOM*
C
C
C     PURPOSE.
C     --------
C
C         DECODE LATITUDE AND LONGITUDE GIVEN IN THE FORM
C         (QLALALALA) (LOLOLOLOLO) (WMO CODE TABLE 3333 FOR Q)
C
C         INPUT    :  IQUADR   THE QUADRANT OF THE GLOBE (QC)
C                  :  ILAT     LATITUDE IN DEGREES AND MINUTES
C                  :  ILONG    LONGITUDE IN DEGREES AND MINUTES
C                  :  MINDIC   MISSING DATA VALUE
C
C
C         OUTPUT   :  ILAT2  LATITUDE IN HUNDREDTHS OF DEGREE
C                            SOUTHERN LATITUDE NEGATIVE
C                  :  ILONG2:LONGITUDE IN HUNDREDTHS OF DEGREE
C                            WESTERN LONGITUDE NEGATIVE
C
C         ILAT2 AND ILONG2 ARE SET TO MISSING DATA VALUE IF
C         ANY ERRORS FOUND IN LAT,LONG OR QUADRANT
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *QLALOM(IQUADR,ILAT,ILONG,MINDIC,ILAT2,ILONG2)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION ILATSIGN(9),ILONSIGN(9)
C
      DATA ILATSIGN/1,0,-1,0,-1,0, 1,0,0/
      DATA ILONSIGN/1,0, 1,0,-1,0,-1,0,0/
C
C
C
C     ------------------------------------------------------------------
C*          1. SET LAT2 AND LONG2 TO MISSING DATA VALUE.
C              -----------------------------------------
 100  CONTINUE
C
      ILAT2=MINDIC
      ILONG2=MINDIC
C
C
C*          1.1 THE ARRAYS LATSIGN AND LONSIGN ARE USED TO DETERMINE IF
C               LAT. AND LONG. ARE NEGATIVE OR POSITIVE
 110  CONTINUE
C
C     CHECK THAT THE QUADRANT IS CORRECT
C
      IF( IQUADR.EQ.MINDIC          ) RETURN
      IF( IQUADR.EQ.2.OR.IQUADR.EQ.4) RETURN
      IF( IQUADR.EQ.6.OR.IQUADR.EQ.8) RETURN
      IF( IQUADR.EQ.0.OR.IQUADR.EQ.9) RETURN
C
C
C*          1.2  CONVERT MINUTES TO DEGREES
C
 120  CONTINUE
C
      ILADEG = ILAT/100
      ILAMIN = ILAT - ILADEG*100
      ILAMIN = ILAMIN/6. + .5
      ILAT   = ILADEG*10 + ILAMIN
C
      ILODEG = ILONG/100
      ILOMIN = ILONG - ILODEG*100
      ILOMIN = ILOMIN/6. + .5
      ILONG  = ILODEG*10 + ILOMIN
C
C
C     CHECK THAT THE LATITUDE AND LONGITUDE ARE SENSIBLE
C
      IF(ILAT  .LT. 0 .OR. ILAT  .GT. 900) RETURN
C
      IF(ILONG .LT. 0 .OR. ILONG .GT. 1800) RETURN
C
C
      IQ=IQUADR
C
      ILAT2=ILAT*ILATSIGN(IQ)*10
C
      ILONG2=ILONG*ILONSIGN(IQ)*10
C
C
      RETURN
      END
      
      SUBROUTINE QLALOD(IQUADR,ILAT,ILONG,MINDIC,ILAT2,ILONG2)
C
C**** *QLALOD*
C
C
C     PURPOSE.
C     --------
C
C         DECODE LATITUDE AND LONGITUDE GIVEN IN THE FORM
C         (QLALALALALA) (LOLOLOLOLOLO) (WMO CODE TABLE 3333 FOR Q)
C
C         INPUT    :  IQUADR   THE QUADRANT OF THE GLOBE (QC)
C                  :  ILAT     LATITUDE IN  HUNDREDTHS OF DEG.
C                  :  ILONG    LONGITUDE IN HUNDREDTHS FO DEG.
C                  :  MINDIC   MISSING DATA VALUE
C
C
C         OUTPUT   :  ILAT2  LATITUDE IN HUNDREDTHS OF DEGREE
C                            SOUTHERN LATITUDE NEGATIVE
C                  :  ILONG2:LONGITUDE IN HUNDREDTHS OF DEGREE
C                            WESTERN LONGITUDE NEGATIVE
C
C         ILAT2 AND ILONG2 ARE SET TO MISSING DATA VALUE IF
C         ANY ERRORS FOUND IN LAT,LONG OR QUADRANT
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *QLALOD(IQUADR,ILAT,ILONG,MINDIC,ILAT2,ILONG2)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
C
C     ------------------------------------------------------------------
C*          1. SET LAT2 AND LONG2 TO MISSING DATA VALUE.
C              -----------------------------------------
 100  CONTINUE
C
      ILAT2=MINDIC
      ILONG2=MINDIC
C
C
C*          1.1 THE ARRAYS LATSIGN AND LONSIGN ARE USED TO DETERMINE IF
C               LAT. AND LONG. ARE NEGATIVE OR POSITIVE
 110  CONTINUE
C
C     CHECK THAT THE QUADRANT IS CORRECT
C
      IF( IQUADR.EQ.MINDIC          ) RETURN
      IF( IQUADR.EQ.2) RETURN
      IF( IQUADR.EQ.4) RETURN
      IF( IQUADR.EQ.6) RETURN
      IF( IQUADR.EQ.9) RETURN
C
      if(iquadr.eq.1) then
         ilats=1
         ilons=1
      elseif(iquadr.eq.7) then
         ilats=1
         ilons=-1
      elseif(iquadr.eq.3) then
         ilats=-1
         ilons=1
      elseif(iquadr.eq.5) then
         ilats=-1
         ilons=-1
      else
         return
      end if
       
C
C     CHECK THAT THE LATITUDE AND LONGITUDE ARE SENSIBLE
C
      IF(ILAT  .LT. 0 .OR. ILAT  .GT. 9000) RETURN
C
      IF(ILONG .LT. 0 .OR. ILONG .GT. 18000) RETURN
C
C
C
      ILAT2=ILAT*ILATS
C
      ILONG2=ILONG*ILONS
C
C
      RETURN
      END
      
      SUBROUTINE NEXTEQ ( I,J )
C
C**** *NEXTEQ*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT '=' CHARACTER.
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER. I > J INDICATES
C                         CHARACTER NOT FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTEQ(I,J)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.   SCANE BULLETIN FOR NEXT '=' SIGN.
C                ---------------------------------
 100  CONTINUE
C
C     '=' IS 61 .
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 61) RETURN
  101 CONTINUE
C
      I=J
      RETURN
      END
      
      SUBROUTINE EXTINT ( I,N,K )
C
C**** *EXTINT*
C
C
C     PURPOSE.
C     --------
C         EXTRACTS N FIGURES FROM ARRAY 'KCHAR' , STARTING AT
C         WORD I , CONVERTS CHARACTERS TO INTEGER AND PLACES
C         IN WORD K OF 'KINT' .
C
C         INPUT     : I - POINTS TO FIRST CHARACTER TO BE EXTRACTED.
C                     N - NUMBER OF CCITT NO. 5 CHARACTERS TO BE EXTRACTE
C
C         OUTPUT    : I - POINTS TO CHARACTER AFTER THE LAST ONE EXTRACTE
C                         MADE NEGATIVE IF A 'SEPARATOR' IS FOUND IN THE
C                         CHARACTERS BEING EXTRACTED.
C                         IF NEGATIVE , THE ABSOLUTE VALUE IS POSITION OF
C                         'SEPARATOR' ENCOUNTERED .
C                     K - INTEGER VALUE IN WORD K OF 'KINT'. MISSING DATA
C                         VALUE INSERTED IF '/' OR NON DIGIT ENCOUNTERED.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTINT ( I,N,K )*
C
C     AUTHOR.
C     -------
C
C          J. HENNESSY
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /
C
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT N FIGURES.
C                ------------------
 100  CONTINUE
C
      IAC = 0
      IA = IABS(I)
      IB = IA + N - 1
C
C*           1.1 STORE KCHAR(J) SO THAT IT WONT BE ALTERED IN THE SUBROUT
C                --------------------------------------------------------
 110  CONTINUE
C
      DO 111 J=IA,IB
C
      KTEMP=KCHAR(J)
      KTEMP=KCHAR(J)
      KAR = KCHAR(J) .AND. 127
C
C
C          CHECK FOR SPACE,LINE FEED AND CARRIAGE RETURN CHARACTER .
C
           IF ( KAR .EQ. 32 .OR. KAR .EQ. 10 .OR. KAR .EQ. 13)
     C                           THEN
                                      I = - J
                                      KINT(K) = MINDIC
                                      RETURN
                                 END IF
C
C          CHECK FOR / CHARACTER .
C
           IF ( KAR.EQ.47 ) THEN
                                     I = IB + 1
                                     KINT(K) = MINDIC
                                     RETURN
                                  END IF
C
C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( KAR .LT. 48 .OR. KAR .GT. 57 )
     C                      THEN
                                  DO 112 JA=1,11
                                       IF ( KAR .EQ. ILET(JA))
     C                                       KAR = IFIG(JA)
  112                             CONTINUE
                           END IF
C
           IF ( KAR .GE. 48 .AND. KAR .LE. 57 )
     C                             THEN
                                    IAC = (IAC + (KAR.AND.15))*10
                                   ELSE
                                      KINT(K) = MINDIC
                                      I = IB + 1
                                      RETURN
                                   END IF
C
C
C
      KCHAR(J)=KTEMP
C
  111 CONTINUE
C
      KINT(K) = IAC / 10
      I = J
C
C
      RETURN
      END
      
      SUBROUTINE NEXTPRT ( I,J )
C
C**** *NEXTPRT*
C
C
C     PURPOSE.
C     --------
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER. I > J INDICATES
C                         CHARACTER NOT FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTSEP ( I,J )
C
C**** *NEXTSEP*
C
C
C     PURPOSE.
C     --------
C         LOCATE THE NEXT GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS NOT 'CR' OR 'LF' OR 'SPACE'.
C                        'CR' OR 'LF' OR 'SPACE'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE' CHARAC
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTSEP(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTEND ( I,J )
C
C**** *NEXTEND*
C
C
C     PURPOSE.
C     --------
C         FUNCTION  : LOCATE NEXT OCCURRENCE OF EITHER 'CR' OR 'LF'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' CHARACTER.
C                     I > J INDICATES NO CHARACTER FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTEND(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 .
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .EQ. 13 .OR. KAR .EQ. 10 ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRTBULL ( I,M )
C
C**** *PRTBULL*
C
C
C     PURPOSE.
C     --------
C         PRINTS BULLETIN IN ARRAY 'KCHAR'
C
C         INPUT      : BULLETIN IN 'KCHAR' .
C                      I - PRINT STARTS AT CHARACTER I
C                      M - PRINT ENDS AT CHARACTER M .
C
C         OUTPUT     : BULLETIN IS PRINTED . ARRAY 'KCHAR' AND POINTERS
C                      UNCHANGED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTBULL(I,M)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C         *CALL* *NEXTEND(I,J)*
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION LINE(80)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT BULLETIN.
C                ---------------
 100  CONTINUE
C
      IP = I
      J = M
      K = 80
C
C*          1.1  SET OUTPUT LINE TO ALL SPACES .
C                -------------------------------
 110  CONTINUE
C
      DO 111 N=1,K
             LINE(N) = 32
  111 CONTINUE
C
C     LOCATE START AND END OF NEXT LINE OF CHARACTERS ( IF ANY ).
C
      CALL NEXTPRT ( IP,J )
      IF ( IP.GT.J ) RETURN
      JP = IP
      CALL NEXTEND ( JP,J )
      K = JP - IP
C
C     INSERT IN OUTPUT LINE AND SUPPRESS PARITY BIT.
C
      DO 112 N =1,K
             LINE(N) = KCHAR(IP).AND.127
             IP = IP + 1
  112 CONTINUE
C
      WRITE ( *,9900) (LINE(N),N=1,K)
C
C     GET NEXT LINE
C
      GO TO 110
C
 9900 FORMAT (1H ,80A1)
C
      END
      
      SUBROUTINE INITVAR ( IERR )
C
C**** *INITVAR*
C
C
C     PURPOSE.
C     --------
C         DECLARATION OF COMMON AREAS AND INITIALISATION OF
C         VARIABLES.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *INITVAR(IERR)*
C
C           IERR - SET TO 0 .
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER *10 IFA
      CHARACTER CTABBEN*64,CTABBU*24
      CHARACTER*8 YDATE
      CHARACTER*5 YTIME,YFAMILY,YTASK  
C
      INCLUDE 'parameter.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comtab.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
C
C     ------------------------------------------------------------------
C           1.   INITIALISE MISSING DATA INDICATOR.
C                ----------------------------------
 100  CONTINUE
C
      DATA MINDIC / '17777777777'O /
      OPS2=.TRUE.
      NSUB=0
C     -------------------------------------------------------------------
C*          2.   INITIALIZE DEFAULT VALUES FOR ERROR HANDLING OPTIONS.
C                ------------------------------------------------------
 200  CONTINUE
C                'IOPTS' CONTAINS 1 WORD FOR ANY POSSIBLE
C                 BULLETIN TYPE FROM 'TT' OF 'AA' TO 'ZZ' .
C                 BIT SETTINGS HAVE THE FOLLOWING MEANING.
C                 BITS ARE NUMBERED LEFT TO RIGHT , 59 TO 0 .
C
C                 BIT N  = 1 MEANS REPORT WITH ERROR NUMBER N+1 IS TO BE
C                            WRITTEN TO THE ERROR FILE .
C                          0 MEANS REPORT NOT TO BE WRITTEN TO ERROR FILE
C
C
C
C
C                 WORDS 677 AND 678 DEFINE DEFAULT OPTIONS FOR HANDLING O
C                 BULLETIN ERRORS.
C
C                 WORD 678 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS T
C                                      WRITTEN TO THE ERROR FILE.
C                 WORD 677 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS T
C                                      PRINTED.
C                 NO ACTION IF BIT N = 0 .
C
C
C                 DEFAULT FOR HANDLING REPORT ERRORS IS TO WRITE
C                 ALL REPORTS WITH ERRORS TO THE ERROR FILE.
C
C                 DEFAULT BULLETIN HANDLING IS TO DISCARD 'NIL' BULLETINS
C                 SHORT ( LESS THAN 3 LINES ) BULLETINS AND NATIONAL
C                 BULLETINS FROM UK AND FRG. BULLETINS IN ERROR ARE NOT
C                 PRINTED.
C
      DATA IOPTS / 676*'37777777777'O,'0'O,'2'O /
C
C     -------------------------------------------------------------------
C*          3.    CLEAR COUNTERS.
C                 ---------------
 300  CONTINUE
C
C                 NUMBULL : NUMBER OF BULLETINS HANDLED BY DECODING RUN.
C                 NUMBERR : NUMBERS OF BULLETIN ERRORS.
C                 NOER    : NUMBERS OF REPORT ERRORS.
C                 NUMREP  : NUMBERS OF REPORTS HANDLED BY DECODING RUN.
C
      DATA NUMBULL / 0 /
      DATA NUMREP /26*0/
      DATA NUMBERR / 8*0 /
      DATA NOER /1560*0/
      DATA NUMRERR /26*0/
      DATA IMPSTA/2000*0/
      DATA IGRIBS /0/
C
C     -------------------------------------------------------------------
C*          4.   SET END OF FILE INDICATOR.
C                ---------------------------
 400  CONTINUE
C
      DATA IEOF / 0 /
C     -------------------------------------------------------------------
C*          5.   INITIALIZE ERROR INDICATOR.
C                ---------------------------
 500  CONTINUE
C
      IERR = 0
C     -----------------------------------------------------------------
C*          6.   SET UP NUMBER OF BITS PER COMPUTER WORD.
C                ----------------------------------------
 600  CONTINUE
C
      NBPW=32
C     -----------------------------------------------------------------
C*          7.   SET UP BIT MASKS.
C                -----------------
 700  CONTINUE
C
      DATA ( MASKS(J),J=1,32)/
     1                             '1'O,                      '3'O,
     2                             '7'O,                     '17'O,
     3                            '37'O,                     '77'O,
     4                           '177'O,                    '377'O,
     5                           '777'O,                   '1777'O,
     6                          '3777'O,                   '7777'O,
     7                         '17777'O,                  '37777'O,
     8                         '77777'O,                 '177777'O,
     9                        '377777'O,                 '777777'O,
     A                       '1777777'O,                '3777777'O,
     1                       '7777777'O,               '17777777'O,
     2                      '37777777'O,               '77777777'O,
     3                     '177777777'O,              '377777777'O,
     4                     '777777777'O,             '1777777777'O,
     5                    '3777777777'O,             '7777777777'O,
     6                   '17777777777'O,            '37777777777'O  /
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR TABLE B.
C                --------------------
 800  CONTINUE
C
      CALL SETTAB( IERR )
C
C*          9.   GET SUPERVISOR TIME
C
 900  CONTINUE
C
C      READ(*,'(A8,A5,A5,A5)') YDATE,YTIME,YFAMILY,YTASK
C
      RETURN
      END
      
      SUBROUTINE NEXTFIG ( I,K )
C
C**** *NEXTFIG*
C
C
C     PURPOSE.
C     --------
C         LOCATE FIRST WORD CONTAINING A FIGURE IN ARRAY
C         'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT     : BULLETIN IN 'KCHAR' , 1 CHARACTER PER WORD.
C
C         OUTPUT    : I = REQUIRED LOCATION . I > K MEANS NO FIGURE FOUND
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTFIG(I,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   FIND POINTER TO NEXT FIGURE.
C                ----------------------------
 100  CONTINUE
C
C
      I = IABS(I)
      J = I
      DO 101 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .GE. 48 .AND. KAR .LE. 57 ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTLET ( I,K )
C
C**** *NEXTLET*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE FIRST WORD CONTAINING A LETTER IN ARRAY
C         'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT     : BULLETIN IN 'KCHAR' , 1 CHARACTER PER WORD.
C
C         OUTPUT    : I = REQUIRED LOCATION . I > K MEANS NO LETTER FOUND
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTLET(I,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		NONE
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   FIND POINTER TO NEXT LETTER.
C                ----------------------------
 100  CONTINUE
C
C
      I = IABS(I)
      J = I
      DO 110 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .GE. 65 .AND. KAR .LE. 90 ) RETURN
  110 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE EXTGRP ( I,N1,N2,N3,N4,N5,N,IRET )
C
C**** *EXTGRP*
C
C
C     PURPOSE.
C     --------
C         CONVERT GROUP IN THE REPORT
C         TO INTEGERS IN ARRAY 'KINT' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTGRP ( I,N1,N2,N3,N4,N5,N,IRET )
C
C                    I - CONVERSION OF GROUP STARTS IN WORD I
C                        OF ARRAY 'KCHAR' .
C
C                    N1 - NUMBER OF CHARACTERS CONVERTED TO FIRST INTEGER
C                    N2 -    "    "     "          "     " SECOND   "
C                    N3 -    "    "     "          "     "  THIRD   "
C                    N4 -    "    "     "          "     "  FOURTH  "
C                    N5 =    "    "     "          "     "  FIFTH   "
C
C
C                    N - INDEX TO ARRAY 'KINT' , WHERE THE INSERTION OF
C                        INTEGER VALUES STARTS.
C                        VALUES ARE INSERTED IN CONSECUTIVE WORDS.
C
C                    IRET = 0 , ALL CONVERSIONS PERFORMED OK.
C                         = N , ERROR FOUND IN N TH INTEGER CONVERSION.
C
C                    I - POINTS TO CHARACTER AFTER LAST ONE EXTRACTED ,
C                        UNLESS A 'SEPARATOR' (= 'SPACE' , 'LINE FEED',
C                        'CARRIAGE RETURN') IS ENCOUNTERED IN FIGURES
C                        BEING EXTRACTED . IN THIS CASE I IS MADE NEGATIV
C                        WITH THE ABSOLUTE VALUE OF 'I' POINTING TO THE
C                        'SEPARATOR' FOUND. IN THIS CASE ALSO THE WHOLE
C                        GROUP IS DELETED FROM 'KINT'.
C
C                        INTEGER VALUES EXTRACTED PUT IN WORDS N,N+1 ETC
C                        OF ARRAY 'KINT' .
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *EXTINT(I,N,K)*
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION NN(5)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT GROUP OF CHARACTERS.
C                ----------------------------
 100  CONTINUE
C
      NN(1) = N1
      NN(2) = N2
      NN(3) = N3
      NN(4) = N4
      NN(5) = N5
C
      IRET = 0
C
      K = N
C
C
C
C*          1.1  CONVERT GROUP .
C                ---------------
 110  CONTINUE
C
      DO 111 J=1,5
         IF ( NN(J).EQ.0 ) RETURN
         CALL EXTINT ( I,NN(J),K )
         IF ( I.LT.0 ) THEN
                            IRET = J
                               DO 50 JJ=1,5
                               IF(NN(JJ) .EQ. 0) RETURN
                               KINT(N+JJ-1) = MINDIC
50                             CONTINUE
                            RETURN
                       END IF
         K = K + 1
  111 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTVAL ( I,N,K )
C
C**** *NEXTVAL*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE FIRST WORD CONTAINING THE VALUE 'N' IN
C         ARRAY 'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT    : 'KCHAR' CONTAINS ONE BULLETIN , ONE CHARACTER PER
C                    WORD.
C
C         OUTPUT   : I = REQUIRED LOCATION . I > K MEANS VALUE NOT FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTVAL(I,N,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT VALUE.
C                --------------
 100  CONTINUE
C
      I = IABS(I)
      J = I
      DO 101 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .EQ. N ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRTKDEC(IA,K,J,MINDIC)
C
C**** *PRTKDEC*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE DECODED FORMAT ARRAY (KDEC)
C         OF DECODING DATA (PHASE II).
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKDEC(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KDEC' ARRAY
C                      K      - PRINT STARTS AT WORD I.
C                      J      - PRINT STOPS AT WORD J .
C                      MINDIC - MISSING VALUE INDICATOR
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION IA(1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT ARRAY 'KDEC'.
C                -------------------
 100  CONTINUE
C
C
C
      LODATA = .TRUE.
      LODOT = .TRUE.
C
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN DECODED FORMAT ( KDEC ) ',/)
C
C
         DO 101 I=K,J,10
         I2 = I+9
C
            DO 102 JJ=I,I2
            IF(IA(JJ) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 JJ=I2,J
                       IF(IA(JJ) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         IF(I .EQ.  1) WRITE(*,30000) I,(IA(IK),IK=I,I2)
         IF(I .EQ. 11) WRITE(*,40000) I,(IA(IK),IK=I,I2)
         IF(I .GT. 20) WRITE(*,50000) I,(IA(IK),IK=I,I2)
C30000   FORMAT(1H ,2X,I4,4X,6(I10,1X),6X,A4,1X,3(I10,1X))
30000    FORMAT(1H ,2X,I4,4X,6(I10,1X),5X,I5,1X,3(I10,1X))
40000    FORMAT(1H ,2X,I4,4X,2(I10,1X),O10,1X,I10,1X,O10,1X,2(I10,1X),
     C          2(I10,1X),I10)
50000    FORMAT(1H ,2X,I4,4X,10(I10,1X))
C
101      CONTINUE
C
C
      RETURN
      END
      
      SUBROUTINE PRTKINT(IA,K,KL,MINDIC)
C
C**** *PRTKINT*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE INTERMEDIATE FORMAT ARRAY (KINT)
C         OF DECODING DATA (PHASE II).
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKINT(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KINT' ARRAY
C                     K      - PRINT STARTS AT WORD I.
C                     KL      - PRINT STOPS AT WORD J .
C                     MINDIC - MISSING VALUE INDICATOR
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION IA(1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT ARRAY 'KINT'.
C                -------------------
 100  CONTINUE
C
C
      LODATA = .TRUE.
      LODOT = .TRUE.
C
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN INTERMEDIATE FORMAT ( KINT ) ',/)
C
C
         DO 101 I=K,KL,10
         I2 = I+9
C
            DO 102 J=I,I2
            IF(IA(J) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 J=I2,KL
                       IF(IA(J) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         WRITE(*,30000) I,(IA(J),J=I,I2)
30000    FORMAT(1H ,2X,I4,2X,10(I10,1X))
C
C
101      CONTINUE
C
      RETURN
      END
      
      SUBROUTINE WTDRIBU( IERR )                                       
C
C**** *WTDRIBU*                                                        
C
C
C     PURPOSE.
c
C         SET UP BUFR EXPANDED FORMAT FOR DRIBU DATA.
c
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *WTDRIBU( IERR )*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *GBYTE*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       NOV 1991.
C
C                                                           
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(l,O,G), CHARACTER*8(C,H,Y)
C
c      logical l11,l12,l13,l21,l22,l31,l32,l33
c
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comtab.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comident.h'
      INCLUDE 'comkeyc.h'
C
      CHARACTER*9 CVAL,CIDENT
      CHARACTER*24 CUNIT
C
      INCLUDE 'comwtc.h'      ! CONTAIN CVAL ARRAY
      CHARACTER*25 YTIME
C     ------------------------------------------------------------------
C*          1.   INCREASE SUBSETS COUNTER BY ONE.
C                ----------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      NSUB=0
      NSUB=NSUB+1
C------------------------------------------------------------------------
c     a atribuicao para N parou de funcionar talvez por uma alteracao 
c     do compilador FORTRAN
C	N = NSUB
c               -------VERIFICAR OS PROXIMOS RELEASES------
C------------------------------------------------------------------------
      Ns=NSUB
      NT=0
      NC=0
C     ------------------------------------------------------------------
C*          2.   SET UP DRIBU WORKING TABLE.
C                ---------------------------
 200  CONTINUE
C
      DO 201 I=1,JP22
      VALUES(I,NSUB)=999999.
      VALUEW(I,NSUB)=999999.
 201  CONTINUE
C
C*            2.1  SET UP SURFACE OBSERVATION.
C                  ---------------------------
 210  CONTINUE
C
      CALL DATUM(KDEC(1),IMONTH,IYEAR)
      
      L11=.TRUE.     ! DRIBU SURFACE REPORT
C
      IF(KDEC( 7).NE.MINDIC) VALUES(1,NSUB)=FLOAT(KDEC(7))
      IF(KDEC(35).NE.MINDIC) VALUES(2,NSUB)=FLOAT(KDEC(35))         
      IF(KDEC(36).NE.MINDIC) VALUES(3,NSUB)=FLOAT(KDEC(36))/100.
                             VALUES(4,NSUB)=0.
c      IF(KINT(6).NE.MINDIC)  VALUES(5,NSUB)=FLOAT(KINT(6)+1990.
      IF(KINT(6).NE.MINDIC)  VALUES(5,NSUB)=iyear
      IF(KINT(5).NE.MINDIC)  VALUES(6,NSUB)=FLOAT(KINT(5))
                             VALUES(7,NSUB)=FLOAT(KDEC(1))
                             VALUES(8,NSUB)=FLOAT(KDEC(2))
                             VALUES(9,NSUB)=FLOAT(KDEC(9))
                             VALUES(10,NSUB)=FLOAT(KDEC(5))/100.
                             VALUES(11,NSUB)=FLOAT(KDEC(6))/100.
      IF(KDEC(26).NE.MINDIC) VALUES(12,NSUB)=FLOAT(KDEC(26))*10
      IF(KDEC(25).NE.MINDIC) VALUES(13,NSUB)=FLOAT(KDEC(25))*10.
      IF(KDEC(33).NE.MINDIC) VALUES(14,NSUB)=FLOAT(KDEC(33))*10.
      IF(KDEC(32).NE.MINDIC) VALUES(15,NSUB)=FLOAT(KDEC(32))
      IF(KDEC(27).NE.MINDIC) VALUES(16,NSUB)=FLOAT(KDEC(27))
      IF(KDEC(28).NE.MINDIC) VALUES(17,NSUB)=FLOAT(KDEC(28))
      IF(KDEC(29).NE.MINDIC) VALUES(18,NSUB)=FLOAT(KDEC(29))/10.+273.16 
      IF(KDEC(30).NE.MINDIC.AND.KINT(27).NE.9) THEN
                             VALUES(19,NSUB)=FLOAT(KDEC(30))/10.+273.16
      END IF
      IF(KDEC(30).NE.MINDIC.AND.KINT(27).EQ.9) THEN
                             VALUES(20,NSUB)=FLOAT(KDEC(30))
      END IF
                             VALUES(21,NSUB)=999999.
                             VALUES(22,NSUB)=999999.
                             VALUES(23,NSUB)=999999.
                             VALUES(24,NSUB)=999999.
                             VALUES(25,NSUB)=999999.
                             VALUES(26,NSUB)=999999.
                             VALUES(27,NSUB)=999999.
                             VALUES(28,NSUB)=999999.
                             VALUES(29,NSUB)=999999.
                             VALUES(30,NSUB)=999999.
                             VALUES(31,NSUB)=999999.
      IF(KDEC(31).NE.MINDIC) VALUES(32,NSUB)=FLOAT(KDEC(31))/10.+273.16
C
      M=32
C
C
C*          2.2  SEA DEPTH,TEMPERATURES,SALINITY.
C                --------------------------------
 220  CONTINUE
C
C                CHECK IF THERE ARE SOME USEFULL DATA.
C
      IST=41
      INC= 3
      NDATA=0
C
      DO 221 I=1,49
      IF(KDEC(IST).NE.MINDIC.AND.KDEC(IST+1).NE.MINDIC) NDATA=NDATA+1
      IST=IST+INC
 221  CONTINUE
C
      L12=.FALSE.     !  DRIBU SUBSURFACE Z,T,S REPORT
C                                                                      
      IF(NDATA.NE.0) THEN
         L12=.TRUE.                                                      
         NT=NDATA
C
         IF(KDEC( 7).NE.MINDIC) VALUEW(1,NSUB)=FLOAT(KDEC(7))
         IF(KDEC(34).NE.MINDIC) VALUEW(2,NSUB)=FLOAT(KDEC(34))
         IF(KDEC(35).NE.MINDIC) VALUEW(3,NSUB)=FLOAT(KDEC(35))
                                VALUEW(3,NSUB)=0.
c         IF(KINT(6).NE.MINDIC)  VALUEW(5,NSUB)=FLOAT(KINT(6))+1990.
         IF(KINT(6).NE.MINDIC)  VALUEW(5,NSUB)=iyear   
         IF(KINT(5).NE.MINDIC)  VALUEW(6,NSUB)=FLOAT(KINT(5))
                                VALUEW(7,NSUB)=FLOAT(KDEC(1))
                                VALUEW(8,NSUB)=FLOAT(KDEC(2))
                                VALUEW(9,NSUB)=FLOAT(KDEC(9))
                                VALUEW(10,NSUB)=FLOAT(KDEC(5))/100.
                                VALUEW(11,NSUB)=FLOAT(KDEC(6))/100.
                                VALUEW(12,NSUB)=999999.
         IF(KINT(37).NE.MINDIC) VALUEW(13,NSUB)=FLOAT(KINT(37))
                                VALUEW(14,NSUB)=FLOAT(NDATA)
C
         IST=41
         INC= 3
         IV =15
C
         DO 222 I=1,NDATA
C
         IF(KDEC(IST).NE.MINDIC) THEN
            VALUEW(IV,NSUB)=FLOAT(KDEC(IST))
            IF(KDEC(IST+1).NE.MINDIC) THEN
               VALUEW(IV+1,NSUB)=FLOAT(KDEC(IST+1))/100.+273.16
            END IF
            IF(KDEC(IST+2).NE.MINDIC) THEN
               VALUEW(IV+2,NSUB)=FLOAT(KDEC(IST+2))/100.
            END IF
            IV=IV+3
         END IF
C
         IST=IST+INC
C
 222     CONTINUE
C
      END IF
C                CHECK IF THERE ARE SOME USEFULL DATA ABOUT
C                CURRENT
C
      IST=201
      INC= 3
      NDATA=0
C
      DO 223 I=1,49
      IF(KDEC(IST).NE.MINDIC.AND.KDEC(IST+1).NE.MINDIC
     1   .AND.KDEC(IST+2).NE.MINDIC) NDATA=NDATA+1
      IST=IST+INC
 223  CONTINUE
C
      L13=.FALSE.     !  DRIFTER SUBSURFACE Z,DD,CCC REPORT (CURRENT)
C                                                                      
      IF(NDATA.NE.0) THEN
         L13=.TRUE.
         NC=NDATA
C
         IST=201
         INC= 3
C
         IF(L12) THEN
C
C           CURRENT METHOD,REPLICATION FACTOR
C
            IF(KINT(204).NE.MINDIC) VALUEW(IV,NSUB)=KINT(204)
            IV=IV+1
            VALUEW(IV,NSUB)=FLOAT(NDATA)
            IV=IV+1
C
            DO 224 I=1,NDATA
C
            IF(KDEC(IST).NE.MINDIC) THEN
               VALUEW(IV,NSUB)=FLOAT(KDEC(IST))
               IF(KDEC(IST+1).NE.MINDIC) THEN
                  VALUEW(IV+1,NSUB)=FLOAT(KDEC(IST+1)*10)
               END IF
               IF(KDEC(IST+2).NE.MINDIC) THEN
                  VALUEW(IV+2,NSUB)=FLOAT(KDEC(IST+2))/100.
               END IF
               IV=IV+3
            END IF
C
            IST=IST+INC
C
 224        CONTINUE
C
         ELSE
C
            IF(KDEC( 7).NE.MINDIC) VALUEW(1,NSUB)=FLOAT(KDEC(7))
            IF(KDEC(34).NE.MINDIC) VALUEW(2,NSUB)=FLOAT(KDEC(34))
            IF(KDEC(35).NE.MINDIC) VALUEW(3,NSUB)=FLOAT(KDEC(35))
                                   VALUEW(3,NSUB)=0.
c            IF(KINT(6).NE.MINDIC)  VALUEW(5,NSUB)=FLOAT(KINT(6))+1990.
            IF(KINT(6).NE.MINDIC)  VALUEW(5,NSUB)=iyear  
            IF(KINT(5).NE.MINDIC)  VALUEW(6,NSUB)=FLOAT(KINT(5))
                                   VALUEW(7,NSUB)=FLOAT(KDEC(1))
                                   VALUEW(8,NSUB)=FLOAT(KDEC(2))
                                   VALUEW(9,NSUB)=FLOAT(KDEC(9))
                                   VALUEW(10,NSUB)=FLOAT(KDEC(5))/100.
                                   VALUEW(11,NSUB)=FLOAT(KDEC(6))/100.
                                   VALUEW(12,NSUB)=999999.
            IF(KINT(37).NE.MINDIC) VALUEW(13,NSUB)=FLOAT(KINT(37))
                                   VALUEW(14,NSUB)=FLOAT(NDATA)
            IV =15
C
C           CURRENT METHOD,REPLICATION FACTOR
C
            IF(KINT(204).NE.MINDIC) VALUEW(IV,NSUB)=KINT(204)
            IV=IV+1
            VALUEW(IV,NSUB)=FLOAT(NDATA)
            IV=IV+1
C
            DO 225 I=1,NDATA
C
            IF(KDEC(IST).NE.MINDIC) THEN
               VALUEW(IV,NSUB)=FLOAT(KDEC(IST))
               IF(KDEC(IST+1).NE.MINDIC) THEN
                  VALUEW(IV+1,NSUB)=FLOAT(KDEC(IST+1)*10)
               END IF
               IF(KDEC(IST+2).NE.MINDIC) THEN
                  VALUEW(IV+2,NSUB)=FLOAT(KDEC(IST+2))/100.
               END IF
               IV=IV+3
            END IF
C
            IST=IST+INC
C
 225        CONTINUE
C
         END IF
C
      END IF
C
      MS=IV-1
C
      RETURN
      END
      
      SUBROUTINE WTBATHY( IERR )
C
C**** *WTBATHY*
C
C
C     PURPOSE.
C     --------
C         SET UP BUFR EXPANDED FORMAT FOR BATHY DATA.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *WTBATHY( IERR )*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *GBYTE(KS,KD,KSKI,KSI)*
C
C
C     AUTHOR.
C     -------
C                                                                     
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comtab.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comident.h'
C
      CHARACTER*9 CVAL
      CHARACTER*24 CUNIT
C
      INCLUDE 'comwtc.h'      ! CONTAIN CVAL ARRAY
C
      CHARACTER*25 YTIME
C     ------------------------------------------------------------------
C*          1.   INCREASE SUBSETS COUNTER BY ONE.
C                ----------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      NSUB=0
      NSUB=NSUB+1
C------------------------------------------------------------------------
c     a atribuicao para N parou de funcionar talvez por uma alteracao 
c     do compilador FORTRAN
C	N = NSUB
c               -------VERIFICAR OS PROXIMOS RELEASES------
C------------------------------------------------------------------------
      Ns=NSUB
C     ------------------------------------------------------------------
C           2.  SET UP BATHY WORKING TABLE.
C                --------------------------
C
 200  CONTINUE
C
      CALL DATUM(KDEC(1),IMONTH,IYEAR)
C
C*          2.1  SET UP WORKING TABLE FOR BATHY SURFACE REPORT.
C                    ----------------------------------------------
 210  CONTINUE
C
      L21=.FALSE.
C
      DO 211 I=1,JP22
      VALUES(I,NSUB)=999999.
      VALUEW(I,NSUB)=999999.
 211  CONTINUE
C
C           CHECK IF THERE ARE SOME DATA.
C
       IF(KDEC(26).NE.MINDIC.AND.KDEC(27).NE.MINDIC.OR.
     1    KDEC(28).NE.MINDIC)
     2    THEN
             L21=.TRUE.
             VALUES(1,NSUB)=NSUB*1000+9
             CVAL(NSUB)=CHAR(IDENT(1))//CHAR(IDENT(2))//CHAR(IDENT(3))//
     1                  CHAR(IDENT(4))//CHAR(IDENT(5))//CHAR(IDENT(6))//
     2                  CHAR(IDENT(7))//CHAR(IDENT(8))//CHAR(IDENT(9))
C
            VALUES(2,NSUB)=999999.
            VALUES(3,NSUB)=999999.
            VALUES(4,NSUB)=3.
c            VALUES(5,NSUB)=FLOAT(KINT(3))+1990.
            VALUES(5,NSUB)=iyear
            IF(KINT(2).NE.MINDIC)  VALUES(6,NSUB)=FLOAT(KINT(2))
            VALUES(7,NSUB)=FLOAT(KDEC(1))
            VALUES(8,NSUB)=FLOAT(KDEC(2))
            VALUES(9,NSUB)=FLOAT(KDEC(9))
            VALUES(10,NSUB)=FLOAT(KDEC(5))/100.
            VALUES(11,NSUB)=FLOAT(KDEC(6))/100.
            VALUES(12,NSUB)=999999.
            VALUES(13,NSUB)=999999.
            VALUES(14,NSUB)=999999.
            VALUES(15,NSUB)=999999. 
            IF(KDEC(26).NE.MINDIC) THEN
            VALUES(16,NSUB)=FLOAT(KDEC(26))
                                   END IF
            IF(KDEC(27).NE.MINDIC) THEN
            VALUES(17,NSUB)=FLOAT(KDEC(27))
                                   END IF
            IF(KDEC(28).NE.MINDIC) THEN
            VALUES(18,NSUB)=FLOAT(KDEC(28))/10.+273.16
                                   END IF 
            VALUES(19,NSUB)=999999.
            VALUES(20,NSUB)=999999.
            VALUES(21,NSUB)=999999.
            VALUES(22,NSUB)=999999.
            VALUES(23,NSUB)=999999.
            VALUES(24,NSUB)=999999.
            VALUES(25,NSUB)=999999.
            VALUES(26,NSUB)=999999.
            VALUES(27,NSUB)=999999.
            VALUES(28,NSUB)=999999.
            VALUES(29,NSUB)=999999.
            VALUES(30,NSUB)=999999.
            VALUES(31,NSUB)=999999.
            IF(KDEC(39).NE.MINDIC) THEN
            VALUES(32,NSUB)=FLOAT(KDEC(39))/100.+273.16
                                   END IF
C
            M=32
C
          END IF
C
C*           3. BATHY SUB SURFACE TEMPERATURES.
C               -------------------------------
 300  CONTINUE

      L22=.FALSE.      ! BATHY SUB_SURFACE TEMPERATURES..
C
C           CHECK FOR NUMBER OF REPLICATIONS
C
      IST=38
      INC=5
      NDATA=0
C
      DO 301 I=1,49
C
      IF(KDEC(IST).NE.MINDIC) NDATA=NDATA+1
      IST=IST+INC 
C
 301  CONTINUE
C
      IF(NDATA.NE.0) THEN
         L22=.TRUE.
C
         VALUEW(1,NSUB)=NSUB*1000+9
         CVAL(NSUB)=CHAR(IDENT(1))//CHAR(IDENT(2))//CHAR(IDENT(3))//
     1           CHAR(IDENT(4))//CHAR(IDENT(5))//CHAR(IDENT(6))//
     2           CHAR(IDENT(7))//CHAR(IDENT(8))//CHAR(IDENT(9))
C
c         IF(KINT(1).NE.MINDIC) VALUEW(2,NSUB)=FLOAT(KINT(3))+1990.
         IF(KINT(1).NE.MINDIC) VALUEW(2,NSUB)=iyear
         IF(KINT(2).NE.MINDIC) VALUEW(3,NSUB)=FLOAT(KINT(2))
                               VALUEW(4,NSUB)=FLOAT(KDEC(1))
                               VALUEW(5,NSUB)=FLOAT(KDEC(2))
                               VALUEW(6,NSUB)=FLOAT(KDEC(9))
                               VALUEW(7,NSUB)=FLOAT(KDEC(5))/100.
                               VALUEW(8,NSUB)=FLOAT(KDEC(6))/100.
         IF(KINT(17).NE.MINDIC)VALUEW(9,NSUB)=FLOAT(KINT(17))
                            VALUEW(10,NSUB)=FLOAT(NDATA)
C
         IST=38
         INC=5
         IV=10
C
         DO 302 I=1,49
C
         IF(KDEC(IST).NE.MINDIC) THEN
            IV=IV+1
            VALUEW(IV,NSUB)=FLOAT(KDEC(IST))
            IV=IV+1
            IF(KDEC(IST+1).NE.MINDIC)
     1         THEN
                  VALUEW(IV,NSUB)=FLOAT(KDEC(IST+1))/100.+273.16
               ELSE
                  VALUEW(IV,NSUB)=999999.
               END IF
C
            IST=IST+INC
C
         END IF
C
 302     CONTINUE
C
         IV=IV+1
         IF(KINT(142).NE.MINDIC) THEN
            VALUEW(IV,NSUB)=FLOAT(KINT(142))
         ELSE
            VALUEW(IV,NSUB)=999999.
         END IF
C
         IV=IV+1
         IF(KDEC(IST+2).NE.MINDIC) THEN
            VALUEW(IV,NSUB)=FLOAT(KDEC(IST+2))
         ELSE
            VALUEW(IV,NSUB)=999999.
         END IF
         IV=IV+1
         IF(KDEC(IST+3).NE.MINDIC) THEN
            VALUEW(IV,NSUB)=FLOAT(KDEC(IST+3))/100.
         ELSE
            VALUEW(IV,NSUB)=999999.
         END IF
C
         MS=IV
C
      END IF
C
      RETURN
      END
      
      SUBROUTINE WTTESAC( IERR )
C
C**** *WTTESAC*
C
C
C     PURPOSE.
C     --------
C         SET UP BUFR EXPANDED FORMAT FOR TESAC DATA.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *WTTESAC( IERR )*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *GBYTE(KS,KD,KSK1,KSI)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
c      logical l11,l12,l13,l21,l22,l31,l32,l33,lshear
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comtab.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comident.h'
C
      CHARACTER*9 CVAL
      CHARACTER*24 CUNIT
C
      INCLUDE 'comwtc.h'      ! CONTAIN CVAL ARRAY
C
      CHARACTER*25 YTIME
C     ------------------------------------------------------------------
C*          1.   INCREASE SUBSETS COUNTER BY ONE.
C                ----------------------------------
 100  CONTINUE
C
      NSUB=0
      NSUB=NSUB+1
C------------------------------------------------------------------------
c     a atribuicao para N parou de funcionar talvez por uma alteracao 
c     do compilador FORTRAN     
C     N  = NSUB
c               -------VERIFICAR OS PROXIMOS RELEASES------
C------------------------------------------------------------------------
      Ns=NSUB
c
      CALL DATUM(KDEC(1),IMONTH,IYEAR)
c      
      DO 101 I=1,JP22
      VALUES(I,NSUB)=999999.
      VALUEW(I,NSUB)=999999.
 101  CONTINUE
C
C     ------------------------------------------------------------------
C*           2.  SET UP TESAC WORKING TABLE (K=3).
C                ---------------------------------
C
 200  CONTINUE
C
C           CHECK FOR NUMBER OF REPLICATIONS
C
      IST=38
      INC=5
      NT=0
      NC=0
C
C     GET NUMBER OF REPLICATIONS FOR TEMPERATURES AND CURRENT.
C
      DO 201 I=1,49
C
      IF(KDEC(IST).NE.MINDIC.AND.KDEC(IST+1).NE.MINDIC) NT=NT+1
      IF(KDEC(IST).NE.MINDIC.AND.KDEC(IST+3).NE.MINDIC.OR.
     1   KDEC(IST+4).NE.MINDIC) NC=NC+1
C
      IST=IST+INC
C
 201        CONTINUE
C
C
C*           2.1  SET UP WORKING TABLE FOR TESAC SURFACE REPORT.
C                    ----------------------------------------------
 210  CONTINUE
C
      L31=.FALSE.
C
C           CHECK IF THERE ARE SOME DATA.
C
       IF(KDEC(26).NE.MINDIC.AND.KDEC(27).NE.MINDIC.OR.
     1    KDEC(28).NE.MINDIC)
     2    THEN
             L31=.TRUE.
             VALUES(1,NSUB)=NSUB*1000+9
             CVAL(NSUB)=CHAR(IDENT(1))//CHAR(IDENT(2))//CHAR(IDENT(3))//
     1                  CHAR(IDENT(4))//CHAR(IDENT(5))//CHAR(IDENT(6))//
     2                  CHAR(IDENT(7))//CHAR(IDENT(8))//CHAR(IDENT(9))
C
            VALUES(2,NSUB)=999999.
            VALUES(3,NSUB)=999999.
            VALUES(4,NSUB)=3.
c            VALUES(5,NSUB)=FLOAT(KINT(3))+1990.
             VALUES(5,NSUB)=iyear
            IF(KINT(2).NE.MINDIC) VALUES(6,NSUB)=FLOAT(KINT(2))
            VALUES(7,NSUB)=FLOAT(KDEC(1))
            VALUES(8,NSUB)=FLOAT(KDEC(2))
            VALUES(9,NSUB)=FLOAT(KDEC(9))
            VALUES(10,NSUB)=FLOAT(KDEC(5))/100.
            VALUES(11,NSUB)=FLOAT(KDEC(6))/100.
            VALUES(12,NSUB)=999999.
            VALUES(13,NSUB)=999999.
            VALUES(14,NSUB)=999999.
            VALUES(15,NSUB)=999999. 
            IF(KDEC(26).NE.MINDIC)
     1            VALUES(16,NSUB)=FLOAT(KDEC(26))
            IF(KDEC(27).NE.MINDIC)
     1            VALUES(17,NSUB)=FLOAT(KDEC(27))
            IF(KDEC(28).NE.MINDIC)
     1            VALUES(18,NSUB)=FLOAT(KDEC(28))/10.+273.16
            VALUES(19,NSUB)=999999.
            VALUES(20,NSUB)=999999.
            VALUES(21,NSUB)=999999.
            VALUES(22,NSUB)=999999.
            VALUES(23,NSUB)=999999.
            VALUES(24,NSUB)=999999.
            VALUES(25,NSUB)=999999.
            VALUES(26,NSUB)=999999.
            VALUES(27,NSUB)=999999.
            VALUES(28,NSUB)=999999.
            VALUES(29,NSUB)=999999.
            VALUES(30,NSUB)=999999.
            VALUES(31,NSUB)=999999.
            IF(KDEC(39).NE.MINDIC) THEN
            VALUES(32,NSUB)=FLOAT(KDEC(39))/100.+273.16
                                   END IF    
            M=32
C
          END IF
C
C*          3. SET UP SUB_SURFACE  TEMPERATURES....
C              -----------------------------------
 300  CONTINUE
C
      L32=.FALSE.
C
      IF(NT.NE.0) THEN
         L32=.TRUE.
C
      VALUEW(1,NSUB)=NSUB*1000+9
      CVAL(NSUB)=CHAR(IDENT(1))//CHAR(IDENT(2))//CHAR(IDENT(3))//
     1           CHAR(IDENT(4))//CHAR(IDENT(5))//CHAR(IDENT(6))//
     2           CHAR(IDENT(7))//CHAR(IDENT(8))//CHAR(IDENT(9))
C
c      IF(KINT(1).NE.MINDIC) VALUEW(2,NSUB)=FLOAT(KINT(3))+1990.
      IF(KINT(1).NE.MINDIC) VALUEW(2,NSUB)=iyear
      IF(KINT(2).NE.MINDIC) VALUEW(3,NSUB)=FLOAT(KINT(2))
                            VALUEW(4,NSUB)=FLOAT(KDEC(1))
                            VALUEW(5,NSUB)=FLOAT(KDEC(2))
                            VALUEW(6,NSUB)=FLOAT(KDEC(9))
                            VALUEW(7,NSUB)=FLOAT(KDEC(5))/100.
                            VALUEW(8,NSUB)=FLOAT(KDEC(6))/100.
                            VALUEW(9,NSUB)=999999.
      IF(KINT(18).NE.MINDIC)VALUEW(10,NSUB)=FLOAT(KINT(18))
                            VALUEW(11,NSUB)=FLOAT(NT)
C
      IST=38
      INC=5
      IV=11
C
      DO 302 I=1,49
C
      IF(KDEC(IST).NE.MINDIC)
     1   THEN
            IV=IV+1
            VALUEW(IV,NSUB)=FLOAT(KDEC(IST))
            IV=IV+1
            IF(KDEC(IST+1).NE.MINDIC)
     1         THEN
                  VALUEW(IV,NSUB)=FLOAT(KDEC(IST+1))/100.+273.16 
               ELSE
                  VALUEW(IV,NSUB)=999999.
               END IF
            IV=IV+1
            IF(KDEC(IST+2).NE.MINDIC)
     1         THEN
                  VALUEW(IV,NSUB)=FLOAT(KDEC(IST+2))/100.
               ELSE
                  VALUEW(IV,NSUB)=999999.
               END IF
C
         END IF
C
            IST=IST+INC
C
 302              CONTINUE
C
 310  CONTINUE
C
       MS=IV
C
       END IF
C
       L33=.FALSE.
       IF(NC.NE.0) THEN
          L33=.TRUE.
C
      IV=IV+1
C
      IF(KINT(201).NE.MINDIC.AND.
     1   KINT(201).NE.9) THEN   
      VALUEW(IV,NSUB)=FLOAT(KINT(201))
                         ELSE
                            IF(KINT(202).NE.MINDIC.AND.
     1                         KINT(202).NE.9) THEN
                                    VALUEW(IV,NSUB)=FLOAT(KINT(202))
                                               ELSE
                                    VALUEW(IV,NSUB)=31.
                                               END IF
                         END IF
      IV=IV+1
      VALUEW(IV,NSUB)=FLOAT(NC)
C
      IST=38
      INC=5
C
      DO 303 I=1,49
C
      IF(KDEC(IST).NE.MINDIC)
     1   THEN
            IV=IV+1
            VALUEW(IV,NSUB)=FLOAT(KDEC(IST))
            IV=IV+1
            IF(KDEC(IST+3).NE.MINDIC)
     1         THEN
                  VALUEW(IV,NSUB)=FLOAT(KDEC(IST+3))
               ELSE
                  VALUEW(IV,NSUB)=999999.
               END IF
            IV=IV+1
            IF(KDEC(IST+4).NE.MINDIC)
     1         THEN
                  VALUEW(IV,NSUB)=FLOAT(KDEC(IST+4))/100.
               ELSE
                  VALUEW(IV,NSUB)=999999.
               END IF
C
         END IF
C 
            IST=IST+INC
C
 303              CONTINUE
C
      MS=IV
C
      END IF
C 
      RETURN
      END
      
      SUBROUTINE BENCD(IERR )
C
C**** *BENCD*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO ENCODE INDIVIDUAL DRIBU
C         REPORT FROM FULLY EXPANDED BUFR FORMAT
C         INTO BUFR MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BENCD(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *SEC0(IERR)*
C         *CALL* *SEC1D(K,IERR)*
C         *CALL* *SEC2(IERR)*
C         *CALL* *SEC3D(K,IERR)*
C         *CALL* *SEC4(K,IERR)*
C         *CALL* *SEC5(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h' 
C
      CHARACTER*9 CIDENT,CVAL 
      character*24 cunit
C
C     ------------------------------------------------------------------
C*          1.   SET UP *BUFR* MESSAGE.
C                ----------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C
C*          1.1  GET CURRENT DATE(MONTH AND YEAR).
C                --------------------------------- 
 110  CONTINUE
C
      CALL DATUM(KDEC(1),IMONTH,IYEAR)
C     ------------------------------------------------------------------      
      IF(L11) THEN
C
C         SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C
         NBUFTYPE=1
         NTYPE=1       ! SURFACE
         NSBTYPE=21    ! SURFACE DRIBU
C
         NYEAR =iyear
         NMONTH=imonth
         NDAY  =KDEC(1)
         NHOUR =KDEC(2)
         NMINUTE=KDEC(9)
         NSECOND=0
C
         JSCALE=5
         JREFLAT= -9000000
         JREFLON=-18000000
C
         NLAT1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLAT
         NLON1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLON
C
         NLAT2=0  
         NLON2=0
C
         NOBS=NSUB
C             
         IF(VALUES(1,1).EQ.999999) THEN
            CIDENT='XXX      '
         ELSE
            ID=NINT(VALUES(1,1))
            WRITE(CIDENT,'(I5)',err=333) ID
            go to 334
 333        continue
            print*,'WRONG DRIBU IDENT=',id
            CIDENT='XXX      '   
 334        continue 
         END IF
C
         NRECR=1
C
         CALL SETWTD(1,IERR)
         CALL SEC0( IERR )
         CALL SEC1D(1,IERR )
         CALL SEC2( IERR )
         CALL SEC3D(1,IERR )
         CALL SEC4(IERR )
         CALL SEC5( IERR )
         CALL PUTBUFR( 1,IERR )
C
         L11=.FALSE.
C
         RETURN
C
      END IF
C
      IF(.NOT.L13.AND.L12) THEN
C
C         SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C
          NBUFTYPE=31   ! BUFR TABLE A
          NTYPE=6       ! RDB TYPE OCEANOGRAPHIC
          NSBTYPE=131     ! DRIBU
C
          NYEAR =iyear
          NMONTH=imonth
          NDAY  =KDEC(1)
          NHOUR =KDEC(2)
          NMINUTE=KDEC(9)
          NSECOND=0
C
          JSCALE=5
          JREFLAT= -9000000
          JREFLON=-18000000
C
          NLAT1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLAT
          NLON1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLON
C
          NLAT2=0  
          NLON2=0
C
          NOBS=NSUB
          IF(VALUES(1,1).EQ.999999) THEN
             CIDENT='XXX      '
          ELSE
             ID=NINT(VALUES(1,1))
             WRITE(CIDENT,'(I5)',err=335) ID
             go to 336
 335         continue
             print*,'WRONG DRIBU IDENT=',id
             CIDENT='XXX      '
 336         continue 
          END IF
C
          NRECR=1
C
          CALL SETWTD(2,IERR)
          CALL SEC0( IERR )
          CALL SEC1D(1,IERR )
          CALL SEC2( IERR )
          CALL SEC3D(2,IERR )
          CALL SEC4( IERR )
          CALL SEC5( IERR )
          CALL PUTBUFR( 2,IERR )
C
          L12=.FALSE.
       END IF
C
      IF(L12.AND.L13) THEN
C
C         SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C
          NBUFTYPE=31   ! BUFR TABLE A
          NTYPE=6       ! RDB TYPE OCEANOGRAPHIC
          NSBTYPE=131     ! DRIBU
C
          NYEAR =iyear
          NMONTH=imonth
          NDAY  =KDEC(1)
          NHOUR =KDEC(2)
          NMINUTE=KDEC(9)
          NSECOND=0
C
          JSCALE=5
          JREFLAT= -9000000
          JREFLON=-18000000
C
          NLAT1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLAT
          NLON1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLON
C
          NLAT2=0  
          NLON2=0
C
          NOBS=NSUB
          IF(VALUES(1,1).EQ.999999) THEN
             CIDENT='XXX      '
          ELSE
             ID=NINT(VALUES(1,1))
             WRITE(CIDENT,'(I5)',err=337) ID
             go to 338
 337         continue
             print*,'WRONG DRIBU IDENT=',id
             CIDENT='XXX      '
 338         continue 
          END IF
C
          NRECR=1
C
          CALL SETWTD(3,IERR)
          CALL SEC0( IERR )
          CALL SEC1D(1,IERR )
          CALL SEC2( IERR )
          CALL SEC3D(3,IERR )
          CALL SEC4( IERR )
          CALL SEC5( IERR )
          CALL PUTBUFR( 3,IERR )
C
          L12=.FALSE.
          L13=.FALSE.
C      
       END IF
C
      IF(.NOT.L12.AND.L13) THEN
C
C         SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C
          NBUFTYPE=31   ! BUFR TABLE A
          NTYPE=6       ! RDB TYPE OCEANOGRAPHIC
          NSBTYPE=131     ! DRIBU
C
          NYEAR =iyear
          NMONTH=imonth
          NDAY  =KDEC(1)
          NHOUR =KDEC(2)
          NMINUTE=KDEC(9)
          NSECOND=0
C
          JSCALE=5
          JREFLAT= -9000000
          JREFLON=-18000000
C
          NLAT1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLAT
          NLON1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLON
C
          NLAT2=0  
          NLON2=0
C
          NOBS=NSUB
          IF(VALUES(1,1).EQ.999999) THEN
             CIDENT='XXX      '
          ELSE
             ID=NINT(VALUES(1,1))
             WRITE(CIDENT,'(I5)',err=339) ID
             go to 340
 339         continue
             print*,'WRONG DRIBU IDENT=',id
             CIDENT='XXX      '
 340         continue 
          END IF
C
          NRECR=1
C
          CALL SETWTD(4,IERR)
          CALL SEC0( IERR )
          CALL SEC1D(1,IERR )
          CALL SEC2( IERR )
          CALL SEC3D(4,IERR )
          CALL SEC4( IERR )
          CALL SEC5( IERR )
          CALL PUTBUFR( 4,IERR )
C
          L13=.FALSE.
       END IF
C     ------------------------------------------------------------------
 200  CONTINUE
C
C
      RETURN
      END
      
      SUBROUTINE BENCB(IERR )
C
C**** *BENCB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO ENCODE INDIVIDUAL BATHY
C         REPORT FROM FULLY EXPANDED BUFR FORMAT
C         INTO BUFR MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BENCB(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *SEC0(IERR)*
C         *CALL* *SEC1B(K,IERR)*
C         *CALL* *SEC2(IERR)*
C         *CALL* *SEC3B(K,IERR)*
C         *CALL* *SEC4(K,IERR)*
C         *CALL* *SEC5(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h' 
C
      CHARACTER*9 CIDENT,CVAL
      character*24 cunit
C
C     ------------------------------------------------------------------
C*          1.   SET UP *BUFR* MESSAGE.
C                ----------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C
C*          1.1  GET CURRENT DATE(MONTH AND YEAR).
C                --------------------------------- 
 110  CONTINUE
C
      CALL DATUM(KDEC(1),IMONTH,IYEAR)
C     ------------------------------------------------------------------
      IF(L21) THEN
C
C         SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C
                 NBUFTYPE=1   ! BUFR TABLE A
                 NTYPE=1       ! SURFACE
                 NSBTYPE=22     ! SURFACE BATHY
C
                 NYEAR =iyear
                 NMONTH=imonth
                 NDAY  =KDEC(1)
                 NHOUR =KDEC(2)
                 NMINUTE=KDEC(9)
                 NSECOND=0
C
                 JSCALE=5
                 JREFLAT= -9000000
                 JREFLON=-18000000
C
                 NLAT1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLAT
                 NLON1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLON
C
                 NLAT2=0  
                 NLON2=0
C
                 NOBS=NSUB
C
                 CIDENT= CVAL(NSUB)
                 NRECR=1
C
C           PACK SURFACE BATHY REPORT
C
                 CALL SETWTB(1,IERR)
                 CALL SEC0( IERR )
                 CALL SEC1B(1,IERR )
                 CALL SEC2( IERR )
                 CALL SEC3B(1,IERR )
                 CALL SEC4( IERR )
                 CALL SEC5( IERR )
                 CALL PUTBUFR( 1,IERR )
C
                 L21=.FALSE.   
C
                 RETURN
C
              END IF
C
      IF(L22) THEN
C
C         SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C
                 NBUFTYPE=31   ! BUFR TABLE A
                 NTYPE=6       ! OCEANOGRAPHIC
                 NSBTYPE=132    ! BATHY
C
                 NYEAR =iyear
                 NMONTH=imonth
                 NDAY  =KDEC(1)
                 NHOUR =KDEC(2)
                 NMINUTE=KDEC(9)
                 NSECOND=0
C
                 JSCALE=5
                 JREFLAT= -9000000
                 JREFLON=-18000000
C
                 NLAT1=NINT(VALUES(7,NSUB)*10.**JSCALE)-JREFLAT
                 NLON1=NINT(VALUES(8,NSUB)*10.**JSCALE)-JREFLON
C
                 NLAT2=0  
                 NLON2=0
C
                 NOBS=NSUB
C
                 CIDENT= CVAL(NSUB)
                 NRECR=1
C
                 CALL SETWTB(2,IERR)
                 CALL SEC0( IERR )
                 CALL SEC1B(2,IERR )
                 CALL SEC2( IERR )
                 CALL SEC3B(2,IERR )
                 CALL SEC4( IERR )
                 CALL SEC5( IERR )
                 CALL PUTBUFR( 2,IERR )
C
                 L22=.FALSE.  
C
              END IF
C     -----------------------------------------------------------------
 200  CONTINUE
C
C
      RETURN
      END
      
      SUBROUTINE BENCT(IERR )
C
C**** *BENCT*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO ENCODE INDIVIDUAL TESAC
C         REPORT FROM FULLY EXPANDED BUFR FORMAT
C         INTO BUFR MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BENCT(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *SEC0(IERR)*
C         *CALL* *SEC1T(K,IERR)*
C         *CALL* *SEC2(IERR)*
C         *CALL* *SEC3T(K,IERR)*
C         *CALL* *SEC4(K,IERR)*
C         *CALL* *SEC5(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h' 
C
      CHARACTER*9 CIDENT,CVAL      
      character*24 cunit
C
C     ------------------------------------------------------------------
C*          1.   SET UP *BUFR* MESSAGE.
C                ----------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C
C*          1.1  GET CURRENT DATE(MONTH AND YEAR).
C                --------------------------------- 
 110  CONTINUE
C
      CALL DATUM(KDEC(1),IMONTH,IYEAR)
C     ------------------------------------------------------------------
      IF(L31) THEN
C
C         SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C
                 NBUFTYPE=1   ! BUFR TABLE A
                 NTYPE=1       ! SURFACE
                 NSBTYPE=23    ! SURFACE TESAC
C
                 NYEAR =iyear
                 NMONTH=imonth
                 NDAY  =KDEC(1)
                 NHOUR =KDEC(2)
                 NMINUTE=KDEC(9)
                 NSECOND=0
C
                 JSCALE=5
                 JREFLAT= -9000000
                 JREFLON=-18000000
C
                 NLAT1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLAT
                 NLON1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLON
C
                 NLAT2=0  
                 NLON2=0
C
                 NOBS=NSUB
C
                 CIDENT= CVAL(NSUB)
                 NRECR=1
C
                 CALL SETWTT(1,IERR)
                 CALL SEC0( IERR )
                 CALL SEC1T(1,IERR )
                 CALL SEC2( IERR )
                 CALL SEC3T(1,IERR )
                 CALL SEC4( IERR )
                 CALL SEC5( IERR )
                 CALL PUTBUFR( 1,IERR )
C
                 L31=.FALSE.
C
                 RETURN   
C
              END IF
C
      IF(L32.AND..NOT.L33)
     1        THEN
C
C         SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C
                 NBUFTYPE=31   ! BUFR TABLE A
                 NTYPE=6       ! OCEANOGRAPHIC
                 NSBTYPE=133    ! TESAC
C
                 NYEAR =iyear
                 NMONTH=imonth
                 NDAY  =KDEC(1)
                 NHOUR =KDEC(2)
                 NMINUTE=KDEC(9)
                 NSECOND=0
C
                 JSCALE=5
                 JREFLAT= -9000000
                 JREFLON=-18000000
C
                 NLAT1=NINT(VALUES(7,NSUB)*10.**JSCALE)-JREFLAT
                 NLON1=NINT(VALUES(8,NSUB)*10.**JSCALE)-JREFLON
C
                 NLAT2=0  
                 NLON2=0
C
                 NOBS=NSUB
C
                 CIDENT= CVAL(NSUB)
                 NRECR=1
C
                 CALL SETWTT(2,IERR)
                 CALL SEC0( IERR )
                 CALL SEC1T(2,IERR )
                 CALL SEC2( IERR )
                 CALL SEC3T(2,IERR )
                 CALL SEC4( IERR )
                 CALL SEC5( IERR )
                 CALL PUTBUFR( 2,IERR )
C
                 L32=.FALSE.
C
                 RETURN  
C
              END IF
C
      IF(L32.AND.L33) THEN
C
C         SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C
                 NBUFTYPE=31   ! BUFR TABLE A
                 NTYPE=6       ! OCEANOGRAPHIC
                 NSBTYPE=133    ! TESAC
C
                 NYEAR =iyear
                 NMONTH=imonth
                 NDAY  =KDEC(1)
                 NHOUR =KDEC(2)
                 NMINUTE=KDEC(9)
                 NSECOND=0
C
                 JSCALE=5
                 JREFLAT= -9000000
                 JREFLON=-18000000
C
                 NLAT1=NINT(VALUES(7,NSUB)*10.**JSCALE)-JREFLAT
                 NLON1=NINT(VALUES(8,NSUB)*10.**JSCALE)-JREFLON
C
                 NLAT2=0  
                 NLON2=0
C
                 NOBS=NSUB
C
                 CIDENT= CVAL(NSUB)
                 NRECR=1
C
                 CALL SETWTT(3,IERR)
                 CALL SEC0( IERR )
                 CALL SEC1T(3,IERR )
                 CALL SEC2( IERR )
                 CALL SEC3T(3,IERR )
                 CALL SEC4( IERR )
                 CALL SEC5( IERR )
                 CALL PUTBUFR( 2,IERR )
C
                 L32=.FALSE.
                 L33=.FALSE.
C
              END IF
C     ------------------------------------------------------------------
 200  CONTINUE
C
C 
      RETURN
      END
      
      SUBROUTINE OCTNUM(KWPTB,KBPTB)
C
C**** *OCTNUM*
C
C
C     PURPOSE.
C     --------
C             CALCULATE NUMBER OF OCTETS FROM BIT POSITION DEFINED BY
C     KWPT,KBPT  AND KWPTB,KBPTB; NUMBER OF OCTETS MUST BE EVEN. IF IT IS
C     NEEDED PADING WITH 0 BIT PERFORMS. NUMBER OF OCTETS IS WRITTEN AT
C     BEGINIG OF THE SECTION.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C
C     EXTERNALS.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C      *CALL* *SBYTE(KD,KS,KSKIP,KSIZE)
C
C             *KD*    - DESTINATION
C             *KS*    - SOURCE
C             *KSKIP* - NUMBER OF BITS TO BE SKIPPED
C             *KSIZE* - BIT LENGTH
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       07/10/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C*          1.    CALCULATE NUMBER OF OCTETS.
C                 ---------------------------
 100  CONTINUE
C
      IB   =(NWPT-1) * NBPW + NBPT
      IBB  =(KWPTB-1)* NBPW + KBPTB
C
      IDIFB= IB - IBB
C
      NOCT = IDIFB/8
      IBDW = IDIFB - NOCT*8
C
      IF(IBDW .NE.0)THEN
                       NOCT=NOCT+1
                       IBDW=8-IBDW
                       CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
                    END IF
C
C     ------------------------------------------------------------------
C*          2.  CHECK IF THERE ARE EVEN NUMBER OF OCTETS IN BLOCK.
C               --------------------------------------------------
 200  CONTINUE
C
      IF(MOD(NOCT,2).NE.0) THEN
          IBDW = 8
          CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
          NOCT = NOCT+1
      END IF
C     ------------------------------------------------------------------
C*          3.  WRITE NUMBER OF OCTETS AT BEGINING OF BLOCK.
C               --------------------------------------------
 300  CONTINUE
C
      IBDW  = 24
      CALL SBYTE(MBUF(KWPTB),NOCT,KBPTB,IBDW)
C
      RETURN
      END
      
      SUBROUTINE PACK(KBPW,KD,KS,KWPT,KBPT,KSI)
C
C**** *PACK*
C
C
C     PURPOSE.
C     --------
C            PURPOSE OF THIS ROUTINE IS TO PACK VALUE *KS* IN
C         *KSI* BITS, STARTED AT WORD KWPT OF ARRAY *KD* AFTER
C         SKIPPING NBPT BITS.  AT THE END
C         POINTERS *NWPT* AND *NBPT* ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C     EXTERNALS.
C     ----------
C
C
C            *CALL SBYTE(KD,KS,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       09/06/86.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION KD(*)
C
C     ------------------------------------------------------------------
C*          1.   SET UP BIT PATTERN.
C                -------------------
C
 100  CONTINUE
C
      CALL SBYTE(KD,KS,KBPT,KSI)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSI
C
      IF(KBPT.GE.KBPW) THEN
                          KW  = KBPT/ KBPW
                          KBPT= KBPT - KW * KBPW
                          KWPT= KWPT +KW
                       END IF
C
      RETURN
      END
      
      SUBROUTINE SEC0( IERR )
C
C**** *SEC0*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 0 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC0(IERR)*
C
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 0 ( INDICATOR SECTION )
C                --- --  ------- -   --------- -------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 -------------------------------------------------------
 110  CONTINUE
C
      NWPT= 2
      NBPT= 0
C
C     B IS CCITT.5 DECIMAL 66
C     U IS CCITT.5 DECIMAL 85
C     F IS CCITT.5 DECIMAL 70
C     R IS CCITT.5 DECIMAL 82
C
      CALL PACK(NBPW,MBUF(NWPT),66,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),85,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),70,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),82,NWPT,NBPT,8)
C
C            Bufr Edition 2
C
      CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT,24)
      CALL PACK(NBPW,MBUF(NWPT), 2,NWPT,NBPT,8)
C
      RETURN
      END
      
      SUBROUTINE SEC1D(K,IERR )
C
C**** *SEC1*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 1 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC1D(K,IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 1 ( IDENTIFICATION SECTION).
C                --------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0) RETURN
      IF(K.NE.1.AND.K.NE.2) THEN
                              IERR=1
                              RETURN
                           END IF
      IF(K.EQ.1) THEN
                    IYEAR =NINT(VALUES(5,1))
                    icen = (iyear * .01)
                    IYEAR=iYEAR - (icen * 100)
                    IMONTH=NINT(VALUES(6,1))
                    IDAY  =NINT(VALUES(7,1))
                    IHOUR =NINT(VALUES(8,1))
                    IMIN  =NINT(VALUES(9,1))
                 END IF
C     ------------------------------------------------------------------
C*          2.   KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 200  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          3.   SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 300  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          4.   BUFR MASTER TABLE( ZERO IF STANDARD WMO FM - 94 USED
C                ----------------------------------------------------
 400  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          5.   SET UP ORIGINATING CENTRE.
C                --------------------------
 500  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),46,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          6.   SET UP UPDATE SEQUENCE NUMBER.
C                ------------------------------
 600  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C
C     ------------------------------------------------------------------
C*          7.   SET UP PRESENCE OF SECTION 2.
C                -----------------------------
 160  CONTINUE
C
      IPS2=0
      IF(OPS2) IPS2=128
      CALL PACK(NBPW,MBUF(NWPT),IPS2,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.7  SET UP BUFR MESSAGE TYPE.
C                -------------------------
 700  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NBUFTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR MESSAGE SUB-TYPE.
C                -----------------------------
 800  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NSBTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          9.   VERSION NUMBER OF MASTER TABLE USED.
C                ------------------------------------
 900  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT,8)
C
C*          9.1  VERSION NUMBER OF LOCAL TABLES USED.
C                ------------------------------------
 910  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          10.  SET UP YEAR OF CENTURY.
C                -----------------------
 1000 CONTINUE
C
      IYEAR =NYEAR
      icen = (iyear * .01)
      IYEAR=iYEAR - (icen * 100)
      if (iyear .eq. 0) iyear=100
c      print*,'SET UP YEAR OF CENTURY',iyear
      CALL PACK(NBPW,MBUF(NWPT),IYEAR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          11.  SET UP MONTH.
C                -------------
 1100 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NMONTH,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          12.  SET UP DAY.
C                -----------
 1200 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NDAY,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          13.  SET UP HOUR.
C                -------------
 1300 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NHOUR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          14.  SET UP MINUTE.
C                --------------
 1400 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NMINUTE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          15.  SET UP LENGTH OF THE SECTION 1.
C                --------------------------------
 1500 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
C
 1600 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC1B(K,IERR )
C
C**** *SEC1*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 1 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC1B(K,IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 1 ( IDENTIFICATION SECTION).
C                --------------------------------------------
 100  CONTINUE
C
      IF(K.NE.1.AND.K.NE.2) THEN
                              IERR=1
                              RETURN
                           END IF
      IF(K.EQ.1) THEN
                    IYEAR=NINT(VALUES(5,1))
                    icen = (iyear * .01)
                    IYEAR=iYEAR - (icen * 100)
                    IMONTH=NINT(VALUES(6,1))
                    IDAY  =NINT(VALUES(7,1))
                    IHOUR =NINT(VALUES(8,1))
                    IMIN  =NINT(VALUES(9,1))
                 END IF
      IF(K.EQ.2) THEN
                    IYEAR=VALUES(2,1)
                    icen = (iyear * .01)
                    IYEAR=iYEAR - (icen * 100)
                    IMONTH=NINT(VALUES(3,1))
                    IDAY  =NINT(VALUES(4,1))
                    IHOUR =NINT(VALUES(5,1))
                    IMIN  =NINT(VALUES(6,1))
                 END IF
C     ------------------------------------------------------------------
C*          2.   KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 200  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          3.   SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 300  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          4.   BUFR MASTER TABLE( ZERO IF STANDARD WMO FM - 94 USED
C                ----------------------------------------------------
 400  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          5.   SET UP ORIGINATING CENTRE.
C                --------------------------
 500  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),98,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          6.   SET UP UPDATE SEQUENCE NUMBER.
C                ------------------------------
 600  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C
C     ------------------------------------------------------------------
C*          7.   SET UP PRESENCE OF SECTION 2.
C                -----------------------------
 160  CONTINUE
C
      IPS2=0
      IF(OPS2) IPS2=128
      CALL PACK(NBPW,MBUF(NWPT),IPS2,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.7  SET UP BUFR MESSAGE TYPE.
C                -------------------------
 700  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NBUFTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR MESSAGE SUB-TYPE.
C                -----------------------------
 800  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NSBTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          9.   VERSION NUMBER OF MASTER TABLE USED.
C                ------------------------------------
 900  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT,8)
C
C*          9.1  VERSION NUMBER OF LOCAL TABLES USED.
C                ------------------------------------
 910  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          10.  SET UP YEAR OF CENTURY.
C                -----------------------
 1000 CONTINUE
C
      IYEAR=NYEAR
      icen = (iyear * .01)
      IYEAR=iYEAR - (icen * 100)
      if (iyear.eq.0) iyear=100
c      print*,'YEAR OF CENTURY',iyear
      CALL PACK(NBPW,MBUF(NWPT),IYEAR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          11.  SET UP MONTH.
C                -------------
 1100 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NMONTH,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          12.  SET UP DAY.
C                -----------
 1200 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NDAY,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          13.  SET UP HOUR.
C                -------------
 1300 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NHOUR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          14.  SET UP MINUTE.
C                --------------
 1400 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NMINUTE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          15.  SET UP LENGTH OF THE SECTION 1.
C                --------------------------------
 1500 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
C
 1600 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC1T(K,IERR )
C
C**** *SEC1*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 1 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC1T(K,IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 1 ( IDENTIFICATION SECTION).
C                --------------------------------------------
 100  CONTINUE
C
      IF(K.NE.1.AND.K.NE.2.AND.K.NE.3) THEN
         IERR=1
         RETURN
      END IF
      IF(K.EQ.1) THEN
         IYEAR =NINT(VALUES(5,1))
         icen = (iyear * .01)
         IYEAR=iYEAR - (icen * 100)
         IMONTH=NINT(VALUES(6,1))
         IDAY  =NINT(VALUES(7,1))
         IHOURN=NINT(VALUES(8,1))
         IMIN  =NINT(VALUES(9,1))
      END IF
      IF(K.EQ.2.OR.K.EQ.3) THEN
         IYEAR =NINT(VALUES(2,1))
         icen = (iyear * .01)
         IYEAR=iYEAR - (icen * 100)
         IMONTH=NINT(VALUES(3,1))
         IDAY  =NINT(VALUES(4,1))
         IHOUR =NINT(VALUES(5,1))
         IMIN  =NINT(VALUES(6,1))
      END IF
C
C     ------------------------------------------------------------------
C*          2.   KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 200  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          3.   SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 300  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          4.   BUFR MASTER TABLE( ZERO IF STANDARD WMO FM - 94 USED
C                ----------------------------------------------------
 400  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          5.   SET UP ORIGINATING CENTRE.
C                --------------------------
 500  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),98,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          6.   SET UP UPDATE SEQUENCE NUMBER.
C                ------------------------------
 600  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C
C     ------------------------------------------------------------------
C*          7.   SET UP PRESENCE OF SECTION 2.
C                -----------------------------
 160  CONTINUE
C
      IPS2=0
      IF(OPS2) IPS2=128
      CALL PACK(NBPW,MBUF(NWPT),IPS2,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.7  SET UP BUFR MESSAGE TYPE.
C                -------------------------
 700  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NBUFTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR MESSAGE SUB-TYPE.
C                -----------------------------
 800  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NSBTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          9.   VERSION NUMBER OF MASTER TABLE USED.
C                ------------------------------------
 900  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT,8)
C
C*          9.1  VERSION NUMBER OF LOCAL TABLES USED.
C                ------------------------------------
 910  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          10.  SET UP YEAR OF CENTURY.
C                -----------------------
 1000 CONTINUE
C
      IYEAR=NYEAR
      icen = (iyear * .01)
      IYEAR=iYEAR - (icen * 100)
      if (iyear .eq. 0) iyear=100
      CALL PACK(NBPW,MBUF(NWPT),IYEAR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          11.  SET UP MONTH.
C                -------------
 1100 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NMONTH,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          12.  SET UP DAY.
C                -----------
 1200 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NDAY,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          13.  SET UP HOUR.
C                -------------
 1300 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NHOUR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          14.  SET UP MINUTE.
C                --------------
 1400 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NMINUTE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          15.  SET UP LENGTH OF THE SECTION 1.
C                --------------------------------
 1500 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
C
 1600 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC5( IERR )
C
C**** *SEC5*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 5 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC5(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 5 ( END SECTION ).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 ------------------------------------------------------
 110  CONTINUE
C
C
C     7 IS CCITT.5 DECIMAL 55
C
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
C
C                                                                       
C*          1.3  SET TOTAL LENGTH OF BUFR MESSAGE.
C                ---------------------------------
 130  CONTINUE
C
      IBYTES=(NWPT-2)*NBPW/8+NBPT/8
C
C*          1.4  SET TOTAL LENGTH OF BUFR MESSAGE IN SECTION 0.
C                ----------------------------------------------
 140  CONTINUE
C
C        FOR BUFR EDITION 2 LENGTH OF MESSAGE STARTS AT 5 TH BYTE.
C
      IWPT= 32/NBPW + 2
      IBPT= 32 - (IWPT-1)* NBPW
      ibpt =0	
C
      CALL PACK(NBPW,MBUF(IWPT),IBYTES,IWPT,IBPT,24)
C
      RETURN
      END
      
      SUBROUTINE SEC2( IERR )
C
C**** *SEC2*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 2 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC2(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 2 ( OPTIONA SECTION).
C                -------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
      IF(.NOT. OPS2 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP RDB KEY (48 BYTES ).
C                ---------------------------
 140  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
C
C     ------------------------------------------------------------------
C*          1.5  SET UP LENGTH OF THE SECTION 2.
C                ------------------------------
 150  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC3D(K,IERR )
C
C**** *SEC3D*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 3 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC3D(K,IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 3 ( DATA DESCRIPTION SECTION ).
C                -----------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
      IF(K.LT.1.AND.K.GT.4) THEN
                              IERR=1
                              RETURN
                           END IF
C
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP NUMBER OF DATA SUB-SETS.
C                -------------------------------
 140  CONTINUE
C
c          ---- verificar a variavel a que foi atribuida  NSUB ----

      CALL PACK(NBPW,MBUF(NWPT),Ns,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          1.5  SET UP INFORMATION ABOUT TYPE OF DATA AND COMPRESSION.
C                ------------------------------------------------------
 150  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),128,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.6  SET UP COLLECTION OF DESCRIPTORS TO DEFINE DATA.
C                --------------------------------------------------
 160  CONTINUE
C
C     DRIBU SURFACE LAND OBSERVATION
C
      IF(K.EQ.1) THEN
         CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),8,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 8)
C
C        CHECK IF Q/C PERFORMED.
C
         IBIT1=0
         DO 161 I=M+1,M+M
         IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 161     CONTINUE
C
         IF(IBIT1.EQ.0) GO TO 170
C
         MQ=M+4
C
         CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
      END IF
C
      IF(K.EQ.2) THEN
         CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),35,NWPT,NBPT, 8)
         CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),6,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 8)
C
C        CHECK IF Q/C PERFORMED.
C
         IBIT1=0
         DO 162 I=M+1,M+M
         IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 162     CONTINUE
C   
         IF(IBIT1.EQ.0) GO TO 170
C
C
         MQ=M+4
C
         CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
      END IF
C
      IF(K.EQ.3) THEN
         CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),35,NWPT,NBPT, 8)
         CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),6,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 8)
         CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),6,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),5,NWPT,NBPT, 8)
C
C        CHECK IF Q/C PERFORMED.
C
         IBIT1=0
         DO 163 I=M+1,M+M
         IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 163     CONTINUE
C   
         IF(IBIT1.EQ.0) GO TO 170
C
C
         MQ=M+4
C
         CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
      END  IF
C
      IF(K.EQ.4) THEN
         CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),35,NWPT,NBPT, 8)
         CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),6,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),5,NWPT,NBPT, 8)
C
C        CHECK IF Q/C PERFORMED.
C
         IBIT1=0
         DO 164 I=M+1,M+M
         IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 164     CONTINUE
C   
         IF(IBIT1.EQ.0) GO TO 170
C
C
         MQ=M+4
C
         CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
      END  IF
C     ------------------------------------------------------------------
C*          1.7  SET UP LENGTH OF THE SECTION 3.
C                -------------------------------
 170  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC3B(K,IERR )
C
C**** *SEC3B*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 3 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC3B(K,IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 3 ( DATA DESCRIPTION SECTION ).
C                -----------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
      IF(K.NE.1.AND.K.NE.2) THEN
                              IERR=1
                              RETURN
                           END IF
C
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP NUMBER OF DATA SUB-SETS.
C                -------------------------------
 140  CONTINUE
C
c          ---- verificar a variavel a que foi atribuida  NSUB ----

      CALL PACK(NBPW,MBUF(NWPT),Ns,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          1.5  SET UP INFORMATION ABOUT TYPE OF DATA AND COMPRESSION.
C                ------------------------------------------------------
 150  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),128,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.6  SET UP COLLECTION OF DESCRIPTORS TO DEFINE DATA.
C                --------------------------------------------------
 160  CONTINUE
C
C     BATHY SURFACE LAND OBSERVATION
C
      IF(K.EQ.1) THEN
      CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),8,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 8)
C
C     CHECK IF Q/C PERFORMED.
C
      IBIT1=0
      DO 161 I=M+1,M+M
         IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 161  CONTINUE
C
      IF(IBIT1.EQ.0) GO TO 170
C
C
      MQ=M+4
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
                 END IF
      IF(K.EQ.2) THEN
      CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),15,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
      CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),6,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 8)
C
C     CHECK IF Q/C PERFORMED.
C
      IBIT1=0
      DO 162 I=M+1,M+M
         IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 162  CONTINUE
C
      IF(IBIT1.EQ.0) GO TO 170
C
C
      MQ=M+4
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
                 END IF
C     ------------------------------------------------------------------
C*          1.7  SET UP LENGTH OF THE SECTION 3.
C                -------------------------------
 170  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC3T(K,IERR )
C
C**** *SEC3T*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 3 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC3T(K,IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 3 ( DATA DESCRIPTION SECTION ).
C                -----------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
      IF(K.NE.1.AND.K.NE.2.AND.K.NE.3) THEN
                                          IERR=1
                                          RETURN
                                     END IF
C
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP NUMBER OF DATA SUB-SETS.
C                -------------------------------
 140  CONTINUE
C
c          ---- verificar a variavel a que foi atribuida  NSUB ----

      CALL PACK(NBPW,MBUF(NWPT),Ns,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          1.5  SET UP INFORMATION ABOUT TYPE OF DATA AND COMPRESSION.
C                ------------------------------------------------------
 150  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),128,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.6  SET UP COLLECTION OF DESCRIPTORS TO DEFINE DATA.
C                --------------------------------------------------
 160  CONTINUE
C
C     TESAC SURFACE LAND OBSERVATION
C
      IF(K.EQ.1) THEN
      CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),8,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 8)
C
C     CHECK IF Q/C PERFORMED.
C
      IBIT1=0
      DO 161 I=M+1,M+M
         IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 161  CONTINUE
C
      IF(IBIT1.EQ.0) GO TO 170
C
C
      MQ=M+4   
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
                 END IF
      IF(K.EQ.2) THEN
      CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),15,NWPT,NBPT,6)
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 8)
C
C     CHECK IF Q/C PERFORMED.
C
      IBIT1=0
      DO 162 I=M+1,M+M
         IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 162  CONTINUE
C
      IF(IBIT1.EQ.0) GO TO 170
C
C
      MQ=M+4
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
                 END IF
      IF(K.EQ.3) THEN
      CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),15,NWPT,NBPT,6)
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 8)
      CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),6,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),5,NWPT,NBPT, 8)
C
C     CHECK IF Q/C PERFORMED.
C
      IBIT1=0
      DO 163 I=M+1,M+M
         IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 163  CONTINUE
C
      IF(IBIT1.EQ.0) GO TO 170
C
C
      MQ=M+4
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),32,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
                 END IF
C     ------------------------------------------------------------------
C*          1.7  SET UP LENGTH OF THE SECTION 3.
C                -------------------------------
 170  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC4(IERR )
C
C**** *SEC4*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 4 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC4(IERR)*
C
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C         *CALL* *GBYTE(KS,KD,KSKI,KSI)
C
C            *KS*    - SOURCE
C            *KD*    - DESTINATION
C            *KSKI*  - NUMBER OF BITS TO BE SKIPPED
C            *KSI*   - NUMBER OF BITS TO BE EXTRACTED
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
      CHARACTER*24 CUNIT,YUNIT
      CHARACTER*9 CVAL,YVAL
C
      INCLUDE 'comwtc.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 4 ( DATA SECTION).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          2.   SET UP BINARY DATA AS DEFINED BY SEQUENCE DESCRIPTOR.
C                ------------------------------------------------
 200  CONTINUE
C
c          ---- verificar a variavel a que foi atribuida  NSUB ----
      DO 201 I=1,Ns
      DO 202 J=1,M
C
      IREF  =IWTRV(J)
      ISCALE=IWTS (J)
      IBDW  =IWTDW(J)
      YUNIT =CUNIT(J)
C
      VAL=VALUES(J,I)
C
      IF(YUNIT.EQ.'CCITTIA5')
     1   THEN
            IST=NINT(VAL)/1000
            IEN=NINT(VAL)-IST*1000
            YVAL=CVAL(IST)
            DO 203 II=1,IEN
            IPACK=ICHAR(YVAL(II:II))
            CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,8)
 203        CONTINUE
            GO TO 202
         END IF
C
      IF(VAL.EQ.999999.)
     1   THEN
            CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
         ELSE
            IF(ISCALE.LT.0)
     1         THEN
                  ISCALE=IABS(ISCALE)
                  IPACK=NINT(VAL/10.**ISCALE) - IREF
               ELSE
                  IPACK=NINT(VAL*10.**ISCALE) - IREF
               END IF
C
            CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
         END IF
C
 202  CONTINUE
C
      IF(M.LT.MQ) THEN
C
        DO 210 J=M+1,MQ      
C
        IREV  =IWTR (J)
        IREF  =IWTRV(J)
        ISCALE=IWTS (J)
        IBDW  =IWTDW(J)
        YUNIT =CUNIT(J)
C
        IF(IREV.EQ.031031) THEN
C 
C          SET BIT FLAG
C
           DO 215 JI=M+1,M+M
C
           IPACK=1
           IF(VALUES(JI,I).NE.999999.) IPACK=0
           CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,1)
C
 215       CONTINUE
C           
        END IF
C
        IF(IREV.EQ.001031) THEN
           VAL=46.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10.**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10.**ISCALE) - IREF
              END IF
C
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.001032) THEN
           VAL=1.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10.**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10.**ISCALE) - IREF
              END IF
C
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.001201) THEN
           VAL=1.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10.**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10.**ISCALE) - IREF
              END IF
C
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.033007) THEN
           DO 216 JI=M+1,M+M
           VAL=VALUES(JI,I)
           IF(VAL.EQ.999999.) GO TO 216
C
           IF(ISCALE.LT.0) THEN
              ISCALE=IABS(ISCALE)
              IPACK=NINT(VAL/10.**ISCALE) - IREF
           ELSE
              IPACK=NINT(VAL*10.**ISCALE) - IREF
           END IF
C
           CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
C
 216       CONTINUE
C
        END IF
C
 210    CONTINUE
C
      END IF
C 
 201  CONTINUE
C
C     ------------------------------------------------------------------
C*         12.   SET UP LENGTH OF THE SECTION 4.
C                -------------------------------
 1200 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 1300 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SETTAB( IERR )
C
C**** *SETTAB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET *BUFR *TABLES *B.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETTAB(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       17/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=20000,JSUBS=400,JCVAL=150 ,JBUFL= 8192,
     2          JBPW =  32,JTAB =1000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=80000,JKEY=46) 
     
      COMMON /BCOMTAB/ NTABBTR(JTAB),NTABBS (JTAB),NTABBRV(JTAB),
     1                NTABBDW(JTAB),NTABDTR(JTAB),NTABDST(JTAB),
     2                NTABDL (JTAB),NTABDSQ(JTAB*20),NTABP(64,255)
C
C             NTABBTR    - table B,  table reference              array
C             NTABBS     - table B,  scale                        array
C             NTABBRF    - table B,  reference value              array
C             NTABBDW    - table B,  data width                   array
C             NTABDTR    - table D,  table reference              array
C             NTABDST    - table D,  starting pointers            array
C             NTABDL     - table D,  lengths                      array
C             NTABDSQ    - table D,  list of sequence descriptors array
C
C
      COMMON /BCOMTABC / CTABBEN(JTAB),CTABBU (JTAB)
C
C             CTABBEN      -  table B, ELEMENT NAME           array
C             CTABBU       -  table B, unit                   array
C
C
C      COMMON /BCOMCT/ NREF(JCTAB)   ,NSTART(JCTAB) ,NLEN(JCTAB),
C     1               NCODNUM(JCTST),NSTARTC(JCTST),
C     2               NLENC(JCTST)
C
C             NREF      - table C reference
C             NSTART    - starting pointers to array NCODNUM
C             NLEN      - lengths
C             NCODNUM   - code/flag table number
C             NSTARTC   - starting pointers to array CTEXT
C             NLENC     - lengths
C
C
C      COMMON /BCOMCTC/ CTEXT(JCTEXT)
C
C             CTEXT     - text in code/flag tables
C
C
      COMMON /BCOMROOT/ CROOT
C
C            CROOT    -  path for Bufr tables
C
C
      CHARACTER*256 YTAB ,YTAC ,YTAD
      CHARACTER*11  YTABB,YTABC,YTABD
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
      CHARACTER*256 CROOT
C     ------------------------------------------------------------------
C
C*          1.   GET BUFR TABLES/LOCAL BUFR TABLES.
C                ----------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0) RETURN
C
C*          2.   SET UP BUFR TABLE FILE NAME.
C                ----------------------------
 200  CONTINUE
C
C
C             BUFR EDITION 2 NAMING CONVENTION
C
C             BXXXXXYYZZ , CXXXXXYYZZ , DXXXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             XXXXX  - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C             BUFR EDITION 3 NAMING CONVENTION
C
C             BWWWXXXYYZZ , CWWWXXXYYZZ , DWWWXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             WWW    - ORIGINATING SUB-CENTRE
C             XXX    - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C
            IXX=46
            IYY=02
            IZZ=01
            IWW=0
C
         croot='./'
         NXXP=IXX
         NYYP=IYY
         NZZP=IZZ
         NWWP=IWW
C
            WRITE(YTABB,'(A1,I5.5,I2.2,I2.2)') 'B',IXX,IYY,IZZ
C            WRITE(YTABC,'(A1,I5.5,I2.2,I2.2)') 'C',IXX,IYY,IZZ
            WRITE(YTABD,'(A1,I5.5,I2.2,I2.2)') 'D',IXX,IYY,IZZ
C
c         PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABC,',',YTABD
          PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABD
C
C     ----------------------------------------------------------------
C*          3. OPEN AND READ FILES CONTAINING BUFR TABLES.
C              -------------------------------------------
 300  CONTINUE
C
      I=INDEX(CROOT,' ')
      IF(I.GT.1) I=I-1
C
C*          3.1 READ BUFR TABLE B.
C               ------------------
 310  CONTINUE
C
      YTAB=CROOT(1:I)//YTABB
      II=I+11
C
      OPEN(UNIT=38,IOSTAT=IOS,ERR=410,FILE=YTAB(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(38,ERR=400,IOSTAT=IOS) NTABBTR,CTABBEN,CTABBU,NTABBS,
     1                            NTABBRV,NTABBDW,NTABP
C
      CLOSE(UNIT=38,IOSTAT=IOS,ERR=420)
C
C*          3.3 READ BUFR TABLE D.
C               ------------------
      
 330  CONTINUE
C
      YTAD=CROOT(1:I)//YTABD
C
      OPEN(UNIT=40,IOSTAT=IOS,ERR=610,FILE=YTAD(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(40,ERR=600,IOSTAT=IOS) NTABDTR,NTABDL,NTABDST,NTABDSQ
C
      CLOSE(UNIT=40,IOSTAT=IOS,ERR=620)
C
C
      RETURN
C     ----------------------------------------------------------------
      
C
 400  CONTINUE
C
      KERR=6
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 410  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 420  CONTINUE
C
      KERR=10
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------
 600  CONTINUE
C
      KERR=8
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 610  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 620  KERR=12
      PRINT*,'BUGBTS: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------
C      
      END

      SUBROUTINE SETWTD(K,IERR)                                        
C
C**** *SETWTD*
C
C
C     PURPOSE.
C     --------
C         SETS UP WORKING TABLE B INFORMATION.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETWTD(K,IERR)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*
C
C

      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      
      COMMON /BCOMTAB/ NTABBTR(Jp2),NTABBS (Jp2),NTABBRV(Jp2),
     1                NTABBDW(Jp2),NTABDTR(Jp2),NTABDST(Jp2),
     2                NTABDL (Jp2),NTABDSQ(Jp2*20),NTABP(64,255)

      COMMON /BCOMTABC / CTABBEN(jp2),CTABBU (jp2)
c
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
      
C
C
      DIMENSION ISL11(36),ISL12(22),ISL123(28),ISL13(21)
      DIMENSION ILISTA(1000),ISTACK(1000),IREPL(5)
C
      DATA ISL11 /001005,001012,001013,002001,004001
     1,           004002,004003,004004,004005,005002
     2,           006002,010004,010051,010061,010063
     4,           011011,011012,012004,012006,013003
     5,           020001,020003,020004,020005,020010
     6,           008002,020011,020013,020012,020012
     7,           020012,022042,031031,001031,001201
     8,           033007/
      DATA ISL12 /001005,001012,001013,002001,004001
     1,           004002,004003,004004,004005,005002
     2,           006002,002032,002033,103000,031001
     3,           007062,022043,022062,031031,001031
     4,           001201,033007/
      DATA ISL123 /001005,001012,001013,002001,004001
     1,            004002,004003,004004,004005,005002
     2,            006002,002032,002033,103000,031001
     3,            007062,022043,022062,002031,103000
     4,            031001,007062,022004,022031,031031
     5,            001031,001201,033007/
      DATA ISL13 /001005,001012,001013,002001,004001
     1,           004002,004003,004004,004005,005002
     2,           006002,002031,103000,031001,007062
     3,           022004,022031,031031,001031,001201,033007/
C
C     ------------------------------------------------------------------
C*          1.   SET UP WORKING TABLES FOR DRIBU DATA.
C                -------------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      IF(K.LT.1.AND.K.GT.4) THEN
                              IERR=1
                              RETURN
                           END IF
      I=1
      IF(NT.NE.0) THEN
         IREPL(I)=NT
         I=I+1
      END IF
      IF(NC.NE.0) IREPL(I)=NC
C
      IF(K.EQ.1) IM=32
      IF(K.EQ.2) IM=18
      IF(K.EQ.3) IM=24
      IF(K.EQ.4) IM=17
C
      LDRP=.FALSE.
      I=1
      IA=1
      IR=0
      JJJ=0
C
C*
C
 200  CONTINUE
C
      IF(K.EQ.1) ID=ISL11(I)
      IF(K.EQ.2) ID=ISL12(I)
      IF(K.EQ.3) ID=ISL123(I)
      IF(K.EQ.4) ID=ISL13(I)
C
      I=I + 1
C
      IF(ID.GT.100000) THEN
C
         IR=IR+1
         IX=(ID-100000)/1000
         IY=(ID-100000)- IX*1000
         IF(IY.EQ.0) THEN
            LDRP=.TRUE.
            IY=IREPL(IR)
            IF(K.EQ.1) ILISTA(IA)=ISL11(I)
            IF(K.EQ.2) ILISTA(IA)=ISL12(I)
            IF(K.EQ.3) ILISTA(IA)=ISL123(I)
            IF(K.EQ.4) ILISTA(IA)=ISL13(I)
            IA=IA+1
            I=I+1              
         END IF
C
C        GET NEXT IX DESCRIPTORS FROM LIST
C
         DO 201 J=1,IX
         IF(K.EQ.1) ISTACK(J)=ISL11(I)
         IF(K.EQ.2) ISTACK(J)=ISL12(I)
         IF(K.EQ.3) ISTACK(J)=ISL123(I)
         IF(K.EQ.4) ISTACK(J)=ISL13(I)
         I=I+1
 201     CONTINUE
C
C        REPEAT IX DESCRIPTORS IY TIMES
C
         DO 202 J=1,IY-1
         DO 203 JJ=1,IX
         JJJ=J*IX+JJ
         ISTACK(JJJ)=ISTACK(JJ)
 203     CONTINUE
 202     CONTINUE
C
C        INSERT ISTACK INTO ILISTA
C
         IF(JJJ.EQ.0) JJJ=IX
         DO 204 J=1,JJJ
         ILISTA(IA)=ISTACK(J)
         IA=IA+1
 204     CONTINUE
C
C        CLEAR ISTACK
C
         DO 205 J=1,100
         ISTACK(J)=0
 205     CONTINUE
C
         IF(I.GT.IM) GO TO 300
         GO TO 200                            
      ELSE
         ILISTA(IA)=ID
         IA=IA+1
         IF(I.GT.IM) GO TO 300
         GO TO 200
      END IF                                          
C     -----------------------------------------------------------------
C*               3. SET UP WORKING TABLE 
C
 300  CONTINUE
C
      IA=IA-1
      M =IA
C
      ILISTA(IA+1)=031031
      ILISTA(IA+2)=001031
      ILISTA(IA+3)=001032
      ILISTA(IA+4)=033007
C
      IA=IA+4
C
      DO 301 I=1,IA
C
      ITR=ILISTA(I)                  
C
      DO 302 J=1,JP2
C
      IF(ITR.EQ.NTABBTR(J)) THEN
         IWTR (I)=NTABBTR(J)
         IWTS (I)=NTABBS (J)
         IWTDW(I)=NTABBDW(J)
         IWTRV(I)=NTABBRV(J)
         CUNIT(I)=CTABBU(J)
         GO TO 301
      END IF
C
 302  CONTINUE
C
      PRINT*,'BUFR TABLE B REFERENCE ENTRY',ITR,'NOT FOUND'
C
 301  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SETWTB(K,IERR)
C
C**** *SETWTB*
C
C
C     PURPOSE.
C     --------
C         SETS UP WORKING TABLE B INFORMATION.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETWTB(K,IERR)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      
      COMMON /BCOMTAB/ NTABBTR(Jp2),NTABBS (Jp2),NTABBRV(Jp2),
     1                NTABBDW(Jp2),NTABDTR(Jp2),NTABDST(Jp2),
     2                NTABDL (Jp2),NTABDSQ(Jp2*20),NTABP(64,255)

      COMMON /BCOMTABC / CTABBEN(jp2),CTABBU (jp2)
c
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
C
C
      DIMENSION ISL21(36),ISL22(20),ILISTA(1000),ISTACK(1000)
C
      DATA ISL21 /001011,001012,001013,002001,
     1            004001,004002,004003,004004,
     2            004005,005002,006002,010004,
     3            010051,010061,010063,011011,011012,
     3            012004,012006,013003,020001,020003,
     4            020004,020005,020010,008002,020011,
     5            020013,020012,020012,020012,022042,
     6            031031,001031,001201,033007/
      DATA ISL22 /001011,004001,004002,004003,004004
     2,           004005,005002,006002,002032,102000,031001
     3,           007062,022042,002031,022004,022031
     4,           031031,001031,001201,033007/
C     ------------------------------------------------------------------
C*          1.   SET UP WORKING TABLES FOR BATHY  DATA.
C                ----------------------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      IF(K.NE.1.AND.K.NE.2) THEN
                               IERR=1
                               RETURN
                            END IF
C          
      IF(K.EQ.1) IM=32
      IF(K.EQ.2) IM=16
C
      LDRP=.FALSE.
      I=1
      IA=1
      JJJ=0
C
C*
C
 200  CONTINUE
C
      IF(K.EQ.1) ID=ISL21(I)
      IF(K.EQ.2) ID=ISL22(I)
C
      I=I + 1
C
      IF(ID.GT.100000) THEN
C
                          IX=(ID-100000)/1000
                          IY=(ID-100000)- IX*1000
                          IF(IY.EQ.0) THEN
                                         LDRP=.TRUE.
                                         IY=NINT(VALUES(10,NSUB))
                                         ILISTA(IA)=ISL22(I)
                                         IA=IA+1
                                         I=I+1              
                                      END IF
C
C                         GET NEXT IX DESCRIPTORS FROM LIST
C
                          DO 201 J=1,IX
                          IF(K.EQ.1) ISTACK(J)=ISL21(I)
                          IF(K.EQ.2) ISTACK(J)=ISL22(I)
                          I=I+1
 201                      CONTINUE
C
C                         REPEAT IX DESCRIPTORS IY TIMES
C
                          DO 202 J=1,IY-1
                          DO 203 JJ=1,IX
                          JJJ=J*IX+JJ
                          ISTACK(JJJ)=ISTACK(JJ)
 203                      CONTINUE
 202                      CONTINUE
C
C                         INSERT ISTACK INTO ILISTA
C
                          IF(JJJ.EQ.0) JJJ=IX
                          DO 204 J=1,JJJ
                          ILISTA(IA)=ISTACK(J)
                          IA=IA+1
 204                      CONTINUE
C
C                         CLEAR ISTACK
C
                          DO 205 J=1,100
                          ISTACK(J)=0
 205                      CONTINUE
C
                          IF(I.GT.IM) GO TO 300
                          GO TO 200                            
                       ELSE
                          ILISTA(IA)=ID
                          IA=IA+1
                          IF(I.GT.IM) GO TO 300
                          GO TO 200
                       END IF                                          
C     -----------------------------------------------------------------
C*               3. SET UP WORKING TABLE 
C
 300  CONTINUE
C
      IA=IA-1
      M= IA
C 
      ILISTA(IA+1)=031031
      ILISTA(IA+2)=001031
      ILISTA(IA+3)=001201
      ILISTA(IA+4)=033007
C
      IA=IA+4
C
      DO 301 I=1,IA
C
      ITR=ILISTA(I)                  
C
      DO 302 J=1,JP2
C
      IF(ITR.EQ.NTABBTR(J)) THEN
                               IWTR (I)=NTABBTR(J)
                               IWTS (I)=NTABBS (J)
                               IWTDW(I)=NTABBDW(J)
                               IWTRV(I)=NTABBRV(J)
                               CUNIT(I)=CTABBU(J)
                               GO TO 301
                            END IF
C
 302  CONTINUE
C
      PRINT*,'BUFR TABLE B REFERENCE ENTRY',ITR,' NOT FOUND'
C
 301  CONTINUE
C     ---------------------------------------------------------------
 400  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SETWTT(K,IERR)
C
C**** *SETWTT*
C
C
C     PURPOSE.
C     --------
C         SETS UP WORKING TABLE B INFORMATION.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETWTT(K,IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
C
      COMMON /BCOMTAB/ NTABBTR(Jp2),NTABBS (Jp2),NTABBRV(Jp2),
     1                NTABBDW(Jp2),NTABDTR(Jp2),NTABDST(Jp2),
     2                NTABDL (Jp2),NTABDSQ(Jp2*20),NTABP(64,255)

      COMMON /BCOMTABC / CTABBEN(jp2),CTABBU (jp2)
c
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
C
C
      DIMENSION ISL31(36),ISL32(19),ISL33(25)
      DIMENSION ILISTA(1000),ISTACK(1000),IREPL(5)
C
      DATA ISL31 /001011,001012,001013,002001,
     1            004001,004002,004003,004004,
     2            004005,005002,006002,010004,
     3            010051,010061,010063,011011,011012,
     3            012004,012006,013003,020001,020003,
     4            020004,020005,020010,008002,020011,
     5            020013,020012,020012,020012,022042,
     6            031031,001031,001201,033007/
      DATA ISL32 /001011,004001,004002,004003,004004,
     2            004005,005002,006002,002032,002033,
     3            103000,031001,007062,022043,022062,
     4            031031,001031,001201,033007/
      DATA ISL33 /001011,004001,004002,004003,004004,
     2            004005,005002,006002,002032,002033,
     3            103000,031001,007062,022043,022062,002031,
     4            103000,031001,007062,022004,022031,
     5            031031,001031,001201,033007/
C     ------------------------------------------------------------------
C*          1.   SET UP WORKING TABLES FOR BATHY  DATA.
C                ----------------------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      IF(K.NE.1.AND.K.NE.2.AND.K.NE.3) THEN
                                          IERR=1
                                          RETURN
                                       END IF
C
      IREPL(1)=NT
      IREPL(2)=NC
C          
      IF(K.EQ.1) IM=32
      IF(K.EQ.2) IM=15
      IF(K.EQ.3) IM=21
C
      LDRP=.FALSE.
      I=1
      IA=1
      IR=0
      JJJ=0
C
C*
C
 200  CONTINUE
C
      IF(K.EQ.1) ID=ISL31(I)
      IF(K.EQ.2) ID=ISL32(I)
      IF(K.EQ.3) ID=ISL33(I)
C
      I=I + 1
C
      IF(ID.GT.100000) THEN
                          IR=IR+1
                          IX=(ID-100000)/1000
                          IY=(ID-100000)- IX*1000
                          IF(IY.EQ.0) THEN
                                         LDRP=.TRUE.
                                         IY=IREPL(IR)
                                      IF(K.EQ.2)ILISTA(IA)=ISL32(I)
                                      IF(K.EQ.3)ILISTA(IA)=ISL33(I) 
                                         IA=IA+1
                                         I=I+1              
                                      END IF
C
C                         GET NEXT IX DESCRIPTORS FROM LIST
C
                          DO 201 J=1,IX
                          IF(K.EQ.2) ISTACK(J)=ISL32(I)
                          IF(K.EQ.3) ISTACK(J)=ISL33(I)
                          I=I+1
 201                      CONTINUE
C
C                         REPEAT IX DESCRIPTORS IY TIMES
C
                          DO 202 J=1,IY-1
                          DO 203 JJ=1,IX
                          JJJ=J*IX+JJ
                          ISTACK(JJJ)=ISTACK(JJ)
 203                      CONTINUE
 202                      CONTINUE
C
C                         INSERT ISTACK INTO ILISTA
C
                          IF(JJJ.EQ.0) JJJ=IX
                          DO 204 J=1,JJJ
                          ILISTA(IA)=ISTACK(J)
                          IA=IA+1
 204                      CONTINUE
C
C                         CLEAR ISTACK
C
                          DO 205 J=1,100
                          ISTACK(J)=0
 205                      CONTINUE
C
                          IF(I.GT.IM) GO TO 300
                          GO TO 200                            
                       ELSE
                          ILISTA(IA)=ID
                          IA=IA+1
                          IF(I.GT.IM) GO TO 300
                          GO TO 200
                       END IF                                          
C     -----------------------------------------------------------------
C*               3. SET UP WORKING TABLE 
C
 300  CONTINUE
C
      IA=IA - 1
C
      M= IA
C
      ILISTA(IA+1)=031031
      ILISTA(IA+2)=001031
      ILISTA(IA+3)=001032
      ILISTA(IA+4)=033007
C
      IA=IA+4

      DO 301 I=1,IA 
C
      ITR=ILISTA(I)                  
C
      DO 302 J=1,JP2
C
      IF(ITR.EQ.NTABBTR(J)) THEN
                               IWTR (I)=NTABBTR(J)
                               IWTS (I)=NTABBS (J)
                               IWTDW(I)=NTABBDW(J)
                               IWTRV(I)=NTABBRV(J)
                               CUNIT(I)=CTABBU(J)
                               GO TO 301
                            END IF
C
 302  CONTINUE
C
      PRINT*,'BUFR TABLE B REFERENCE ENTRY',ITR,'NOT FOUND'
C
 301  CONTINUE
C     ---------------------------------------------------------------
 400  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PUTBUFR( K,IERR )
C
C**** *PUTBUFR*
C
C
C     PURPOSE.
C     --------
C         PUT BUFR MESSAGE INTO REPORT DATA BASE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PUTBUFR(K,IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      parameter (idime=15)
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h'
      INCLUDE 'comrec.h'
CC
      common /recwriten/ irecswriten
      common /repetida/ irepetida
c
      character*11 ctabname
      character*21 ctstamp
      character*4  cstream
C
      CHARACTER*15000 YOUT
      CHARACTER*9  CIDENT
      CHARACTER*48 CKEY
      CHARACTER*32 YKEY
      CHARACTER*18 CFNAME
      CHARACTER*25 YTIME
      CHARACTER*25 CTIME,YCTIME
      CHARACTER*29 YCFNAME
      character*6  cc
      integer iyyy,imo,idd,iutc,ihh,imm,iss,icc
C
      character*48 records_writen(4000)
c
      DIMENSION IKEY(12)
      dimension iflags(idime)
C
      EQUIVALENCE (IKEY(1),YKEY,CKEY)
      EQUIVALENCE (MBUF(1),YOUT)
      data iflags/1,1,0,1,1,1,2,8*0/
C
C     ------------------------------------------------------------------
C*          1. DEFINE RDB FILE NAME AND OPEN RDB FILE.
C                -------------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      ierr=0
      IRET=0
      call datim(ny,nmonth,nday,iutc,NHOUR,NMINUTE,NSECOND,icc)
      icen = nyear*.01        
      NY=NYEAR - (icen *100)
      WRITE(YTIME,'(6I2.2)',IOSTAT=IOS,ERR=101)
     1      NY,NMONTH,NDAY,NHOUR,NMINUTE,NSECOND

      ctabname='OCEA_'//ytime(1:8)
C
      GO TO 102
C
 101  CONTINUE
C
      PRINT*,'BAD DATE OR TIME, REPORT SKIPPED. IOSTAT=',IOS
      RETURN
C
 102  CONTINUE
C
C*          2.  DEFINE RDB KEY AND HOUSEHEEPING INFORMATION.
C               --------------------------------------------
 200  CONTINUE
C
      IW=1
      IBT=0
C
C*          2.1 DEFINE RDB KEY.
C               ---------------
 210  CONTINUE
C 
      CALL PACK(32,IKEY(IW),NTYPE,IW,IBT,8)
      CALL PACK(32,IKEY(IW),NSBTYPE,IW,IBT,8)
      CALL PACK(32,IKEY(IW),NYEAR,IW,IBT,12)
      CALL PACK(32,IKEY(IW),NMONTH,IW,IBT,4)
      CALL PACK(32,IKEY(IW),NDAY,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NHOUR,IW,IBT,5)
      CALL PACK(32,IKEY(IW),NMINUTE,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NSECOND,IW,IBT,6)
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)
      CALL PACK(32,IKEY(IW),NLON1,IW,IBT,26)
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NLAT1,IW,IBT,25)
      CALL PACK(32,IKEY(IW),0,IW,IBT,7)
c
c      YKEY(16:24)=CIDENT
c
c     atribuicao do identificador da estacao
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
      YKEY(13:13)=CIDENT(1:1)
      YKEY(17:17)=CIDENT(5:5)
      YKEY(18:18)=CIDENT(4:4)
      YKEY(19:19)=CIDENT(3:3)
      YKEY(20:20)=CIDENT(2:2)
      YKEY(21:24)=' '
      YKEY(25:32)=' '
C
C*          2.2 DEFINE HOUSE KEEPING INFORMATION.      
C               ---------------------------------
 220  CONTINUE
C
      ILENGTH=(NWPT-2)*4+NBPT/8
C
      IF(KDEC(21).EQ.MINDIC) THEN
                                NCORR=0
                             ELSE
                                NCORR=KDEC(21)
                             END IF
C
C     FIND LOWEST QUALITY CONTROL PERCENTAGE. 
C
      IF(M.LT.MQ) THEN
                     RMIN=VALUES(M+1,NSUB)
                     DO 221 I=M+1,M+M
                     IF(VALUES(I,NSUB).LT.RMIN) RMIN=VALUES(I,NSUB)
 221                 CONTINUE
                     NQC=NINT(RMIN) 
                  END IF
C      
      CALL datim(iyyy,imo,idd,iutc,ihh,imm,iss,icc)
c
      IW =9
      IBT=0
C
C       SET LENGTH OF RECORD
C
      CALL PACK(32,IKEY(IW),ILENGTH,IW,IBT,16)      
C
C        SET TIME RECORD WAS LAST WRITTEN TO RDB
C 
      CALL PACK(32,IKEY(IW),IDD,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),IHH,IW,IBT,5)      
      CALL PACK(32,IKEY(IW),IMM,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),ISS,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
C
C       SET TIME BULLETIN WAS RECEIVED
C
      CALL PACK(32,IKEY(IW),NRDAY,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRHOUR,IW,IBT,5)      
      CALL PACK(32,IKEY(IW),NRMIN,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRSEC,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORR,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRECR,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NNIL,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NQC,IW,IBT,8)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,24)      
C
C
C     WRITE RDB KEY INTO SECTION 2 OF BUFR MESSAGE.
C
C     WORD 8 BIT 16 (atencao meio de palavra 9)
C
c     YOUT(35:82)=CKEY(1:48)
c
c     atribuicao da chave da secao 2
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
      call invbytes(48,ckey)
      yout(34:34) = ckey(1:1)
      yout(33:33) = ckey(2:2)
c      pass = 9
c      do 10 ii = 1,41,4
c        pass = pass + 1
c         do 20 jj = 1,4
c            yout(((pass*4+1)-jj):((pass*4+1)-jj)) =
c     *       ckey_aux(((ii-1)+jj):((ii-1)+jj))
c 20   continue  
c 10   continue
c
       do 10 i = 1,44
          j = ((i-1)/4 + 10)*4 - MOD((i-1),4)
          yout(j:j) = ckey(i+2:i+2)
 10    continue
c
      yout(84:84) = ckey(47:47)
      yout(83:83) = ckey(48:48)
c
      mbuf(1)=ilength
C
C*          3.  WRITE REPORT INTO RDB.
C               ----------------------        
 300  CONTINUE
C
C*          3.1 write report into RDB.
C               ----------------------
 310  CONTINUE
c
      ierr=0
C
C     -----------------------------------------------------------------
      call invbytes(ilength+4,yout)
      irecswriten = irecswriten + 1
      do 11 i=1,irecswriten
         if(records_writen(i)(1:48).eq.ckey(1:48)) then
           irecswriten = irecswriten - 1
	   irepetida = irepetida + 1
           go to 400
         end if
 11   continue
      records_writen(irecswriten)(1:48) = ckey(1:48)
      WRITE(99,'(a)')YOUT(5:ilength+4)
C     -----------------------------------------------------------------
 400  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SAVBULL ( IERR )
C
C**** *SAVBULL*
C
C
C     PURPOSE.
C     --------
C
C         WRITE COMPLETE BULLETIN TO ERROR FILE .
C
C         BULLETIN IN KCHAR(1)-KCHAR(IGS) IN CCITT 5.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SAVBULL(IERR)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'combuff.h'
C
C
      CHARACTER*80 YLINE,YLINEA
      CHARACTER*1 Y63
      CHARACTER*4 YGS
C
      Y63=CHAR(63)
      YGS=CHAR(13)//CHAR(13)//CHAR(10)//CHAR(3)
C     ------------------------------------------------------------------
C*          1.   OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 100  CONTINUE
C
C      IF(IERR .EQ. 0) RETURN
C
      YLINE=' '
      YLINEA=' '
C
C
C
      OPEN(UNIT=11,IOSTAT=IOS,ERR=400,
     C     FILE='OCEA.error.dat',
     C     CARRIAGECONTROL='LIST', 
     C     ACCESS='APPEND',
     C     STATUS='UNKNOWN',
     C     SHARED,RECL=80                      )
C
      IP = 1
      JP = IP
      J = IGS
C
C*          1.1  OUTPUT INITIAL CONTROL CHARACTERS.
C                ----------------------------------
 110  CONTINUE
C
      CALL NEXTPRT (JP,IGS)
      K = JP - IP
      N1 = 0
      DO 111 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127) THEN
                                   YLINEA(N1:N1)=Y63
                                   ISIGN=1
                                   KCHAR(IP)=KCHAR(IP).AND.127
                                          END IF
         YLINE(N1:N1) = CHAR(KCHAR(IP))
         IP = IP + 1
C
  111 CONTINUE
C
      WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
      YLINE=' '
      YLINEA=' '
C
 120  CONTINUE
C
      CALL NEXTPRT (IP,J)
      IF (IP .GT. J) GO TO 400
      JP = IP
      CALL NEXTEND (JP,J)
      CALL NEXTPRT (JP,J)
      K = JP - IP
      N1 = 0
      DO 112 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127 )
     C                      THEN
                               YLINEA(N1:N1) = Y63
                               ISIGN= 1
                               KCHAR(IP) = KCHAR(IP).AND.127
                            END IF
C
      YLINE(N1:N1) = CHAR(KCHAR(IP))
      IP = IP + 1
C
  112 CONTINUE
C
      WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
C
      YLINE=' '
      YLINEA=' '
C
      GO TO 120
C
 300  IERR = -1
      PRINT*,' ERROR IN WRITING INTO ERROR FILE IOS=',IOS 
 400  CONTINUE
C
      WRITE(11,'(A)') YGS
      CLOSE(11)
C
C     REMOVE PARITY BIT
C
      DO 410 I = 1 , IGS
      KCHAR(I) = KCHAR(I) .AND. 127
 410  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SAVREP ( IHEAD,IERR)
C
C**** *SAVREP*
C
C
C     PURPOSE.
C     --------
C
C         WRITE REPORT IN ERROR TO THE ERROR FILE.
C
C                 IHEAD = 0 , WRITE BULLETIN HEADER AND ERROR REPORT
C                             TO ERROR FILE.
C                       = 1 , WRITE ERROR REPORT ONLY.
C                       = 2 , WRITE 'GS' CHARACTER AT END.
C
C                 IERR NOT USED.
C
C                 IHEAD SET TO 1 IF HEADER WRITTEN , OTHERWISE
C                       UNCHANGED.
C
C                 IERR SET TO -1 , IF ERROR IN WRITE , OTHERWISE
C                       UNCHANGED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SAVREP(IHEAD,IERR)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C      MODIFICATIONS.
C      --------------
C
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'combuff.h'
C
      DIMENSION ISTART(4),IFIN(4)
C
      CHARACTER *80 YLINE,YLINEA
      CHARACTER*1 Y63
      CHARACTER*4 YGS
C
      Y63=CHAR(63)
c     YGS=CHAR(13)//CHAR(13)//CHAR(10)//CHAR(3)
      ygs=char(03)//char(01)//char(13)//char(13)
C     ------------------------------------------------------------------
C*          1.   OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 100  CONTINUE
C
C      IF(IERR .EQ. 0) RETURN
C
      ierr = 1
      YLINE=' '
      YLINEA=' '
C
C
C
      OPEN(UNIT=11,IOSTAT=IOS,ERR=400,
     C     FILE='OCEA.error.dat',
     C     CARRIAGECONTROL='LIST', 
     C     ACCESS='APPEND', 
     C     STATUS='UNKNOWN',
     C     SHARED,RECL=80                      )
C
C
C
C*          1.2  WRITE BULLETIN HEADER TO ERROR
C                ------------------------------
C                FILE IF NOT ALREADY DONE.
C                -------------------------
 120  CONTINUE
C
      IF ( IHEAD.NE.0 ) GO TO 130
C
C
      ISTART(1) = 1
      ISTART(2) = ISL
      ISTART(3) = IAH
      ISTART(4) = IMI
C
      IFIN(1) = ISL
      IFIN(2) = IAH
      IFIN(3) = JAH
      CALL NEXTEND(IFIN(3),IGS)
      CALL NEXTPRT(IFIN(3),IGS)
      IFIN(4) = JMI
      CALL NEXTEND(IFIN(4),IGS)
      CALL NEXTPRT(IFIN(4),IGS)
C
      IP = 0
      N2 = 0
C
      IHEAD = 1
C
      NN = 4
C
      DO 121 N=1,NN
         K = IFIN(N) - ISTART(N) 
         IF(K.GT.80) K=80 
         DO 122 N1=1,K
            N2 = N2 + 1
            IP = IP + 1
            IF (KCHAR(IP).GT.127)
     C                      THEN
                                YLINEA(N2:N2) = Y63
                                ISIGN=1
                                KCHAR(IP)=KCHAR(IP).AND.127
                            END IF
C
            YLINE(N2:N2) = CHAR(KCHAR(IP))
C
  122    CONTINUE
c
         if(k.le.2) go to 18
C
C
      WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N2)
      IF(ISIGN.EQ.1) THEN
         WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N2)
         ISIGN=0
      END IF
C
 18   continue
c
         YLINE=' '
         YLINEA=' '
C
      N2 = 0
C
  121 CONTINUE
C
C
C*           1.3   WRITE ERROR REPORT , IF REQUIRED.
C***               ---------------------------------
 130  CONTINUE
C
      IF ( IHEAD.EQ.2 ) GO TO 140
C
C
C     AVOID WRITING REPORT TWICE IF MIMIMJMJ  LINE IS
C     MISSING.
C
      IF ( IAH.EQ.KPT ) THEN
           CLOSE(11)
           RETURN
      END IF 
C
C     AVOID WRITING MIMIMJMJ TWICE ( CORRUPT MIMIMJMJ CAN BE TAKEN
C     AS STATION NUMBER )
C
      IF ( KPT.LT.IFIN(4) ) KPT = IFIN(4)
C
C
      IP = KPT
      IF(KDEC(4) .EQ. 35 .OR. KDEC(4) .EQ. 36) IP = IMI
      IF(KDEC(4) .EQ. 32 .OR. KDEC(4) .EQ. 33) IP = IMI
      J = IEQ+ 3
      IF ( J.GT.IGS) J = IGS
C
  133 CALL NEXTPRT (IP,J)
      IF (IP.GT.J) THEN
          CLOSE(11)
          RETURN
      END IF 
      JP = IP
      CALL NEXTEND(JP,J)
      CALL NEXTPRT(JP,J)
      K = JP - IP
      IF(K.GT.80) K=80
      N1 = 0
      DO 131 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127)
     C                        THEN
                                  YLINEA(N1:N1) = Y63
                                  ISIGN= 1
                                  KCHAR(IP) = KCHAR(IP).AND.127
                              END IF
C
         YLINE(N1:N1) = CHAR(KCHAR(IP))
         IP = IP + 1
C
 131  CONTINUE
C
      if(k.le.2) go to 19
c
      WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
 19   continue
c
      YLINE=' '
      YLINEA=' '
C
C
      GO TO 133
C
C
C*              1.4 WRITE 'GS' AT END OF BULLETIN.
C                   ------------------------------
 140  CONTINUE
C
      YLINE(1:4)= YGS
C
      WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINE
      CLOSE(11)
C
      GO TO 400
C     ----------------------------------------------------------------
 300  IERR = -1
      PRINT*,'ERROR IN WRITING INTO ERROR FILE IOS=',IOS 
C     ----------------------------------------------------------------
 400  CONTINUE
C
C     REMOVE PARITY BIT
C
      DO 500 I = 1 , IGS
      KCHAR(I) = KCHAR(I) .AND. 127
 500  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE ERRSTA (IPART,IMARK,IFIRST,NUMBER)
C
C**** *ERRSTA*
C
C
C     PURPOSE.
C     --------
C
C         COUNTS THE NUMBER OF ERRORS IN THE REPORT
C         COUNTS THE NUMBER OF ERRORS IN THE DECODING JOB
C         MARKS THE ERROR BIT TO KDEC
C         ADDS ?-MARK TO KCHAR AT THE ERRONEUS GROUP
C
C         INPUT     : IPART    - INDICATOR OF NOER
C                                (IN TEMPS  3 = A, 4 = B, 5 = C, 6 = D)
C                     IMARK    = 1 IF ? IS TO BE ADDED TO ERRONEUS GROUP
C                     IFIRST   = O IF FIRST DECODING ATTEMPT OF THE REPORT
C                              = 1 OTHERWISE
C                     NUMBER   - NUMBER OF ERRORS IN THE REPORT SO FAR
C
C         OUTPUT    : NUMBER   - NEW NUMBER OF ERRORS
C                     NOER     - NUMBER OF ERRONEUS REPORT (INCREASED BY 1
C                                IF THE FIRST ERROR IN THE REPORT)
C                     KDEC(20) - ERROR BITS
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ERRSTA(IPART,IMARK,IFIRST,NUMBER)*
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  NOV.83
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
C     ------------------------------------------------------------------
C
 100  CONTINUE
C
      IF(NUMBER .GE. 0) NUMBER = NUMBER + 1
      IF ( IFIRST.EQ.0 )
     C   THEN
            IF(NUMBER .EQ. 1)
     C          NUMRERR(IPART)=NUMRERR(IPART) + 1
            NOER(IPART,KERR)=NOER(IPART,KERR) + 1
            KERBIT =ISHFT(KDEC(20),1-KERR) .AND. 1
            IF(KERBIT .EQ. 0) KDEC(20) = KDEC(20) + 2**(KERR-1)
         END IF
C
      IPT = IABS(IPT)
      IF(IMARK .EQ. 1) KCHAR(IPT) = KCHAR(IPT) .OR. 128
      IF(IMARK .EQ. 2)
     C   THEN
            NPT = IPT
            CALL NEXSEP2(NPT,IEQ,*200)
            CALL PREPRT(NPT,IMI,*200)
            KCHAR(NPT) = KCHAR(NPT) .OR. 128
         END IF
C
200   CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PREPRT(I,J,*)
C
C**** *PREPRT*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR PREVIOUS CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER.
C
C         IF CHARACTER NOT FOUND THE CONROL
C         RETURNS TO ALTERNATIVE RETURN POINT *
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PREPRT(I,J,*)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.                    .
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J,-1
         IF(I .LE. J) RETURN 1
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE NEXTMI(I,J,II)
C
C**** *NEXTMI*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT GROUP OF
C         'TTAA' OR 'TTBB' OR 'TTCC' OR 'TTDD'
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C
C         OUTPUT    : II- POSITION OF THE FIRST CHARACTER IN REQUIRED GROUP
C                         IF CHARACTER NOT FOUND II = 99999
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTMI(I,J,II)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION MIMJ(26)
C
C
      DATA MIMJ /65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,
     &           80,81,82,83,84,85,86,87,88,89,90/
C
C     ------------------------------------------------------------------
C
C*          1.                                     .
C                -----------------------------------
 100  CONTINUE
C
C
      II=9999
      K =IABS(I)
      M =IABS(I)
C
 110  CONTINUE
C
      CALL NEXSEP2(M,J,*1000)
      CALL NEXPRT2(M,J,*1000)
C
      IF(M.GE.J) RETURN
C
      K1= KCHAR(M  )
      K2= KCHAR(M+1)
      K3= KCHAR(M+2)
      K4= KCHAR(M+3)
C
      DO 200 IL=1,26
C
      IF(K1.EQ.MIMJ(IL).AND.K2.EQ.MIMJ(IL))
     &   THEN
C
            DO 300 ILL=1,26
C
            IF(K3.EQ.MIMJ(ILL).AND.K4.EQ.MIMJ(ILL))
     &         THEN
                  CALL PRESEP(M,K,*1000)
                  CALL PREPRT(M,K,*1000)
                  II= M+1
                  RETURN
               END IF
C
 300        CONTINUE
C
         END IF
C
 200  CONTINUE
C
       GO TO 110
C
 1000 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXSEP2 ( I,J,*)
C
C**** *NEXSEP2*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE NEXT GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS NOT 'CR' OR 'LF' OR 'SPACE'.
C         'CR' OR 'LF' OR 'SPACE'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE' CHARACTER
C                         IF NO CHARACTER FOUND THE CONTROL RETURN TO
C                         ALTERNATIVE RETURN POINT *
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXSEP2(I,J,*)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.  SCAN BULLETIN.                     .
C                -------------
 100  CONTINUE
C
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         IF(I .GE. J) RETURN 1
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE NEXPRT2(I,J,*)
C
C**** *NEXPRT2*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER.
C                         IF CHARACTER NOT FOUND THE CONROL
C                         RETURNS TO ALTERNATIVE RETURN POINT *
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXPRT2(I,J,*)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.                    .
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         IF(I .GE. J) RETURN 1
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE EXTVAL ( I,N,IVAL)
C
C**** *EXTVAL*
C
C
C     PURPOSE.
C     --------
C
C         EXTRACTS N FIGURES FROM ARRAY 'KCHAR' , STARTING AT
C         WORD I , CONVERTS CHARACTERS TO INTEGER AND PLACES
C         IN IVAL
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTVAL(I,N,IVAL)*
C
C         INPUT     : I - POINTS TO FIRST CHARACTER TO BE EXTRACTED.
C                     N - NUMBER OF CCITT NO. 5 CHARACTERS TO BE EXTRACTED.
C
C         OUTPUT    : IVAL - INTEGER VALUE
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT N FIGURES FROM KCHAR ARRAY.
C                -----------------------------------
 100  CONTINUE
C
      IAC = 0
      IA = IABS(I)
      IB = IA + N - 1
C
      DO 101 J=IA,IB
C
C
C     STORE KCHAR(J) SO THAT IT WONT BE ALTERED IN THE SUBROUTINE
C
      KTEMP=KCHAR(J)
      KAR = KCHAR(J) .AND. 127
C
C          CHECK FOR SPACE CHARACTER .
C
           IF ( KAR.EQ.32 ) THEN
                                      IVAL = MINDIC
                                      RETURN
                                 END IF
C
C          CHECK FOR / CHARACTER .
C
           IF ( KAR.EQ.47 ) THEN
                                     IVAL = MINDIC
                                     RETURN
                                  END IF
C
C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( KAR.LT.48.OR.KAR.GT.57 )
     C                      THEN
                                  DO 102 JA=1,11
                                       IF ( KAR.EQ.ILET(JA))
     C                                       KAR = IFIG(JA)
  102                             CONTINUE
                           END IF
C
           IF ( KAR.GE.48.AND.KAR.LE.57 )
     C                             THEN
                                    IAC = (IAC + (KAR.AND.15))*10
                                   ELSE
                                      IVAL = MINDIC
                                      RETURN
                                   END IF
C
C
C
      KCHAR(J)=KTEMP
C
  101 CONTINUE
C
      IVAL = IAC / 10
C
C
      RETURN
      END
      
      SUBROUTINE PRESEP ( I,J,*)
C
C**** *PRESEP*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE PREVIOUS GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS 'CR' OR 'LF' OR 'SPACE'.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRESEP(I,J,*)
C
C                 INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                             J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C                 OUTPUT    : I - POSITION OF PREVIOUS 'CR' OR 'LF' OR 'SPACE'.
C                                 IF NO CHARACTER FOUND THE CONTROL RETURN TO
C                                 ALTERNATIVE RETURN POINT *
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   LOCATE THE PREVIOUS GROUP BY FINDING THE NEXT
C                ---------------------------------------------
C                CHARACTER WHICH IS 'CR' OR 'LF' OR 'SPACE'.
C                --------------------------------------------
 100  CONTINUE
C
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J,-1
         IF(I .LE. J) RETURN 1
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE REMEEE
C
C**** *REMEEE*
C
C
C     PURPOSE.
C     --------
C
C         HANDLE TYPING ERRORS CORRECTED BY THE 'E E E'
C         PROCEDURE AS SPECIFIED IN GTS MANUAL.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *REMEEE*
C
C         INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                     1 CHARACTER PER WORD.
C
C         OUTPUT    : E'S , ERRONEUS CHARACTERS AND REPEATED GROUPS REPLACED
C                     BY SPACE CHARACTERS. THESE ARE IGNORED IN SCANNING
C                     ROUTINES.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C*          1.  CHECK FOR 'E E E'. 'EEE' IS ACCEPTED EVEN
C               THOUGH THIS MAY BE  AMBIGUOUS WITH A SYNOP '333' GROUP IN
C               LETTER SHIFT. FREQUENTLY  ONLY 1 OR 2 'E'S MAY BE USED.
C               THESE ALSO CATERED FOR.
 100  CONTINUE
C
C     SKIP PAST SHIP'S CALL SIGN AND LOCATE 'E' IF ANY EXISTS.
C
      I = IPT + 4
      N = 69
      CALL NEXTVAL(I,N,IEQ)
      IF(I .GT. IEQ) RETURN
C
C     'E' CHARACTER FOUND. REPLACE 'E' AND ANY FOLLOWING 'E'S BY SPACES
C     E.G.  40118 7012EE 40118 70500  BECOMES
C           40118 7012   40118 70500 .
C
      K = I
      CALL NEXTFIG(K,IEQ)
      IF(K .GE. IEQ) RETURN
C
            DO 101 J=I,K-1
               IF((KCHAR(J) .NE. 10) .AND. (KCHAR(J) .NE. 13))
     1             KCHAR(J) = 32
101         CONTINUE
C
C     SET POINTER TO CHARACTER BEFORE THE 'E'. CHANGE
C     THIS CHARACTER TO A 'SPACE'.
C       E.G.  40118 7012   40118 70500  BECOMES
C             40118 701    40118 70500 .
C
      N = I - 1
      IF((KCHAR(N) .NE. 10) .AND. (KCHAR(N) .NE. 13))
     1    KCHAR(N) = 32
C
C     SCANNING BACKWARDS REPLACE CHARACTERS BY 'SPACE'
C     UNTIL A 'SPACE' CHARACTER IS ENCOUNTERED.
C        E.G.  40118 701    40118 70500  BECOMES
C              40118        40118 70500 .
C
      DO 102 I=N-1,IPT,-1
          IF(KCHAR(I) .EQ. 32) GO TO 300
          IF((KCHAR(I) .NE. 10) .AND. (KCHAR(I) .NE. 13))
     1        KCHAR(I) = 32
  102 CONTINUE
C
C     NO CHARACTER FOUND
C
      GO TO 100
C
C     ---------------------------------------------------------------------
C*           3. 'I' NOW POINTS TO THE 'SPACE' AFTER LAST FIGURE OF THE GROUP
C               BEFORE THE SERIES OF SPACES AND 'K' POINTS TO FIRST FIGURE
C               OF FOLLOWING GROUP. IF THESE GROUPS ARE THE SAME REMOVE
C               ONE GROUP (SECOND).
C               E.G.  40118        40118 70500  BECOMES
C                     40118              70500 .
C
 300  CONTINUE
C
      I = I - 5
      IF((KCHAR(I)   .EQ. KCHAR(K))   .AND.
     1   (KCHAR(I+1) .EQ. KCHAR(K+1)) .AND.
     2   (KCHAR(I+2) .EQ. KCHAR(K+2)) .AND.
     3   (KCHAR(I+3) .EQ. KCHAR(K+3)) .AND.
     4   (KCHAR(I+4) .EQ. KCHAR(K+4)))
     5         THEN
                   N = K + 4
                   DO 301 I=K,N
                       KCHAR(I) = 32
  301              CONTINUE
               END IF
C
C
C*           4.  SOMETIMES MORE THAN 1 GROUP HAS TO BE DELETED
C                E.G.  40118 59623 7012EE 40118 70500 .
C                THIS WILL NOW HAVE BECOME
C                40118 59623        40118         AND POINTERS ARE
C                      I            K
C                40118 59623 NEED TO BE REMOVED.
 400  CONTINUE
C
      I = I - 6
      N = K - 1
      IF((KCHAR(I)   .EQ. KCHAR(K))   .AND.
     1   (KCHAR(I+1) .EQ. KCHAR(K+1)) .AND.
     2   (KCHAR(I+2) .EQ. KCHAR(K+2)) .AND.
     3   (KCHAR(I+3) .EQ. KCHAR(K+3)) .AND.
     4   (KCHAR(I+4) .EQ. KCHAR(K+4)))
     5         THEN
                   DO 401 J=I,N
                       KCHAR(J) = 32
  401              CONTINUE
               END IF
C
C     GO BACK TO BEGINNING OF SUBROUTINE TO FIND OUT
C     IF THERE ARE MORE 'E'-CORRECTIONS.
C
      GO TO 100
C
      END
      
      SUBROUTINE KKXINT (IHEAD,IERR)
C
C**** *KKXINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT TESAC REPORTS  FROM CCITT 5 CHARACTER
C         FORMAT TO INTERMEDIATE (INTEGER) FORMAT
C
C         INPUT    : REPORT IN KCHAR(IPT) - KCHAR(IEQ),
C                    IN CCITT 5, 1 CHARACTER PER WORD.
C
C                    IHEAD = 0  INDICATES BULLETIN HEADER NOT ALREADY
C                               WRITTEN TO ERROR FILE
C                          = 1  MEANS HEADER ALREADY WRITTEN TO ERROR FILE
C
C                    IERR       NOT USED ON INPUT
C
C          OUTPUT   : REPORTS IN INTEGER FORMAT IN ARRAY 'KINT' IN DESIRED
C                     FORMAT (SEE SEPARATE DOCUMENTATION).
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *KKXINT(IHEAD,IERR)*
C
C     METHOD.
C     -------
C
C         IF AN ERROR IS FOUND IN THE DATA, THE DECODING IS PROCE
C         UNLESS THE ERROR IS FATAL I.E.
C         LAT/LONG OR TIME/DATE IS INCORRECT.
C         WHEN A NON FATAL ERROR HAS BEEN DETECTED THE ROUTINE TR
C         TO FIND THE BEGINNING OF CORRECT DATA. IF CORRECT DATA
C         FOUND THE DECODING THE NUMBER OF NON-FATAL ERRORS IS CO
C         AND IF IT IS GREATER THAN LIMIT (5 FOR NOW) ALL THE DAT
C         AFTER THE FIRST ERROR ARE REMOVED (THIS IS DONE TO ENSU
C         THAT TOTALLY CORRUPTED DATA ARE NOT USED E.G. WRONG PAR
C         OF TESAC).
C         FOR THIS PURPOSE TWO VARIABLES ARE USED
C             NUMERR = NUMBER OF NON-FATAL ERRORS
C             IREMPOS= THE POINTER TO FIRST ERROR IN 'KINT'.
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *ERRSTA(      )*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
C     ------------------------------------------------------------------
C*          1.  CLEAR FLAGS AND ERROR INDICATOR. KEEP POINTER TO FIRST
C               ------------------------------------------------------
C               CHARACTER OF REPORT.
C               --------------------
 100  CONTINUE
C
C
C     POINTER TO FIRST CHARACTER
C
      KEEP=IPT
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST= 0
C
C     ERROR INDICATOR
C
 101  KERR   = 0
      NUMERR = 0
      IREMPOS= 10
C
C
C*          1.1  CHECK FOR 'NIL' REPORT.
C                -----------------------
 110  CONTINUE
C
      NIL= 0
C
      LEN=IEQ-IPT
      IF(LEN.LE.30)
     &   THEN
            KERR=1
            NIL =1
            CALL ERRSTA(24,0,IFIRST,NUMERR)
         END IF
C
C     SET AREA FOR INTERMEDIATE (INTEGER) REPORT TO MISSING DATA VALUE
C
      DO 111 I=1,8192
         KINT(I)=MINDIC
 111  CONTINUE
C
C
C*          1.2 CLEAR DATA FOR PREVIOUS REPORT FROM
C               -----------------------------------
C               DECODED REPORT HEADER AREA .
C               ----------------------------
 120  CONTINUE
C
      DO 121 I=1,3
         KDEC(I)=MINDIC
 121  CONTINUE
C
      DO 122 I=5,9
         KDEC(I)=MINDIC
 122  CONTINUE
C
      KDEC(13)=MINDIC
      KDEC(15)=KDEC(15).AND.4
      KDEC(16)=MINDIC
      KDEC(17)=MINDIC
C
      KDEC(20)=0
      KDEC(22)=MINDIC
      KDEC(23)=1
C
C     -----------------------------------------------------------------
C*          2. SECTION 1 - IDENTIFICATION AND POSITION DATA;
C              (WHENEVER AVAILABLE) SURFACE PRESSURE AND SEA SURFACE
C              TEMPERATURE; (OPTIONAL) WIND,AIR TEMPERATURE
C                 PRESSURE TENDENCY.
C
 200  CONTINUE
C
C     YYMMJ - GROUP
C
      CALL NEXTFIG(IPT,IEQ)
      IF(IPT .GT. IEQ) GO TO 600
C
      CALL EXTGRP(IPT,2,2,1,0,0,1,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=2
            CALL ERRSTA(24,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
            GO TO 600
         END IF
C
C     YY GG /
C     -- -- -
      CALL NEXSEP2 (IPT,IEQ,*600)
      CALL NEXPRT2 (IPT,IEQ,*600)
C
      CALL EXTGRP(IPT,2,2,1,0,0,4,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=3
            CALL ERRSTA(24,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
            GO TO 600
         END IF
C
      IF(KINT(1).LT.1.OR.KINT(1).GT.31)
     &   THEN
            IRET=1
            KINT(1)=MINDIC
         END IF
C
      IF(KINT(2).LT.1.OR.KINT(2).GT.12)
     &   THEN
            IRET=2
            KINT(2)=MINDIC
         END IF
C
      IF(KINT(3).LT.0.OR.KINT(3).GT.9) THEN
         IRET=3
         KINT(3)=MINDIC
      END IF
C 
      IF(KINT(4).LT.0.OR.KINT(4).GT.24)
     &   THEN
            IRET=2
            KINT(4)=MINDIC
         END IF
      IF(KINT(5).LT.0.OR.KINT(5).GT.59)
     &   THEN
            IRET=2
            KINT(4)=MINDIC
         END IF
C
      IF(IRET.NE.0)
     &   THEN
C
C           CHECK IF ALREADY KNOWN TO BE 'NIL' - REPORT
C
            IF(NIL.EQ.1)
     &         THEN
                  KERR=1
                  RETURN
               END IF
C
            KERR=2
            CALL ERRSTA(24,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
            RETURN
C
         END IF
C
C     QCLALALALA - GROUP
C     - - - - -
C
      CALL NEXSEP2 (IPT,IEQ,*600)
      CALL NEXPRT2(IPT,IEQ,*600)
C
      CALL EXTGRP (IPT,1,4,0,0,0,7,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=4
            CALL ERRSTA(24,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
            GO TO 600
         END IF
C
C     LOLOLOLOLO - GROUP
C     - - - - -
C
      CALL NEXSEP2 (IPT,IEQ,*600)
      CALL NEXPRT2(IPT,IEQ,*600)
C
      CALL EXTGRP (IPT,5,0,0,0,0,9,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=5
            CALL ERRSTA(24,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
            GO TO 600
         END IF
C-----------------------------------------------------------------------
 210  CONTINUE
C
C     CHECK IF THE NEXT GROUP IS BEGINING OF SECTION 2
C
      CALL NEXSEP2(IPT,IEQ,*600)
      CALL NEXPRT2(IPT,IEQ,*600)
C
      IF(KCHAR(IPT  ) .EQ. 56.AND.
     &   KCHAR(IPT+1) .EQ. 56.AND.
     &   KCHAR(IPT+2) .EQ. 56.AND.
     &   KCHAR(IPT+5) .LE. 32     )
     &   THEN
C           BEGINING OF THE SECTION 2 FOUND
            GO TO 300
         END IF
C
C     THERE ARE SOME USEFULL INFORMATION IN SECTION 1
C
      CALL EXTVAL(IPT,1,IVAL)
C
C
      IF(IVAL .EQ. 4)
     &   THEN
C           AIR TEMPERATURE FOUND
C
            CALL EXTGRP (IPT,1,1,3,0,0,13,IRET)
            IF(IRET.NE.0)
     &          THEN
                   KERR=7
                   CALL ERRSTA(24,1,IFIRST,NUMERR)
                   IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
                   IF(NUMERR.EQ.1) IREMPOS=13
                END IF
C
            GO TO 210
C
         ELSE
C
            IF(KINT(10).EQ.MINDIC)
     &         THEN
C                 WIND DIRECTION AND SPEED
C
                  CALL EXTGRP (IPT,1,2,2,0,0,10,IRET)
                  IF(IRET.NE.0)
     &               THEN
                        KERR=8
                        CALL ERRSTA(24,1,IFIRST,NUMERR)
                        IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
                        IF(NUMERR.EQ.1) IREMPOS=10
                     END IF
C
               END IF
C
         END IF
C
      GO TO 210
C-----------------------------------------------------------------------
C*          3. SECTION 2 - TEMPERATURES AND SALINITY AT EITHER SIGNOFICANT
C              OR SELECTED DEPTHS
C
 300  CONTINUE
C
      CALL EXTGRP (IPT,3,1,1,0,0,16,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=9
            CALL ERRSTA(24,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=16
         END IF
C-----------------------------------------------------------------------
      IPOS=19
      IR  =0
C
 310  CONTINUE
C
      CALL NEXSEP2 (IPT,IEQ,*600)
      CALL NEXPRT2(IPT,IEQ,*600)
C
      IF(KCHAR(IPT  ) .EQ. 48.AND.
     &   KCHAR(IPT+1) .EQ. 48.AND.
     &   KCHAR(IPT+2) .EQ. 48.AND.
     &   KCHAR(IPT+3) .EQ. 48.AND.
     &   KCHAR(IPT+4) .EQ. 48.AND.
     &   KCHAR(IPT+5) .LE. 32     )
     &   THEN
C           END OF SECTION 2 REACHED
            GO TO 320
         END IF
C
      IF(KCHAR(IPT ).GE.65.AND.KCHAR(IPT  ).LE.90)
     &   THEN
C           PROBABLY SHIP'S CALL SIGN FOUND
C
            KPT=IPT
            CALL NEXTSEP(KPT,IEQ)
            if(kpt.gt.ieq) kpt=ieq
C
            NC=KPT-IPT
C
            DO 311 I=1,NC
C
            IF(KCHAR(IPT-1+I).GE.65.AND.KCHAR(IPT-1+I).LE.90)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I) 
               END IF
C
            IF(KCHAR(IPT-1+I).GE.48.AND.KCHAR(IPT-1+I).LE.57)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I) 
               END IF
C
 311        CONTINUE
C
            GO TO 600
C
         END IF
C
      IF(KCHAR(IPT  ).GE.48.AND.KCHAR(IPT  ).LE.57 .AND.
     &   KCHAR(IPT+1).GE.65.AND.KCHAR(IPT+1).LE.90       )
     &   THEN
C           PROBABLY SHIP'S CALL SIGN FOUND
C
            KPT=IPT
            CALL NEXTSEP(KPT,IEQ)
            if(kpt.gt.ieq) kpt=ieq
C
            NC=KPT-IPT
C
            DO 312 I=1,NC
C
            IF(KCHAR(IPT-1+I).GE.65.AND.KCHAR(IPT-1+I).LE.90)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I) 
               END IF
C
            IF(KCHAR(IPT-1+I).GE.48.AND.KCHAR(IPT-1+I).LE.57)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I) 
               END IF
C
 312        CONTINUE
C
            GO TO 600
C
         END IF
C
C
      IF(KCHAR(IPT  ) .EQ. 54.AND.
     &   KCHAR(IPT+1) .EQ. 54.AND.
     &   KCHAR(IPT+2) .EQ. 54.AND.
     &   KCHAR(IPT+5) .LE. 32     )
     &   THEN
C           BEGINING OF THE SECTION 3 FOUND
            GO TO 400
         END IF
C
C
      IF(KCHAR(IPT  ) .EQ. 53.AND.
     &   KCHAR(IPT+1) .EQ. 53.AND.
     &   KCHAR(IPT+2) .EQ. 53.AND.
     &   KCHAR(IPT+3) .EQ. 53.AND.
     &   KCHAR(IPT+4) .EQ. 53.AND.
     &   KCHAR(IPT+5) .LE. 32     )
     &   THEN
C           BEGINING OF THE SECTION 4 FOUND
            GO TO 500
         END IF
C
C     TEMPERATURES AT SIGNIFICANT DEPTHS FOLLOW
C
      CALL EXTVAL(IPT,1,IVAL)
C
      IF(IVAL.EQ.2)
     &   THEN
            CALL EXTGRP (IPT,1,4,0,0,0,IPOS,IRET)
            IF(IRET.NE.0)
     &         THEN
                  KERR=10
                  CALL ERRSTA(24,1,IFIRST,NUMERR)
                  IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
                  IF(NUMERR.EQ.1) IREMPOS=IPOS
               END IF
C
            GO TO 310
C
         ELSE
C
            IF(IR.EQ.0) IPOS=IPOS+2
            IR=1
C
         END IF
C
      IF(IVAL.EQ.3)
     &   THEN
            CALL EXTGRP (IPT,1,4,0,0,0,IPOS,IRET)
            IF(IRET.NE.0)
     &         THEN
                  KERR=11
                  CALL ERRSTA(24,1,IFIRST,NUMERR)
                  IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
                  IF(NUMERR.EQ.1) IREMPOS=IPOS
               END IF
C
            GO TO 310
C
         ELSE
C
            IPOS=IPOS+2
C
         END IF
C
      IF(IVAL.EQ.4)
     &   THEN
            CALL EXTGRP (IPT,1,4,0,0,0,IPOS,IRET)
            IF(IRET.NE.0)
     &         THEN
                  KERR=12
                  CALL ERRSTA(24,1,IFIRST,NUMERR)
                  IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
                  IF(NUMERR.EQ.1) IREMPOS=IPOS
               END IF
C
            IPOS=IPOS+2
            IR  =0
C
            GO TO 310
C
         ELSE
C
            IPOS=IPOS+2
            IR  =0
C
            CALL NEXSEP2(IPT,IEQ,*600)
C
            GO TO 310
C
         END IF
C-----------------------------------------------------------------------
 320  CONTINUE
C
      CALL EXTGRP (IPT,5,0,0,0,0,199,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=13
            CALL ERRSTA(24,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=199
         END IF
C
      GO TO 310
C
C     -----------------------------------------------------------------
C*          4. SECTION 3 - CURRENT AT SELECTED AND/OR
C              SIGNIFICANT DEPTHS(OPTION)
C
 400  CONTINUE
C
      CALL EXTGRP (IPT,3,1,1,0,0,200,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=14
            CALL ERRSTA(24,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=200
         END IF
      IPOS=203
C
 410  CONTINUE
C
      CALL NEXSEP2(IPT,IEQ,*600)
      CALL NEXPRT2(IPT,IEQ,*600)
C
      IF(KCHAR(IPT ).GE.65.AND.KCHAR(IPT  ).LE.90)
     &   THEN
C           PROBABLY SHIP'S CALL SIGN FOUND
C
            KPT=IPT
            CALL NEXTSEP(KPT,IEQ)
            if(kpt.gt.ieq) kpt=ieq
C
            NC=KPT-IPT
C
            DO 411 I=1,NC
C
            IF(KCHAR(IPT-1+I).GE.65.AND.KCHAR(IPT-1+I).LE.90)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I)
               END IF
C
            IF(KCHAR(IPT-1+I).GE.48.AND.KCHAR(IPT-1+I).LE.57)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I)
               END IF
C
 411        CONTINUE
C
            GO TO 600
C
         END IF
C
      IF(KCHAR(IPT  ).GE.48.AND.KCHAR(IPT  ).LE.57 .AND.
     &   KCHAR(IPT+1).GE.65.AND.KCHAR(IPT+1).LE.90       )
     &   THEN
C           PROBABLY SHIP'S CALL SIGN FOUND
C
            KPT=IPT
            CALL NEXTSEP(KPT,IEQ)
            if(kpt.gt.ieq) kpt=ieq
C
            NC=KPT-IPT
C
            DO 412 I=1,NC
C
            IF(KCHAR(IPT-1+I).GE.65.AND.KCHAR(IPT-1+I).LE.90)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I) 
               END IF
C
            IF(KCHAR(IPT-1+I).GE.48.AND.KCHAR(IPT-1+I).LE.57)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I) 
               END IF
C
 412        CONTINUE
C
            GO TO 600
C
         END IF
C
      IF(KCHAR(IPT  ) .EQ. 53.AND.
     &   KCHAR(IPT+1) .EQ. 53.AND.
     &   KCHAR(IPT+2) .EQ. 53.AND.
     &   KCHAR(IPT+3) .EQ. 53.AND.
     &   KCHAR(IPT+4) .EQ. 53.AND.
     &   KCHAR(IPT+5) .LE. 32     )
     &   THEN
C           BEGINING OF THE SECTION 4 FOUND
            GO TO 500
         END IF
C
C     THERE ARE SOME INFORMATION ABOUT CURRENT
C
      CALL EXTVAL(IPT,1,IVAL)
      IF(IVAL.EQ.2)
     &   THEN
            CALL EXTGRP (IPT,1,4,0,0,0,IPOS,IRET)
            IF(IRET.NE.0)
     &         THEN
                  KERR=15
                  CALL ERRSTA(24,1,IFIRST,NUMERR)
                  IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
                  IF(NUMERR.EQ.1) IREMPOS=IPOS
                END IF
C
            GO TO 410

         ELSE
            IPOS=IPOS+2
            CALL EXTGRP (IPT,2,3,0,0,0,IPOS,IRET)
            IF(IRET.NE.0)
     &         THEN
                  KERR=16
                  CALL ERRSTA(24,1,IFIRST,NUMERR)
                  IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
                  IF(NUMERR.EQ.1) IREMPOS=IPOS
                END IF
C
            IPOS=IPOS+2
            GO TO 410
C
         END IF
C
C     ----------------------------------------------------------------
C*          5. SECTION 4 - TOTAL WATER DEPTH (OPTIONAL).
C              -----------------------------------------
 500  CONTINUE
C
      CALL EXTGRP (IPT,5,0,0,0,0,343,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=17
            CALL ERRSTA(24,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=343
         END IF
C
 510  CONTINUE
C
      CALL NEXSEP2(IPT,IEQ,*600)
      CALL NEXPRT2(IPT,IEQ,*600)
C
      IF(KCHAR(IPT ).GE.65.AND.KCHAR(IPT  ).LE.90)
     &   THEN
C           PROBABLY SHIP'S CALL SIGN FOUND
C
            KPT=IPT
            CALL NEXTSEP(KPT,IEQ)
            if(kpt.gt.ieq) kpt=ieq
C
            NC=KPT-IPT
C
            DO 511 I=1,NC
C
            IF(KCHAR(IPT-1+I).GE.65.AND.KCHAR(IPT-1+I).LE.90)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I)
               END IF
C
            IF(KCHAR(IPT-1+I).GE.48.AND.KCHAR(IPT-1+I).LE.57)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I)
               END IF
C
 511        CONTINUE
C
            GO TO 600
C
         END IF
C
      IF(KCHAR(IPT  ).GE.48.AND.KCHAR(IPT  ).LE.57 .AND.
     &   KCHAR(IPT+1).GE.65.AND.KCHAR(IPT+1).LE.90       )
     &   THEN
C           PROBABLY SHIP'S CALL SIGN FOUND
C
            KPT=IPT
            CALL NEXTSEP(KPT,IEQ)
            if(kpt.gt.ieq) kpt=ieq
C
            NC=KPT-IPT
C
            DO 512 I=1,NC
C
            IF(KCHAR(IPT-1+I).GE.65.AND.KCHAR(IPT-1+I).LE.90)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I) 
               END IF
C
            IF(KCHAR(IPT-1+I).GE.48.AND.KCHAR(IPT-1+I).LE.57)
     &         THEN
                  KINT(346-1+I)=KCHAR(IPT-1+I) 
               END IF
C
 512        CONTINUE
C
            GO TO 600
C
         END IF
C
      CALL EXTVAL(IPT,1,IVAL)
      IF(IVAL.EQ.1)
     &   THEN
            CALL EXTGRP (IPT,1,4,0,0,0,344,IRET)
            IF(IRET.NE.0)
     &         THEN
                  KERR=18
                  CALL ERRSTA(24,1,IFIRST,NUMERR)
                  IF(IFIRST.NE.0) NOER(24,KERR)=NOER(24,KERR)+1
                  IF(NUMERR.EQ.1) IREMPOS=344
                END IF
C
            GO TO 510

         ELSE
            CALL NEXSEP2(IPT,IEQ,*600)
C
            GO TO 510
C
         END IF
C-----------------------------------------------------------------------
 600  CONTINUE
C***
C*    ERROR CHECKING AND HANDLING
C****
C     RETURN IF NO ERRORS IN REPORT
C
      IF(KERR.EQ.0) RETURN
C
C     IF FIRST DECODING ATTEMPT ,TRY TO CORRECT
C     THE ERROR AND DECODE AGAIN
C
      IF(IFIRST.EQ.0) THEN
                         IPT=KEEP
                         CALL FIXSO
                         IFIRST=1
                         NUMRERR(24)=NUMRERR(24)+1
                         GO TO 101
                      ELSE
                         CALL SAVREP(IHEAD,IERR)
C
C                        CLEAR PARITY BIT AFTER SAVING ERROR FILE
C
                         DO 601 I=KEEP,IGS
                         KCHAR(I)=KCHAR(I).AND.127
 601                     CONTINUE
C
C                        ONLY REPORTS WITH ERROR IN DATE/TIME
C                        OR LAT/LONG ARE NOT PROCESSED ANY FURTHER
C
C                        IF THERE ARE MORE THEN 5 NON-FATAL ERRORS
C                        IN REPORT IT IS ONLY PROCESSED UNTIL THE
C                        FIRST ERROR
C
                         IF(NUMERR.GT.5) THEN
                                            DO 602 I=IREMPOS,8192
                                            KINT(I)=MINDIC
 602                                        CONTINUE
                                         END IF
C
c                         IF(KERR.GT.6) KERR=0
                          if(kerr.gt.6) then
                           kerr = 0
c                          ierr = 0
                          end if
c
                      END IF
C
 610  CONTINUE
C
C      CALL PRTKINT(KINT,1,120,MINDIC)
C
      RETURN
      END
      
      SUBROUTINE JJXDEC(IHEAD,IERR)
C
C**** *JJXDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE BATHY REPORT  FROM INTERMEDIATE
C         FORMAT TO FULL DECODED FORMAT
C
C         INPUT    : REPORT IN INTERMEDIATE FORMAT IN 'KINT'
C
C         OUTPUT   : REPORT WRITTEN INTO DECODED REPORT FILE 04
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *JJXDEC(IHEAD,IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *QLALOM(                )*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comident.h' 
      INCLUDE 'comwt.h'
C
C     ------------------------------------------------------------------
C*          1.  CLEAR ERROR INDICATOR.             .
C                ---------------------
 100  CONTINUE
C
      KERR=0
C
C*          1.1 SET UNUSED HEADER FIELDS TO MISSING DATA INDICATOR
C               --------------------------------------------------
C               (ALTITUDE,WMO REGION AND COUNTRY,RESERVED FIELDS).
C               --------------------------------------------------
 110  CONTINUE
C
      KDEC(07)=MINDIC
      KDEC(08)=MINDIC
      KDEC(13)=MINDIC
      KDEC(15)=KDEC(15).AND.4
      KDEC(16)=MINDIC
      KDEC(17)=MINDIC
      KDEC(21)=MINDIC
      KDEC(22)=MINDIC
C
C     CLEAR 'NIL' REPORT INDICATOR
C
      KDEC(20)=0
C
C     SET DECODED REPORT TO MISSING DATA VALUE
C
      DO 111 I=25,1536
      KDEC(I)=MINDIC
 111  CONTINUE
C
C
C     ------------------------------------------------------------------
C*          2. SET UP HEADER OF FULLY EXPANDED DRIBU FORMAT.
C              ---------------------------------------------
 200  CONTINUE
C
C*    SET UP DAY, HOUR AND MINUTE
C
      KDEC(1)=KINT(1)
      KDEC(2)=KINT(4)
      KDEC(9)=KINT(5)
C
C*    SET UP LATITUDE AND LONGITUDE
C
      CALL QLALOM(KINT(7),KINT(8),KINT(9),MINDIC,KDEC(5),KDEC(6))
      IF(KDEC(5).EQ.MINDIC.OR.KDEC(6).EQ.MINDIC)
     1   THEN
            IERR=5
            RETURN
         END IF
C
C     SET SHIP'S CALL SIGN
C
      IBL=32
C
      IF(KINT(145).EQ.MINDIC.OR.
     &   KINT(146).EQ.MINDIC.OR.
     &   KINT(147).EQ.MINDIC    )
     &   THEN
            IDENT(1)=88
            IDENT(2)=88
            IDENT(3)=88
            IDENT(4)=IBL
            IDENT(5)=IBL
            IDENT(6)=IBL
            IDENT(7)=IBL
            IDENT(8)=IBL
            IDENT(9)=IBL
         ELSE
            IDENT(1)=KINT(145)
            IDENT(2)=KINT(146)
            IDENT(3)=KINT(147)
            IF(KINT(148).EQ.MINDIC) THEN
                                       IDENT(4)=32
                                    ELSE     
                                       IDENT(4)=KINT(148)
                                    END IF
            IF(KINT(149).EQ.MINDIC) THEN
                                       IDENT(5)=32
                                    ELSE     
                                       IDENT(5)=KINT(149)
                                    END IF
            IDENT(6)=32
            IDENT(7)=32
            IDENT(8)=32
            IDENT(9)=32
         END IF
C
      KDEC(7)=88
C
C
C*    SET ENGINEERING STATUSOF BUOY,INDICATOR FOR TYPE OF DROGUE
C*    AND LENGTH OF CABLE AT WICH THE DROGUE IS ATTACHED
C
C      IU- KINT(10)
C      I5  KINT(142)
C
C
C*    SET UP LENGTH OF REPORT
C
      KDEC(24)=288
C
C
C*    WIND DIRECTION AND SPEED
C
      IF(KINT(11).NE.MINDIC.AND.
     &   KINT(12).NE.MINDIC     )
     &   THEN
            KDEC(26)=KINT(11)*10
            IF(KINT(11).EQ.99) KDEC(26)=0
            IF(KINT(11).EQ.0 )
     &          THEN
                   KDEC(26)=0
                   KDEC(27)=0
               END IF
         IF(KINT(10).EQ.0.OR.KINT(10).EQ.2)
     &      THEN
C              WIND SPEED IN (M/S)
               KDEC(27)=KINT(12)
            END IF
C
         IF(KINT(10).EQ.1.OR.KINT(10).EQ.3)
     &      THEN
C              WIND SPEED IN KNOTS
               KDEC(27)=KINT(12)/2. + .5
            END IF
         END IF
C
C*    AIR TEMPERATURE
C
      IF(KINT(14).NE.MINDIC.AND.
     &   KINT(15).NE.MINDIC     )
     &   THEN
            IF(KINT(14).EQ.0)
     &         THEN
                  KDEC(28)=KINT(15)
               END IF
            IF(KINT(14).EQ.1)
     &         THEN
                  KDEC(28)=-KINT(15)
               END IF
         END IF
C
C*    TOTAL WATER DEPTH IN METRES
C
      KDEC(32)=KINT(141)
C
C*    SURFACE CURRENT DIRRECTION AND SPEED
C
      IF(KINT(143).NE.MINDIC) KDEC(36)=KINT(143)*10
C
      KDEC(37)=KINT(144)
C
C*    DEPTHS AND TEMPERATURES
C
      IPKT=18
      IPKD=38
      IZZ=0
C
      DO 201 I=1,49
C
      IF(KINT(IPKT  ).NE.MINDIC.AND.
     &   KINT(IPKT+1).NE.MINDIC     )
     &   THEN
            IF(KINT(IPKT).NE.999)
     &         THEN
                  KDEC(IPKD  )=KINT(IPKT) + IZZ
                  IF(KINT(IPKT+1).GT.500)
     &               THEN
                        KDEC(IPKD+1)=-(KINT(IPKT+1)-500)*10
                     ELSE
                        KDEC(IPKD+1)=  KINT(IPKT+1)*10
                     END IF
               ELSE
                  IZZ=KINT(IPKT+1)*100
                  IPKT=IPKT+2
                  IF(KINT(IPKT  ).NE.MINDIC.AND.
     &               KINT(IPKT+1).NE.MINDIC     )
     &               THEN
                        KDEC(IPKD)=  KINT(IPKT) + IZZ
                        IF(KINT(IPKT+1).GT.500)
     &                     THEN
                              KDEC(IPKD+1)=-(KINT(IPKT+1)-500)*10
                           ELSE
                              KDEC(IPKD+1)=  KINT(IPKT+1)*10
                           END IF
                     END IF
               END IF
          END IF
C
      IPKD=IPKD+5
      IPKT=IPKT+2
C
      IF(IPKT.GE.145) GO TO 300
C
 201  CONTINUE
C
C     -------------------------------------------------------------
C           3. SET UP WORKING TABLES.
C              ----------------------
 300  CONTINUE
C
C     CALL PRTBULL(IMI,IEQ)
C     CALL PRTKINT(KINT,1,120,MINDIC)
C     CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
C
      CALL WTBATHY(IERR )
C     -------------------------------------------------------------
C           4. QUALITY CONTROL BATHY BASIC SURFACE REPORT.
C              -------------------------------------------
 400  CONTINUE
C
      IF(.NOT.L21) GO TO 600
      CALL QCBATHY(IERR)
C     -------------------------------------------------------------
C           5. ENCODE BUFR MESSAGE.
C              --------------------
 500  CONTINUE
C
      CALL BENCB(IERR)
C
C     -------------------------------------------------------------
C           6. MOVE VALUEW INTO VALUES ARRAY.
C              ------------------------------
 600  CONTINUE
C
       IF(.NOT.L22) GO TO 900
       CALL QCCON( IERR )
C     -------------------------------------------------------------
C           7. QUALITY CONTROL BATHY SUB-SURFACE DATA.
C              ---------------------------------------
 700  CONTINUE
C
      CALL QCBATHY(IERR)
C     -------------------------------------------------------------
C           8. ENCODE BUFR MESSAGE.
C              --------------------
 800  CONTINUE
C
      CALL BENCB(IERR)
C     -------------------------------------------------------------
 900  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE KKXDEC(IHEAD,IERR)
C
C**** *KKXDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE TESAC REPORT  FROM INTERMEDIATE
C         FORMAT TO FULL DECODED FORMAT
C
C         INPUT    : REPORT IN INTERMEDIATE FORMAT IN 'KINT'
C
C         OUTPUT   : REPORT WRITTEN INTO DECODED REPORT FILE 04
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *KKXDEC(IHEAD,IERR)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comident.h'
      INCLUDE 'comwt.h'
C
C     ------------------------------------------------------------------
C*          1.   CLEAR ERROR INDICATOR.            .
C                ----------------------
 100  CONTINUE
C
      KERR=0
C
C*          1.1  SET UNUSED HEADER FIELDS TO MISSING DATA INDICATOR
C                (ALTITUDE,WMO REGION AND COUNTRY,RESERVED FIELDS)
 110  CONTINUE
C
      KDEC(07)=MINDIC
      KDEC(08)=MINDIC
      KDEC(13)=MINDIC
      KDEC(15)=KDEC(15).AND.4
      KDEC(16)=MINDIC
      KDEC(17)=MINDIC
      KDEC(21)=MINDIC
      KDEC(22)=MINDIC
C
C     CLEAR 'NIL' REPORT INDICATOR
C
      KDEC(20)=0
C
C     SET DECODED REPORT TO MISSING DATA VALUE
C
      DO 111 I=25,1536
      KDEC(I)=MINDIC
 111  CONTINUE
C
C     -------------------------------------------------------------------
C*          2. SET UP HEADER OF FULLY EXPANDED DRIBU FORMAT.
C              ---------------------------------------------
 200  CONTINUE
C
C*    SET UP DAY, HOUR AND MINUTE
C
      KDEC(1)=KINT(1)
      KDEC(2)=KINT(4)
      KDEC(9)=KINT(5)
C
C*    SET UP LATITUDE AND LONGITUDE
C
      CALL QLALOM(KINT(7),KINT(8),KINT(9),MINDIC,KDEC(5),KDEC(6))
      IF(KDEC(5).EQ.MINDIC.OR.KDEC(6).EQ.MINDIC)
     1   THEN
            IERR=5
            RETURN
         END IF
C
C*    SET SHIP'S CALL SIGN
C
      IBL=32
C
      IF(KINT(346).EQ.MINDIC.OR.
     &   KINT(347).EQ.MINDIC.OR.
     &   KINT(348).EQ.MINDIC    )
     &   THEN
            IDENT(1)=88
            IDENT(2)=88
            IDENT(3)=88
            IDENT(4)=IBL
            IDENT(5)=IBL
            IDENT(6)=IBL
            IDENT(7)=IBL
            IDENT(8)=IBL
            IDENT(9)=IBL
         ELSE
            IDENT(1)=KINT(346)
            IDENT(2)=KINT(347)
            IDENT(3)=KINT(348)
            IF(KINT(349).EQ.MINDIC) THEN
                                       IDENT(4)=32
                                    ELSE     
                                       IDENT(4)=KINT(349)
                                    END IF
            IF(KINT(350).EQ.MINDIC) THEN
               IDENT(5)=32
            ELSE     
              ident(5)=32
              if(kint(350).le.48.and.kint(350).le.90)IDENT(5)=KINT(350)
            END IF
            IDENT(6)=32
            IDENT(7)=32
            IDENT(8)=32
            IDENT(9)=32
         END IF
C
      KDEC(7)=88
C
C
C*    SET IU, K1, K2, K3 AND K4
C
C     KINT( 10)  - IU
C     KINT( 17)  - K1
C     KINT( 18)  - K2
C     KINT(201)  - K4
C     KINT(202)  - K3
C
C
C*    SET UP LENGTH OF REPORT
C
      KDEC(24)=288
C
C*    WIND DIRECTION AND SPEED
C
      IF(KINT(11).NE.MINDIC.AND.
     &   KINT(12).NE.MINDIC     )
     &   THEN
            KDEC(26)=KINT(11)*10
            IF(KINT(11).EQ.99) KDEC(26)=0
            IF(KINT(11).EQ.0 )
     &          THEN
                   KDEC(26)=0
                   KDEC(27)=0
               END IF
         IF(KINT(10).EQ.0.OR.KINT(10).EQ.2)
     &      THEN
C              WIND SPEED IN (M/S)
               KDEC(27)=KINT(12)
            END IF
C
         IF(KINT(10).EQ.1.OR.KINT(10).EQ.3)
     &      THEN
C              WIND SPEED IN KNOTS
               KDEC(27)=KINT(12)/2. + .5
            END IF
         END IF
C
C*    AIR TEMPERATURE
C
      IF(KINT(14).NE.MINDIC.AND.
     &   KINT(15).NE.MINDIC     )
     &   THEN
            IF(KINT(14).EQ.0)
     &         THEN
                  KDEC(28)=KINT(15)
               END IF
            IF(KINT(14).EQ.1)
     &         THEN
                  KDEC(28)=-KINT(15)
               END IF
         END IF
C
C*    TOTAL WATER DEPTH IN METRES
C
      KDEC(32)=KINT(345)
C
C*    TEMPERATURE, SALINITY, CURRENT DIRECTION AND SPEED
C
      IPKT1=20
      IPKT2=205
      IPKD =38
C
      DO 201 I=1,29
C
      IF(KINT(IPKT1).NE.MINDIC)
     &   THEN
            KDEC(IPKD)=KINT(IPKT1)
         END IF
C
      IF(KINT(IPKT1+2).NE.MINDIC)           ! TEMPERATURES
     &   THEN
            IF(KINT(IPKT1+2).GT.5000)
     &         THEN
                  KDEC(IPKD+1)=-KINT(IPKT1+2)-5000
               ELSE
                  KDEC(IPKD+1)= KINT(IPKT1+2)
               END IF
         END IF
C
      IF(KINT(IPKT1+4).NE.MINDIC)    !  SALINITY
     &   THEN
            KDEC(IPKD+2)=KINT(IPKT1+4)
         END IF
C
      IF(KINT(IPKT2  ).NE.MINDIC.AND.
     &   KINT(IPKT2+1).NE.MINDIC     )
     &   THEN
            KDEC(IPKD+3)=KINT(IPKT2)*10
            KDEC(IPKD+4)=KINT(IPKT2+1)
         END IF
C
C
      IPKT1=IPKT1 + 6
      IPKT2=IPKT2 + 4
      IPKD =IPKD  + 5
C
 201  CONTINUE
C
C     -------------------------------------------------------------
C           3. SET UP WORKING TABLES.
C              ----------------------
 300  CONTINUE
C
C     CALL PRTBULL(IMI,IEQ)
C     CALL PRTKINT(KINT,1,120,MINDIC)
C     CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
C
      CALL WTTESAC(IERR )
C     -------------------------------------------------------------
C           4. QUALITY CONTROL TESAC BASIC SURFACE REPORT.
C              -------------------------------------------
 400  CONTINUE
C
      IF(.NOT.L31) GO TO 600
      CALL QCTESAC(IERR)
C     -------------------------------------------------------------
C           5. ENCODE BUFR MESSAGE.
C              --------------------
 500  CONTINUE
C
      CALL BENCT(IERR)
C
C     -------------------------------------------------------------
C           6. MOVE VALUEW INOT VALUES ARRAY.
C              ------------------------------
 600  CONTINUE
C
      IF(.NOT.L32) GO TO 900
      CALL QCCON( IERR )
C
C     -------------------------------------------------------------
C           7. QUALITY CONTROL TESAC REPORT.
C              -------------------------------------------
 700  CONTINUE
C
      CALL QCTESAC(IERR)
C     -------------------------------------------------------------
C           8. ENCODE BUFR MESSAGE.
C              --------------------
 800  CONTINUE
C
      CALL BENCT(IERR)
C
C------------------------------------------------------------------
 900  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE FIXSO
C
C**** *FIXSO*
C
C
C     PURPOSE.
C     --------
C         TRY TO FIX ERROR.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *FIXSO*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C*          1.  CLEAR PARITI BITS .
C               -------------------
 100  CONTINUE
C
      DO 101 I=IPT,IGS
         KCHAR(I)=KCHAR(I).AND.127
 101  CONTINUE
C
C           1.1 CONVERT LETTERS INTO FIGURES IF NEEDED.
C               ---------------------------------------
 110  CONTINUE
C
      CALL REMEEE
C
      RETURN
      END
      
      SUBROUTINE JJXINT (IHEAD,IERR)
C
C**** *JJXINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT BATHY REPORTS  FROM CCITT 5 CHARACTER
C         FORMAT TO INTERMEDIATE (INTEGER) FORMAT
C
C         INPUT    : REPORT IN KCHAR(IPT) - KCHAR(IEQ),
C                    IN CCITT 5, 1 CHARACTER PER WORD.
C
C                    IHEAD = 0  INDICATES BULLETIN HEADER NOT ALREADY
C                               WRITTEN TO ERROR FILE
C                          = 1  MEANS HEADER ALREADY WRITTEN TO ERROR FILE
C
C                    IERR       NOT USED ON INPUT
C
C         OUTPUT   : REPORTS IN INTEGER FORMAT IN ARRAY 'KINT' IN DESIRED
C                    FORMAT (SEE SEPARATE DOCUMENTATION).
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *JJXINT(IHEAD,IERR)*
C
C     METHOD.
C     -------
C
C         IF AN ERROR IS FOUND IN THE DATA, THE DECODING IS PROCE
C         UNLESS THE ERROR IS FATAL I.E.
C         LAT/LONG OR TIME/DATE IS INCORRECT.
C         WHEN A NON FATAL ERROR HAS BEEN DETECTED THE ROUTINE TR
C         TO FIND THE BEGINNING OF CORRECT DATA. IF CORRECT DATA
C         FOUND THE DECODING THE NUMBER OF NON-FATAL ERRORS IS CO
C         AND IF IT IS GREATER THAN LIMIT (5 FOR NOW) ALL THE DAT
C         AFTER THE FIRST ERROR ARE REMOVED (THIS IS DONE TO ENSU
C         THAT TOTALLY CORRUPTED DATA ARE NOT USED E.G. WRONG PAR
C         OF BATHY).
C         FOR THIS PURPOSE TWO VARIABLES ARE USED
C            NUMERR = NUMBER OF NON-FATAL ERRORS
C            IREMPOS= THE POINTER TO FIRST ERROR IN 'KINT'.
C
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
C     ------------------------------------------------------------------
C*          1.  CLEAR FLAGS AND ERROR INDICATOR. KEEP POINTER TO FIRST
C               ------------------------------------------------------
C               CHARACTER OF REPORT.
C               --------------------
 100  CONTINUE
C
C     POINTER TO FIRST CHARACTER
C
      KEEP=IPT
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST= 0
C
C     ERROR INDICATOR
C
 101  KERR   = 0
      NUMERR = 0
      IREMPOS= 10
C
C
C*             1.1 CHECK FOR 'NIL' REPORT.
C                  -----------------------
 110  CONTINUE
C
      NIL= 0
C
      LEN=IEQ-IPT
      IF(LEN.LE.30)
     &   THEN
            KERR=1
            NIL =1
            CALL ERRSTA(23,0,IFIRST,NUMERR)
         END IF
C
C*            1.2  SET AREA FOR INTERMEDIATE (INTEGER) REPORT TO
C                  MISSING DATA VALUE
C
 120  CONTINUE
C
      DO 121 I=1,8192
         KINT(I)=MINDIC
 121  CONTINUE
C
C
C*          1.3 CLEAR DATA FOR PREVIOUS REPORT FROM DECODED
C               REPORT HEADER AREA.
C
 130  CONTINUE
C
      DO 131 I=1,3
         KDEC(I)=MINDIC
 131  CONTINUE
C
      DO 132 I=5,9
         KDEC(I)=MINDIC
 132  CONTINUE
C
C
      KDEC(13)=MINDIC
      KDEC(16)=MINDIC
      KDEC(17)=MINDIC
C
      KDEC(20)=0
      KDEC(22)=MINDIC
      KDEC(23)=1
C     ------------------------------------------------------------------
C           2.  SECTION 1 - IDENTIFICATION AND POSITION DATA;
C               (WHENEVER AVAILABLE) SURFACE PRESSURE AND SEA SURFACE
C               TEMPERATURE; (OPTIONAL) WIND,AIR TEMPERATURE
C               PRESSURE TENDENCY.
C
 200  CONTINUE
C
C     YYMMJ - GROUP
C
      CALL NEXTFIG(IPT,IEQ)
      IF(IPT .GT. IEQ) GO TO 500
C
      CALL EXTGRP(IPT,2,2,1,0,0,1,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=2
            CALL ERRSTA(23,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
            GO TO 500
         END IF
C
C     YY GG /
C     -- -- -
      CALL NEXSEP2 (IPT,IEQ,*500)
      CALL NEXPRT2 (IPT,IEQ,*500)
C
      CALL EXTGRP(IPT,2,2,1,0,0,4,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=3
            CALL ERRSTA(23,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
            GO TO 500
         END IF
C
      IF(KINT(1).LT.1.OR.KINT(1).GT.31)
     &   THEN
            IRET=1
            KINT(1)=MINDIC
         END IF
      IF(KINT(2).LT.1.OR.KINT(2).GT.12)
     &   THEN
            IRET=2
            KINT(2)=MINDIC
         END IF
C
      IF(KINT(3).LT.0.OR.KINT(3).GT.9) THEN
         IRET=3
         KINT(3)=MINDIC
      END IF
C 
      IF(KINT(4).LT.0.OR.KINT(4).GT.24)
     &   THEN
            IRET=2
            KINT(4)=MINDIC
         END IF
      IF(KINT(5).LT.0.OR.KINT(5).GT.59)
     &   THEN
            IRET=2
            KINT(4)=MINDIC
         END IF
C
      IF(IRET.NE.0)
     &   THEN
C
C           CHECK IF ALREADY KNOWN TO BE 'NIL' - REPORT
C
            IF(NIL.EQ.1) THEN
               KERR=1
               RETURN
            END IF
C
            KERR=2
            CALL ERRSTA(23,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
            RETURN
C
         END IF
C
C     QCLALALALA - GROUP
C     - - - - -
C
      CALL NEXSEP2(IPT,IEQ,*500)
      CALL NEXPRT2(IPT,IEQ,*500)
C
      CALL EXTGRP (IPT,1,4,0,0,0,7,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=4
            CALL ERRSTA(23,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
            GO TO 500
         END IF
C
C     LOLOLOLOLO - GROUP
C     - - - - -
C
      CALL NEXSEP2(IPT,IEQ,*500)
      CALL NEXPRT2(IPT,IEQ,*500)
C
      CALL EXTGRP (IPT,5,0,0,0,0,9,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=5
            CALL ERRSTA(23,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
            GO TO 500
         END IF
C-----------------------------------------------------------------------
 210  CONTINUE
C
C     CHECK IF THE NEXT GROUP IS BEGINING OF SECTION 2
C
      CALL NEXSEP2(IPT,IEQ,*500)
      CALL NEXPRT2(IPT,IEQ,*500)
C
      IF(KCHAR(IPT  ) .EQ. 56.AND.
     &   KCHAR(IPT+1) .EQ. 56.AND.
     &   KCHAR(IPT+2) .EQ. 56.AND.
     &   KCHAR(IPT+3) .EQ. 56.AND.
     &   KCHAR(IPT+5) .LE. 32       )
     &   THEN
C           BEGINING OF THE SECTION 2 FOUND
            GO TO 300
         END IF
C
C     THERE ARE SOME USEFULL INFORMATION IN SECTION 1
C
      CALL EXTVAL(IPT,1,IVAL)
C
C
      IF(IVAL .EQ. 4)
     &   THEN
C           AIR TEMPERATURE FOUND
C
            CALL EXTGRP (IPT,1,1,3,0,0,13,IRET)
            IF(IRET.NE.0)
     &          THEN
                   KERR=7
                   CALL ERRSTA(23,1,IFIRST,NUMERR)
                   IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
                   IF(NUMERR.EQ.1) IREMPOS=13
                END IF
C
            GO TO 210
C
         ELSE
            IF(KINT(10).EQ.MINDIC)
     &         THEN
C
C                 WIND DIRECTION AND SPEED
C
                  CALL EXTGRP (IPT,1,2,2,0,0,10,IRET)
                  IF(IRET.NE.0)
     &                THEN
                         KERR=9
                         CALL ERRSTA(23,1,IFIRST,NUMERR)
                         IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
                         IF(NUMERR.EQ.1) IREMPOS=10
                      END IF
C
               END IF
C
         END IF
C
      GO TO 210
C-----------------------------------------------------------------------
C*           3.  SECTION 2 - TEMPERATURES AT EITHER SIGNIFICANT
C                OR SELECTED DEPTHS
C
 300  CONTINUE
C
      CALL EXTGRP (IPT,4,1,0,0,0,16,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=10
            CALL ERRSTA(23,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=16
         END IF
C
      IPOS=18
C
 310  CONTINUE
C
      CALL NEXSEP2(IPT,IEQ,*500)
      CALL NEXPRT2(IPT,IEQ,*500)
C
      IF(KCHAR(IPT  ) .EQ. 48.AND.
     &   KCHAR(IPT+1) .EQ. 48.AND.
     &   KCHAR(IPT+2) .EQ. 48.AND.
     &   KCHAR(IPT+3) .EQ. 48.AND.
     &   KCHAR(IPT+4) .EQ. 48.AND.
     &   KCHAR(IPT+5) .LE. 32       )
     &   THEN
C           END OF SECTION 2 REACHED
            GO TO 320
         END IF
C
      IF(KCHAR(IPT  ) .EQ. 54.AND.
     &   KCHAR(IPT+1) .EQ. 54.AND.
     &   KCHAR(IPT+2) .EQ. 54.AND.
     &   KCHAR(IPT+3) .EQ. 54.AND.
     &   KCHAR(IPT+4) .EQ. 54.AND.
     &   KCHAR(IPT+5) .LE. 32       )
     &   THEN
C           BEGINING OF THE SECTION 3 FOUND
            GO TO 400
         END IF
C
      IF(KCHAR(IPT  ) .EQ. 57.AND.
     &   KCHAR(IPT+1) .EQ. 57.AND.
     &   KCHAR(IPT+2) .EQ. 57.AND.
     &   KCHAR(IPT+3) .EQ. 57.AND.
     &   KCHAR(IPT+4) .EQ. 57.AND.
     &   KCHAR(IPT+5) .LE. 32       )
     &   THEN
C           BEGINING OF THE SECTION 4 FOUND
            GO TO 450
         END IF
C
      IF(KCHAR(IPT ).GE.65.AND.KCHAR(IPT  ).LE.90)
     &   THEN
C           PROBABLY SHIP'S CALL SIGN FOUND
C
            KPT=IPT
            CALL NEXTSEP(KPT,IEQ)
            if(kpt.gt.ieq) kpt=ieq
C
            NC=KPT-IPT
C
            DO 311 I=1,NC
C
            IF(KCHAR(IPT-1+I).GE.65.AND.KCHAR(IPT-1+I).LE.90)
     &         THEN
                  KINT(145-1+I)=KCHAR(IPT-1+I) 
               END IF
C
            IF(KCHAR(IPT-1+I).GE.48.AND.KCHAR(IPT-1+I).LE.57)
     &         THEN
                  KINT(145-1+I)=KCHAR(IPT-1+I) 
               END IF
C
 311        CONTINUE
C
            GO TO 500
C
         END IF
C
      IF(KCHAR(IPT  ).GE.48.AND.KCHAR(IPT  ).LE.57 .AND.
     &   KCHAR(IPT+1).GE.65.AND.KCHAR(IPT+1).LE.90       )
     &   THEN
C           PROBABLY SHIP'S CALL SIGN FOUND
C
            KPT=IPT
            CALL NEXTSEP(KPT,IEQ)
            if(kpt.gt.ieq) kpt=ieq
C
            NC=KPT-IPT
C
            DO 312 I=1,NC
C
            IF(KCHAR(IPT-1+I).GE.65.AND.KCHAR(IPT-1+I).LE.90)
     &         THEN
                  KINT(145-1+I)=KCHAR(IPT-1+I)
               END IF
C
            IF(KCHAR(IPT-1+I).GE.48.AND.KCHAR(IPT-1+I).LE.57)
     &         THEN
                  KINT(145-1+I)=KCHAR(IPT-1+I)
               END IF
C
 312        CONTINUE
C
            GO TO 500
C
         END IF
C
C
C*    TEMPERATURES AT SIGNIFICANT DEPTHS FOLLOW
C
      IF(KCHAR(IPT  ).EQ.57.AND.
     &   KCHAR(IPT+1).EQ.57.AND.
     &   KCHAR(IPT+2).EQ.57     )
     &   THEN
            CALL EXTGRP (IPT,3,2,0,0,0,IPOS,IRET)
            IF(IRET.NE.0)
     &         THEN
                  KERR=12
                  CALL ERRSTA(23,1,IFIRST,NUMERR)
                  IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
                  IF(NUMERR.EQ.1) IREMPOS=IPOS
               END IF
C
            IPOS=IPOS+2
            GO TO 310
C
         END IF
C
      CALL EXTGRP (IPT,2,3,0,0,0,IPOS,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=12
            CALL ERRSTA(23,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=IPOS
         END IF
C
      IPOS=IPOS+2
C
      GO TO 310
C-----------------------------------------------------------------------
 320  CONTINUE
C
      CALL EXTGRP (IPT,5,0,0,0,0,138,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=13
            CALL ERRSTA(23,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=138
         END IF
C
      GO TO 310
C     -----------------------------------------------------------------
C*            4. SECTION 3 - TOTAL WATER DEPTH AND SURFACE
C                ------------------------------------------
C                CURRENT (OPTIONAL).
C                -------------------
 400  CONTINUE
C
      CALL EXTGRP (IPT,5,0,0,0,0,139,IRET)
      IF(IRET.NE.0)
     &   THEN
            KERR=14
            CALL ERRSTA(23,1,IFIRST,NUMERR)
            IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
            IF(NUMERR.EQ.1) IREMPOS=139
         END IF
C
 410  CONTINUE
C
      CALL NEXSEP2(IPT,IEQ,*500)
      CALL NEXPRT2(IPT,IEQ,*500)
C
C
      IF(KCHAR(IPT  ) .EQ. 57.AND.
     &   KCHAR(IPT+1) .EQ. 57.AND.
     &   KCHAR(IPT+2) .EQ. 57.AND.
     &   KCHAR(IPT+3) .EQ. 57.AND.
     &   KCHAR(IPT+4) .EQ. 57.AND.
     &   KCHAR(IPT+5) .LE. 32       )
     &   THEN
C           BEGINING OF THE SECTION 4 FOUND
            GO TO 450
         END IF
C
      IF(KCHAR(IPT ).GE.65.AND.KCHAR(IPT  ).LE.90)
     &   THEN
C           PROBABLY SHIP'S CALL SIGN FOUND
C
            KPT=IPT
            CALL NEXTSEP(KPT,IEQ)
            if(kpt.gt.ieq) kpt=ieq
C
            NC=KPT-IPT
C
            DO 411 I=1,NC
C
            IF(KCHAR(IPT-1+I).GE.65.AND.KCHAR(IPT-1+I).LE.90)
     &         THEN
                  KINT(145-1+I)=KCHAR(IPT-1+I) 
               END IF
C
            IF(KCHAR(IPT-1+I).GE.48.AND.KCHAR(IPT-1+I).LE.57)
     &         THEN
                  KINT(145-1+I)=KCHAR(IPT-1+I) 
               END IF
C
 411        CONTINUE
C
            GO TO 500
C
         END IF
C
      IF(KCHAR(IPT  ).GE.48.AND.KCHAR(IPT  ).LE.57 .AND.
     &   KCHAR(IPT+1).GE.65.AND.KCHAR(IPT+1).LE.90       )
     &   THEN
C           PROBABLY SHIP'S CALL SIGN FOUND
C
            KPT=IPT
            CALL NEXTSEP(KPT,IEQ)
            if(kpt.gt.ieq) kpt=ieq
C
            NC=KPT-IPT
C
            DO 412 I=1,NC
C
            IF(KCHAR(IPT-1+I).GE.65.AND.KCHAR(IPT-1+I).LE.90)
     &         THEN
                  KINT(145-1+I)=KCHAR(IPT-1+I)
               END IF
C
            IF(KCHAR(IPT-1+I).GE.48.AND.KCHAR(IPT-1+I).LE.57)
     &         THEN
                  KINT(145-1+I)=KCHAR(IPT-1+I)
               END IF
C
 412        CONTINUE
C
            GO TO 500
C
         END IF
C
C
      CALL EXTVAL(IPT,1,IVAL)
      IF(IVAL.EQ.1) THEN
            CALL EXTGRP (IPT,1,4,0,0,0,140,IRET)
            IF(IRET.NE.0)
     &         THEN
                  KERR=15
                  CALL ERRSTA(23,1,IFIRST,NUMERR)
                  IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
                  IF(NUMERR.EQ.1) IREMPOS=140
                END IF
C
            GO TO 410

      ELSE
            CALL EXTGRP (IPT,1,2,2,0,0,142,IRET)
            IF(IRET.NE.0)
     &         THEN
                  KERR=16
                  CALL ERRSTA(23,1,IFIRST,NUMERR)
                  IF(IFIRST.NE.0) NOER(23,KERR)=NOER(23,KERR)+1
                  IF(NUMERR.EQ.1) IREMPOS=142
                END IF
C
            GO TO 410
C
      END IF
C-----------------------------------------------------------------------
C*                4.5 SECTION 4 (A1BWNBNBNB)
 450  CONTINUE
C
      CALL NEXSEP2(IPT,IEQ,*500)
      CALL NEXPRT2(IPT,IEQ,*500)
C
      KINT(145)=KCHAR(IPT  )
      KINT(146)=KCHAR(IPT+1)
      KINT(147)=KCHAR(IPT+2)
      KINT(148)=KCHAR(IPT+3)
      KINT(149)=KCHAR(IPT+4)
      NC=5

C-----------------------------------------------------------------------
C*            5. ERROR CHECKING AND HANDLING .
C                -----------------------------
 500  CONTINUE
C
C     RETURN IF NO ERRORS IN REPORT
C
      IF(KERR.EQ.0) RETURN
C
C     IF FIRST DECODING ATTEMPT ,TRY TO CORRECT
C     THE ERROR AND DECODE AGAIN
C
      IF(IFIRST.EQ.0) THEN
                         IPT=KEEP
                         CALL FIXSO
                         IFIRST=1
                         NUMRERR(23)=NUMRERR(23)+1
                         GO TO 101
                      ELSE
                         CALL SAVREP(IHEAD,IERR)
C
C                        CLEAR PARITY BIT AFTER SAVING ERROR FILE
C
                         DO 501 I=KEEP,IGS
                         KCHAR(I)=KCHAR(I).AND.127
 501                     CONTINUE
C
C                        ONLY REPORTS WITH ERROR IN DATE/TIME
C                        OR LAT/LONG ARE NOT PROCESSED ANY FURTHER
C
C                        IF THERE ARE MORE THEN 5 NON-FATAL ERRORS
C                        IN REPORT IT IS ONLY PROCESSED UNTIL THE
C                        FIRST ERROR
C
                         IF(NUMERR.GT.5) THEN
                                            DO 502 I=IREMPOS,8192
                                            KINT(I)=MINDIC
 502                                        CONTINUE
                                         END IF
C
c                         IF(KERR.GT.6) KERR=0
                          if(kerr.gt.6) then
                           kerr = 0
c                          ierr = 0
                         end if
c
                      END IF
C
 503  CONTINUE
C
C     CALL PRTKINT(KINT,1,120,MINDIC)
C
      RETURN
      END
      
      SUBROUTINE BULLSO( IERR )
C
C**** *BULLSO*
C
C
C     PURPOSE.
C     --------
C
C         CONTROLLING ROUTINE FOR DECODING OF INDIVIDUAL
C         REPORTS FROM BULLETINS OF 'BATHY' AND 'TESAC' REPORTS.
C
C         INPUT    : BULLETIN IN CCITT 5 CHARACTER, 1 CHARACTER PER
C                    WORD IN 'KCHAR'.
C
C                    POINTERS TO BEGINNING AND END OF 'STARTING LINE',
C                    'MIMIMJMJ LINE' AND END OF BULLETIN.
C
C                    IERR NOT USED
C
C         OUTPUT   : DECODED REPORTS WRITTEN TO FILE AND ERROR REPORTS
C                    TO ERROR FILE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BULLSO(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PRTBULL(I,J)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
      common /reperr/ numreperr
      common /inil/ inil
C
C     ------------------------------------------------------------------
C*          1.  PRINT INPUT BULLETIN .
C                ---------------------
 100  CONTINUE
C
C      CALL PRTBULL ( 1,IGS)
C
C*          1.1 SET FLAGS AND WORKING POINTERS.
C               -------------------------------
 110  CONTINUE
C
C     WORKING POINTERS
C
      IPT=IMI
C
C     CLEAR FLAG WHICH INDICATES BULLETIN HEADER ALREADY WRITTEN
C     TO ERROR FILE
C
      IHEAD= 0
C
C*          2. SET DATA REPORT TYPE INDICATORS IN DECODED
C              REPORT HEADER AND PART OF REPORT INDICATOR
C
 200  CONTINUE
C
      K= IPT + 10
C
C     CHECK IF VALID MIMI OF 'MIMIMJMJ'.
C
      DO 201 I=IPT,K
C
C     CHECK IF IT IS 'BATHY' REPORT
C
      IF ( KCHAR( I ) .EQ. 74 .AND. KCHAR(I+1) .EQ. 74 .AND.
     &     KCHAR(I+2) .EQ. 88 .AND. KCHAR(I+3) .EQ. 88      )
     &      THEN
               KDEC(4)=  63
               IPT    =  I
               GO TO 220
            END IF
C
C     CHECK IF IT IS 'TESAC' REPORT
C
      IF ( KCHAR( I ) .EQ. 75 .AND. KCHAR(I+1) .EQ. 75 .AND.
     &     KCHAR(I+2) .EQ. 88 .AND. KCHAR(I+3) .EQ. 88      )
     &      THEN
               KDEC(4)=  64
               IPT    =  I
               GO TO 220
            END IF
 201  CONTINUE
C
C*            2.1  INVALID 'MIMI'. WRITE REPORT TO ERROR FILE
C
 210  CONTINUE
C
      KCHAR(IPT)=KCHAR(IPT).OR.128
      IEQ=IPT
      CALL NEXTEQ (IEQ,IGS)
      IF(IEQ.GT.IGS) RETURN
C
C     SEE IF REPORT TOO SHORT
C
      LEN =IEQ-IPT
      IF(LEN.LT.17) GO TO 300
C
      KDEC(4)= 63
      CALL SAVREP(IHEAD,IERR)
c
      numrep(23) = numrep(23) + 1
c
      GO TO 300
C
C
 220  CONTINUE
C
      KDEC(23)=0
C
      IF(KDEC(4) .EQ. 63) KDEC(23)=1
      IF(KDEC(4) .EQ. 64) KDEC(23)=2
C
      K=KDEC(23)
C
      KK=KDEC(23)+22
C
C
C*           2.3 LOCATE END OF REPORT AND INCREMENT COUNT.
C                -----------------------------------------
 230  CONTINUE
C
      IEQ=IPT
      CALL NEXTEQ(IEQ,IGS)
C
      IF(IEQ.GE.IGS) RETURN
C
C     CHECK IF = - SIGN IS MISSING BY TRYING TO FIND THE NEXT
C                  JJXX OR KKXX
C
      CALL NEXTMI(IPT,IEQ,IIPT)
      IF(IIPT.LT.IEQ) IEQ=IIPT
C
      NUMREP(KK)=NUMREP(KK) + 1
C
      IF(K .EQ. 1)THEN
C
C            2.4 DECODE BATHY REPORT.
C                --------------------
 240  CONTINUE
C                   CONVERT TO INTERMEDIATE (INTEGER) FORMAT
C
                    CALL JJXINT(IHEAD,IERR)
C
                    IF(KERR.NE.0) GO TO 300
C
C                   CONVERT INTERMEDIATE (INTEGER) FORMAT TO DECODE FORM
C                   AND WRITE TO FILE
C
                    CALL JJXDEC(IHEAD,IERR)
C
                 END IF
C
      IF(K .EQ. 2)THEN
C
C
C*                2.5  DECODE TESAC REPORT.
C                      --------------------
 250  CONTINUE
C                   CONVERT TO INTERMEDIATE (INTEGER) FORMAT
C
                    CALL KKXINT(IHEAD,IERR)
c
                    isaverr = ierr
C
                    IF(KERR.NE.0) GO TO 300
C
C                   CONVERT INTERMEDIATE (INTEGER) FORMAT TO DECODE FORM
C                   AND WRITE TO FILE
C
                    CALL KKXDEC(IHEAD,IERR)
C
                 END IF
C      ----------------------------------------------------------------
C*            3.   LOCATE START OF NEXT REPORT.
C                  ----------------------------
 300  CONTINUE
c
      if(isaverr.ne.0) numreperr = numreperr + 1
      saverr = 0 
      ierr = 0
      kerr = 0
c
      IPT=IEQ + 1
C
      CALL NEXTPRT(IPT,IGS)
C
C*            3.1  CHECK FOR END OF BULLETIN.
C                  --------------------------
 310  CONTINUE
C
      IF(IPT.GE.IGS)
     &   THEN
C           END OF BULLETIN,SO IF ANY REPORT HAS BEEN WRITTEN TO
C           ERROR FILE,ADD 'GS' CHARACTER BEFORE RETURNING.
C
            IF(IHEAD.EQ.0) RETURN
            IHEAD= 2
            CALL SAVREP(IHEAD,IERR)
C
C
C           CALL PRTBULL(1,IGS)

           RETURN
         END IF
C
C
C*          3.2  RESET REPORTS DATA BASE TYPE AND REPORT TYPE INDICATORS.
C                --------------------------------------------------------
 320  CONTINUE
C
      KDEC(23)= 0
      KDEC( 4)= 0
C
C*           3.3 SEARCH STHE BEGINNING OF NEXT REPORT ANDRT.
C                -------------------------------------------
C                CHANGE THE POINTER IMI.
C                ----------------------  -
 330  CONTINUE
C
C
      NPT=IEQ
      CALL NEXTLET(NPT,IGS)
C
      IF(NPT.GE.IGS) RETURN
C
      IMI=NPT
      CALL NEXTEND(NPT,IGS)
C
      IF(NPT.GE.IGS) RETURN
C
      GO TO 200
C
      END
      
      SUBROUTINE GETNEXT( IERR )
C
C**** *GETNEXT*
C
C
C     PURPOSE.
C     --------
C         GET NEXT MESSAGE FROM MDB.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *GETNEXT( IERR )*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
C
      character*4 cstream
      CHARACTER*15000 YCHAR
      CHARACTER*25 YTIME
      CHARACTER*21 CTSTAMP
      character*78  cstr
c
      data cstr/'                   buoy decoding'/
C
      DATA NSKIP/0/
C     ------------------------------------------------------------------
C*          1.   RESET ERROR INDICATOR, WORD AND BIT POINTERS.
C                ---------------------------------------------
 100  CONTINUE
C
      IERR=0
      NWPT=1
      NBPT=0
      NSUB=0
      ilenby=0
      ychar=' '
c
      if(ostream) then
         call datim(ny,nmonth,nday,iutc,NHOUR,NMINUTE,NSECOND,icc)
         WRITE(YTIME,'(i4.4,5I2.2)',IOSTAT=IOS,ERR=101)
     1       NY,NMONTH,NDAY,NHOUR,NMINUTE,NSECOND
         print*,'ytime=',ytime
         
         WRITE(17,9903,IOSTAT=IOS,ERR=410)
     1         CSTR,CSTREAM,CTSTAMP,YTIME
C
         REWIND(17)
      end if
c
      go to 110
c
 410  continue
c
 101     print*,' Error writing time stamp.'
C
 9903 FORMAT(1h ,A,
     1     //1h ,'stream             ',A,
     1      /1h ,'time stamp         ',a,
     1     //1h ,'last time updated  ',a  )
c
c      call ebexit(2)
C
C
C           1.1  GET NEXT MESSAGE.
C                -----------------
 110  CONTINUE
C
      ostream=.true.
      ILEN=ILENBY
c      print*,'Current time stamp is ',ctstamp(1:20)
C
      READ(CTSTAMP,'(6x,4i2)') NRDAY,NRHOUR,
     1                         NRMIN,NRSEC
C
 115  CONTINUE
C
      NUMBULL=NUMBULL+1 
C
C
C           1.2  PRINT BULLETIN NUMBER.
C                ----------------------
 120  CONTINUE
C
C      WRITE(*,9902) NUMBULL
C
C           1.3  SKIP BULLETIN IF NECESSARY.
C                ---------------------------
 130  CONTINUE
C
      IF(NUMBULL.EQ.NSKIP) GO TO 110
C
C
C           1.4  TRANSFER BULLETIN TO 'KCHAR' ONE CHARACTER PER WORD.
C                ----------------------------------------------------
C                AND SUPPRESS PARITY BIT.
C                ------------------------
 140  CONTINUE
C
      DO 141 I=1,ILEN
C
      KCHAR(I)=ICHAR(YCHAR(I:I)).AND.127
C
 141  CONTINUE
C 
      RETURN
C
C     -----------------------------------------------------------------
c 200  CONTINUE
C
c      IERR=1
c      WRITE(*,9901) IRET
c      RETURN
C     -----------------------------------------------------------------
c 300  CONTINUE
C
c      IERR=1
c      WRITE(*,9905) IOS
c      RETURN
C
c 310  CONTINUE
C
c      IERR=1
c      WRITE(*,9904) IOS
c      RETURN
C     ----------------------------------------------------------------- 
 400  CONTINUE
C
 9902 FORMAT(1H ,' BULLETIN NUMBER = ',I9)
 9904 FORMAT(1H ,' ERROR WRITING STATUS FILE ',I6)
 9905 FORMAT(1H ,' ERROR OPENING STATUS FILE ',I6)
C
      END
      
      SUBROUTINE QCCON( IERR )
C
C**** *QCCON*
C
C
C     PURPOSE.
C     --------
C         MOVE VALUEW ARRAY INTO VALUES ARRAY FOR INPUT TO Q/C.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *QCCON( IERR )*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
C
C     -----------------------------------------------------------------
C*          1. MOVE CONTENT OF VALUEW ARRAY INTO VALUES.
C              -----------------------------------------
 100  CONTINUE
C
      M = MS
C
      DO 101 J=1,JP1
      DO 101 I=1,JP22
      VALUES(I,J)=999999.
      VALUES(I,J)=VALUEW(I,J)
      VALUEW(I,J)=999999.
 101  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE DATUM(IDD,IMM,IYY)
C
C**** *DATUM*
C
C
C     PURPOSE.
C     --------
C         DEFINE PROPER MONTH AND YEAR IF DAY IS DEFINED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DATUM(IDD,IMM,IYY)*
C
C                       IDD - DAY
C                       IMM - MONTH
C                       IYY - YEAR
C
C     METHOD.
C     -------
C
C          IF IDD IS GREATER THAN CURRENT DAY DAY IS CONSIDERED TO BE FROM
C          PREVIOUS MONTH.IF CURRENT MONTH IS JANUARY
C          YEAR BECOMS PREVIOUS ONE.
C          IF IDD IS LESS OR EQUALL THAN CURRENT DAY IT IS FROM CURRENT MONTH
C          AND YEAR.
C
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *datim(YDATE)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER*3 YMONTH(12)
      integer iyear,imonth,iday,iutc,ihour,imin,isec,imili
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C
C     ------------------------------------------------------------------
C
C*          1.   GET DATE FROM THE SYSTEM.
C                -------------------------
 100  CONTINUE
C
      CALL datim(iyear,imonth,iday,iutc,ihour,imin,isec,imili)
C
C
C*          1.1  DEFINE MONTH AND YEAR
C                ---------------------
 110  CONTINUE
C
      IF(IDAY.GE.IDD) THEN
         IMM=IMONTH
         IYY=IYEAR
         ima=imonth
         RETURN
      END IF
C
      IF(IDAY.LT.IDD) THEN
         IF(IMONTH.EQ.1) THEN
            IMM=12
            IYY=IYEAR-1
            RETURN
         END IF
         IMM=IMONTH-1
         IYY=IYEAR
      END IF
C
      RETURN
      END
C
      SUBROUTINE datim(date_time)
C
C     This subroutine returns a interger array (8)
C       where:  value1 = 4-digit year
c		value2 = month of the year
c		value3 = day of the year
c		value4 = time difference to UTC in minutes.
c		value5 = hour of the day ( range 0 to 23)
c		value6 = minutes of the hour ( range 0 to 59)
c		value7 = seconds of the range ( range 0 to 59)
c		value8 = miliseconds of the second ( range 0 to 999)		
C     
      integer date_time (8)
      character*12  real_clock(3)
      CHARACTER*3 YMONTH(12)      
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C----------------------------------------------------------------
C    Caso seja fornecido um argumento sera usado caso contrario
C    pegara a data do sistema
C----------------------------------------------------------------
               integer k,iargc
               CHARACTER*12 arg
               external getarg,iargc
               k=iargc()
               call getarg(k , arg)
               
      if (k .lt. 2 )   then      
               
 	CALL date_and_time(real_clock(1),real_clock(2),real_clock(3),
     c   date_time)
      else
             PRINT*,'Passando a data'
             write(date_time(1),'(A)')arg(1:4)
             write(date_time(2),'(A)')arg(5:6)
             write(date_time(2),'(A)')arg(7:8)
             date_time(4) = 0
             write(date_time(2),'(A)')arg(9:10)
             write(date_time(2),'(A)')arg(11:12) 
             date_time(7) = 0
             date_time(8) = 0
      end if
c      print*,date_time
C----------------------------------------------------------------
      RETURN
      END

